// EventDisasm.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "EventDisasm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

#define HEXSCRIPT_FN	_T("EventScriptHex.txt")
#define TXTSCRIPT_FN	_T("EventScriptTxt.txt")
#define NPC_DATA_FN		_T("NPCDataTxt.txt")
#define TRIGGER_DATA_FN	_T("EventTriggerTxt.txt")
#define CHEST_DATA_FN   _T("ChestDataTxt.txt")
#define LOCATION_FN		_T("LocationDataTxt.txt")
#define MAP_EVENT_FN    _T("MapEventPointer.txt")
#define XKAS_OUTPUT_FN  _T("XkasEventScript.txt")
#define XKAS_EVENT_PTR  _T("XkasEventPointer.txt")

#define SCRIPT_START		0x0A0200
#define SCRIPT_END			0x0DFFFF //0x0CE5EE
#define NPC_POINTERS		0x041C10
#define TRIGGER_POINTERS	0x040200
#define CHEST_POINTERS		0x2D84F4
#define CHEST_START			0x2D8834
#define LOCATION_START		0x2D9100
#define MAP_EVENT_POINTERS  0x11FC00

CWinApp theApp;
CTypedPtrArray<CPtrArray, DialogueItem*> dialogue;
Item items[512];
Esper espers[27];
Character characters[64];

CString g_strColorComponents[] =
{
	"Black","Black",
	"Red","Red",
	"Green","Green",
	"Yellow [Red + Green]","Yellow [Red + Green]",
	"Blue","Blue",
	"Magenta [Red + Blue]","Magenta [Red + Blue]",
	"Cyan [Green + Blue]","Cyan [Green + Blue]",
	"White [Red + Green + Blue]","White [Red + Green + Blue]",
};

CString g_strStatusNames[] = 
{
	"Dark","Zombie",
	"Poison","M-Tek", 
	"Vanish (Clear)","Imp",
	"Petrify (Stone)","Death (Wound)",
	"Rage","Frozen",
	"Instant Death Protection","Morph (Esper-form)", 
	"Chant (Casting Spell)","Hide",
	"Dog Block","Float",
};

CString g_strSongNames[] =
{
	"Silence",
	"Prelude",
	"Opening Theme #1",
	"Opening Theme #2",
	"Opening Theme #3",
	"Awakening",
	"Terra",
	"Shadow",
	"Strago",
	"Gau",
	"Edgar and Sabin",
	"Coin Song",
	"Cyan",
	"Locke",
	"Forever Rachel",
	"Relm",
	"Setzer",
	"Epitaph",
	"Celes",
	"Techno de Chocobo",
	"The Decisive Battle",
	"Johnny C. Bad",
	"Kefka",
	"The Mines of Narshe",
	"Cave Theme",
	"Wild West",
	"Save Them!",
	"The Empire Gestahl",
	"Troops March On",
	"Under Martial Law",
	"Waterfall",
	"Metamorphosis",
	"The Phantom Train #1",
	"Another World of Beasts",
	"Grand Finale #2",
	"Mt. Koltz",
	"Battle Theme",
	"Fanfare, slow",
	"The Wedding Waltz #1",
	"Aria de Mezzo Caraterre",
	"The Serpent Trench",
	"Slam Shuffle",
	"Kids Run Through the City Corner",
	"???, Crazy Old Man's House",
	"Grand Finale #1",
	"Gogo",
	"Returners",
	"Battle Fanfare",
	"Umaro",
	"Mog",
	"The Unforgiven",
	"The Fierce Battle",
	"The Day After",
	"Blackjack",
	"Catastrophe",
	"The Magic House",
	"Nighty Night",
	"Wind",
	"Windy Shores",
	"Dancing Mad #1",
	"The Raft and the Flowing River",
	"Spinach Rag",
	"Rest in Peace",
	"Train Running",
	"The Dream of a Train",
	"Overture #1",
	"Overture #2",
	"Overture #3",
	"The Wedding Waltz #2",
	"The Wedding Waltz #3",
	"The Wedding Waltz #4",
	"Devil's Lab",
	"Fire!",
	"Machine Running",
	"Inside the Burning House",
	"New Continent",
	"Searching for Friends",
	"Fanatics",
	"Last Dungeon",
	"Dark World",
	"Dancing Mad #4.2",
	"Silence",
	"<unknown>",
	"Ending Theme #1",
	"Ending Theme #2",
	
};

CString g_strBackgroundNames[] =
{
	"Grass",
	"Brown Forest",
	"Desert",
	"Green Forest",
	"Building",
	"World of Ruin",
	"The Veldt",
	"Falling through the Clouds",
	"Dark Town",
	"Grey Cave",
	"Brown Cave",
	"Mountain Top",
	"Mountain Cave",
	"Raft on a River",
	"Imperial Base",
	"On Top of Train Car",
	"Inside of Train Car",
	"Blue/Purple Cave",
	"Icy Field",
	"Bright Town",
	"Factory",
	"Floating Island",
	"Kefka's Domain",
	"Opera Stage",
	"Opera House Rafters",
	"Flaming House",
	"Castle",
	"Magitek Research Facility w/ Tubes",
	"Colloseum",
	"Magitek Research Facility",
	"Village",
	"Waterfall",
	"Owzer's House",
	"Running on Train Tracks",
	"Bridge near Sealed Gate",
	"Underwater",
	"Zozo",
	"Airship, World of Balance, centered",
	"Tomb",
	"Doma",
	"Kefka's Domain",
	"Airship, World of Ruin, right",
	"Red Cave",
	"Light Building",
	"Riding Car out of Magitek Research Facility",
	"Fanatics' Tower",
	"Cyan's Dream World",
	"Desert",
	"Airship, World of Balance, right",
	"--",
	"--",
	"Statue 1",
	"Statue 2",
	"Statue 3",
	"Kefka's Background",
	"Tentacles",
	"--",
	"--",
	"--",
	"--",
	"--",
	"--",
	"--",
	"Default for this area",
};


CString g_strLocationNames[] =
{
	"World of Balance",
	"World of Ruin",
	"Serpent Trench",
	"Darkness (briefly on many occasions, inc. Tent use on the world map)",
	"Darkness (Shadow's first dream)",
	"Darkness (Mog explains 3-party battles / various narration)",
	"Blackjack, upper deck (general use / \"The world is groaning in pain\")",
	"Blackjack, below decks, all rooms except Celes' prison",
	"Blackjack, room where Setzer imprisons Celes",
	"Darkness (\"Choose a scenario\" / \"The three have reached Narshe\")",
	"Blackjack, upper deck (IAF sequence / various cutscenes)",
	"Falcon, upper deck (general use / with Daryl / buried / homing pigeon)",
	"Falcon, below decks",
	"Blackjack, upper deck, breaking apart (end of the WoB)",
	"Hidden chocobo stables, outdoors (WoB)",
	"Hidden chocobo stables, indoors (always)",
	"Hidden chocobo stables, outdoors (WoR)",
	"Falcon, upper deck (leaving the Tomb / \"We're going in!\" / Bahamut / ending)",
	"Narshe, mountaintop (Terra / Vicks / Wedge in Magitek armor)",
	"Narshe, lower town (Magitek attack / guards seek Terra / party files out)",
	"Narshe, lower town (WoB)",
	"Narshe, upper town (WoB)",
	"Narshe, hills maze (WoB)",
	"Narshe, mountaintop (WoB / \"Long ago, the War of the Magi...\")",
	"Narshe, weapon shop, including back room (always)",
	"Narshe, armor shop (always)",
	"Narshe, item shop (always)",
	"Narshe, relic shop (always)",
	"Narshe, inn (always)",
	"--",
	"Narshe, all non-shop buildings except classroom (always)",
	"--",
	"Narshe, lower town (WoR)",
	"Narshe, upper town (WoR)",
	"Narshe, hills maze (WoR)",
	"Narshe, mountaintop (WoR)",
	"Narshe, caves, secret entrance and all caves in upper town (WoR)",
	"Narshe, moogle 3-party battle area (WoR)",
	"Narshe, caves, before checkpoint / checkpoint / behind Arvis' house (WoR)",
	"Narshe, upper town (Magitek attack)",
	"--",
	"Narshe, Whelk cave (Magitek attack), secret entrance / north caves (WoB)",
	"Narshe, Tritoch's cave (Magitek attack)",
	"Narshe, Whelk's empty cave / Tritoch's empty cave (WoB)",
	"Narshe, moogle cave (WoR)",
	"--",
	"--",
	"South Figaro, outdoors (party being smuggled out of occupied town)",
	"Narshe, cave south of the security checkpoint (WoB)",
	"Narshe, security checkpoint cave (WoB)",
	"Narshe, cave behind Arvis' house (WoB)",
	"Narshe, moogle 3-party battle area (WoB)",
	"Narshe, moogle cave (WoB)",
	"Cave to South Figaro, second cave beyond the turtle (WoR only)",
	"Figaro Castle, outdoors, \"Figaro submerge mode engaged!\"",
	"Figaro Castle, outdoors (both worlds and ending)",
	"Empty desert (fleeing on chocobos / Imperials en route to Narshe)",
	"Figaro Castle, west tower (Edgar's room) (always)",
	"Figaro Castle, throne room (always)",
	"Figaro Castle, miscellaneous rooms (always)",
	"Figaro Castle, library (always)",
	"Figaro Castle, switch room and prison (always)",
	"Figaro Castle, upper sub-basement",
	"Figaro Castle, lower sub-basement",
	"Figaro Castle, engine room",
	"Figaro Castle, treasury",
	"Figaro Castle, NW treasure room in basement",
	"Figaro Castle, outdoors, night, with sky (coin toss in flashback)",
	"Cave to South Figaro, main cave / short tunnel / east entrance (WoR)",
	"Cave to South Figaro, main cave / short tunnel / east exit (WoB post-Celes)",
	"Cave to South Figaro, recovery spring / up NW stairs (WoB post-Celes)",
	"Cave to South Figaro, outside west entrance (WoB only)",
	"Cave to South Figaro, main cave / short tunnel / east exit (WoB pre-Celes)",
	"Cave to South Figaro, recovery spring / up NW stairs (WoB, pre-Celes)",
	"South Figaro, outdoors (WoR)",
	"South Figaro, outdoors (WoB)",
	"South Figaro, inn and relic shop (always)",
	"South Figaro, arsenal (always)",
	"South Figaro, cafe and cafe basement (always)",
	"--",
	"South Figaro, chocobo stable (always)",
	"South Figaro, rich house, all non-hidden rooms (always)",
	"--",
	"South Figaro, below rich house, stairwell / hallway / Celes' cell (always)",
	"South Figaro, clock room and Duncan's basement (always)",
	"South Figaro, item shop (always)",
	"South Figaro, Duncan's house / old man's house / tunnel ends (always)",
	"South Figaro, escape tunnel (always)",
	"South Figaro, save point near Celes' cell (always)",
	"South Figaro, hidden \"castle-like\" sub-basements (always)",
	"Cave to South Figaro, turtle pond / up NW stairs (WoR)",
	"South Figaro, docks (always)",
	"Cave to South Figaro, first cave beyond the turtle (WoR only)",
	"Sabin's house, outdoors",
	"Sabin's house, indoors",
	"Mt. Kolts, south entrance",
	"Mt. Kolts, lower cliffs, without clouds",
	"Mt. Kolts, lower cliffs, with clouds",
	"Mt. Kolts, cliff path down to Vargas",
	"--",
	"Mt. Kolts, all caves except save point (inc. Locke & Rachel flashback)",
	"Mt. Kolts, north entrance",
	"Mt. Kolts, upper cliffs",
	"Mt. Kolts, save point cave",
	"Narshe, Beginner's House main room (always)",
	"Narshe, Beginner's House west classroom (always)",
	"Narshe, Beginner's House middle classroom (always)",
	"Narshe, Beginner's House east classroom (always)",
	"Returners' Hideout, entrance",
	"Returners' Hideout, main cave",
	"Returners' Hideout, save point / bedroom / storeroom",
	"Returners' Hideout, inn",
	"Returners' Hideout, tunnel to Lete River",
	"Lete River, outdoors",
	"Lete River, river caves",
	"Gau's father's house, outdoors (WoB)",
	"Gau's father's house, indoors (always)",
	"Imperial Camp (before Doma is poisoned)",
	"--",
	"Imperial Camp (after Doma is poisoned)",
	"Doma Castle, outdoors (during Imperial siege)",
	"Doma Castle, outdoors (being poisoned)",
	"--",
	"Doma Castle, all rooms except Cyan's (always)",
	"Doma Castle, Cyan's room (always)",
	"Cyan's Dream, Doma Castle outdoors",
	"Cyan's Dream, Doma Castle all rooms",
	"Duncan's hidden house, outdoors",
	"Duncan's hidden house, indoors",
	"Mountaintop overlook with birds (ending)",
	"Forest pond with birds (ending)",
	"Gau's father's house, outdoors (WoR)",
	"Phantom Forest, first area",
	"Phantom Forest, recovery spring area",
	"Phantom Forest, crossroads area",
	"Phantom Forest, leading to train platform (before Phantom Train only)",
	"Waterfall cliff bridge with birds (ending)",
	"Arrival platform for Phantom Train (train is gone, Cyan is sad)",
	"Arrival platform for Phantom Train (train pulls into station)",
	"Arrival platform for Phantom Train (ghosts board, train leaves)",
	"Departure platform for Phantom Train (train waits for our heros)",
	"Phantom Train, exterior (after detaching rear cars)",
	"Phantom Train, exterior (before detaching rear cars)",
	"Cyan's Dream, Phantom Train exterior",
	"Cyan's Dream, Phantom Train first dining car",
	"Phantom Train, first 3 seating cars",
	"Phantom Train, caboose inner room and engine room (inc. Cyan's Dream)",
	"Phantom Train, dining car",
	"Mobliz, outdoors, Light of Judgement attack (Terra's flashback in WoR)",
	"Phantom Train, seating car with detachment switch",
	"Mobliz, cave under soldier's house (only after first Phunbaba fights)",
	"Phantom Train, hallways outside suites",
	"Phantom Train, caboose hallway",
	"Phantom Train, suite rooms and save point car (inc. Cyan's Dream)",
	"Mobliz, children's cave under mailman's house (WoR only)",
	"Baren Falls, cave passageway",
	"Baren Falls, waterfall overlook (including ending)",
	"Mobliz, outdoors (WoB)",
	"Mobliz, outdoors (WoR)",
	"Calm riverbank (Cyan and Sabin wash up, Gau freaks out)",
	"Mobliz, inn (WoB only)",
	"Mobliz, arsenal (WoB only)",
	"Mobliz, relic shop (always)",
	"Mobliz, mailman's house, upstairs only (always)",
	"Mobliz, item shop (WoB only)",
	"Mobliz, soldier's house / mailman's basement (always)",
	"Baren Falls, entrance",
	"Crescent Mountain, caves",
	"Crescent Mountain, Serpent Trench overlook",
	"Nikeah, outdoors (always)",
	"Calm riverbank, dark (Shadow's third dream)",
	"Nikeah, inn (always)",
	"Nikeah, cafe (always)",
	"Nikeah, chocobo stable (always)",
	"Phantom Forest, leading to train platform, dark (Shadow's second dream)",
	"Serpent Trench, caves",
	"Mt. Zozo, cliffside bridge",
	"Mt. Zozo, small cliffside area",
	"Mt. Zozo, cliffside before Cyan's cave",
	"Mt. Zozo, all caves except Cyan's",
	"Mt. Zozo, Cyan's cave",
	"Mt. Zozo, Cyan's cliff overlook",
	"Thamasa, outdoors (Shadow's 4th dream / ending w/o Relm / Shadow / Strago)",
	"Mobliz, children's cave (ending)",
	"Mobliz, outdoors (ending)",
	"House at Dragon's Neck, outdoors",
	"House at Dragon's Neck, indoors",
	"Nikeah, docks / cargo ship at sea (always)",
	"Kohlingen, outdoors (WoB, including Locke's flashback)",
	"Kohlingen, outdoors (WoR / ending)",
	"Whitewater river with birds (ending)",
	"Kohlingen, inn (always)",
	"--",
	"--",
	"Kohlingen, general store (always)",
	"Kohlingen, crazy man's house, both floors (always)",
	"Maranda, Lola's house (always)",
	"Kohlingen, Rachel's house (always)",
	"Jidoor, outdoors (both worlds)",
	"--",
	"Jidoor, auction house (always)",
	"Jidoor, item shop (always)",
	"Jidoor, relic shop (always)",
	"Jidoor, armor shop (always)",
	"Jidoor, weapon shop (always)",
	"Jidoor, chocobo stable (always)",
	"Jidoor, inn (always)",
	"Owzer's house, darkened basement rooms",
	"Owzer's house, Chadarnook's room",
	"Owzer's house, upper floor (always)",
	"Doma Castle, dark (ending without Cyan)",
	"Narshe, mountaintop, dark (ending without Mog / without Umaro)",
	"Gogo's Lair, bridges, dark (ending without Gogo)",
	"Crescent Mountain, caves, dark (ending without Gau)",
	"Setzer and Darill's cliff (Setzer's flashback)",
	"Falcon in sky with birds (ending)",
	"Esper World, looking out through the gate (Gestahl takes Terra)",
	"Esper World, outdoors (Terra's flashback / Ramuh's flashback)",
	"Esper World, cave to the exit (Terra's flashback)",
	"Esper World, caves (Terra's flashback)",
	"--",
	"Zozo, outdoors (always)",
	"--",
	"--",
	"--",
	"Zozo, all rooms except tower top (always)",
	"Zozo, room at tower top (always)",
	"--",
	"--",
	"--",
	"--",
	"Opera House, theater (opera fight scene / WoR)",
	"Opera House, backstage & catwalk door, enabled (WoB post-Ultros / WoR)",
	"Opera House, theater (opera dance scene / party onstage with Celes)",
	"Opera House, theater (overture to the opera)",
	"Opera House, catwalks over stage (always)",
	"Opera House, \"Maria's castle\" set",
	"Opera House, lobby (always)",
	"Opera House, disabled backstage & catwalk door / dressing room",
	"Opera House, theater, going dark (flip middle switch in switch room)",
	"Vector, outdoors (during escape from Magitek factory)",
	"Imperial Castle, outdoors, rooftop (cranes rising in the distance)",
	"Vector, outdoors, intact (before the Esper attack)",
	"Imperial Castle, outdoors, lower level",
	"Imperial Castle, outdoors, rooftop (including prologue and flashbacks)",
	"Vector, inn",
	"Vector, weapon shop",
	"Vector, cafe",
	"Vector, armor shop",
	"Vector, tiny house",
	"Imperial Castle, most rooms (including Terra's flashback)",
	"Imperial Castle, banquet hall",
	"Imperial Castle, western barracks",
	"Vector, outdoors, trashed (after the Esper attack)",
	"Ending - Cyan's / Mog's / Gogo's scenes",
	"Ending - Setzer's scene",
	"Ending - Umaro's scene",
	"--",
	"Ending - Edgar and Sabin's scene (with or without Sabin)",
	"Ending - Falcon flies out of Kefka's tower",
	"Ending - Locke and Celes' scene (with or without Locke)",
	"Ending - Gau's / Shadow's / Strago's scenes",
	"Magitek Factory, first area (first visit / after subway ride)",
	"Magitek Factory, second area (only before subway ride)",
	"Magitek Factory, garbage dump",
	"--",
	"Magitek Research Facility, descending elevator (with Cid)",
	"--",
	"Ending - Terra's scene",
	"Magitek Factory, stairwell to Magitek Research Facility",
	"Magitek Factory, save point next to garbage dump",
	"Magitek Research Facility, hallway with empty tubes",
	"Magitek Research Facility, subway station",
	"Magitek Research Facility, Number 024's room",
	"Magitek Research Facility, Esper extraction room",
	"--",
	"Gogo's Lair, entrance / guarded bridges / below bridges",
	"Gogo's Lair, short passage past moving ceiling",
	"Gogo's Lair, Gogo's room",
	"Gogo's Lair, save point",
	"Gogo's Lair, moving ceiling room / chest jumping room",
	"Umaro's Cave, first cave and bridges cave",
	"Umaro's Cave, cave north of first cave",
	"Umaro's Cave, Umaro's lair",
	"Maranda, outdoors (always)",
	"Doma Castle, outdoors (WoB, after the poisoning / WoR)",
	"--",
	"--",
	"Maranda, inn (always)",
	"Maranda, weapon shop (always)",
	"Maranda, armor shop (always)",
	"Kefka's Tower, Guardian's room",
	"Kefka's Tower, switched platform factory area",
	"Kefka's Tower, third group third and fourth nondescript cave tunnels",
	"Kefka's Tower, second group nondescript cave tunnel",
	"Kefka's Tower, first group second cave",
	"Kefka's Tower, catwalk in Inferno's room",
	"Darill's Tomb, outside entrance",
	"Darill's Tomb, first room",
	"Darill's Tomb, most upstairs rooms / Darill's grave",
	"Darill's Tomb, rooms with visible switches / downstairs rooms",
	"Darill's Tomb, long staircase to the Falcon",
	"Thamasa, outdoors (ending)",
	"Kefka's Tower, first party first cave",
	"Kefka's Tower, Fixed Dice room",
	"Tzen, outdoors (WoR)",
	"Tzen, outdoors (WoB)",
	"Tzen, item shop (always)",
	"Tzen, inn (always)",
	"Tzen, weapon shop (always)",
	"Tzen, armor shop (always)",
	"Tzen, collapsing house (both floors)",
	"Tzen, relic shop (always)",
	"Phoenix Cave, downstairs",
	"--",
	"Phoenix Cave, upstairs",
	"--",
	"Cyan's Dream, psychedelic stairs",
	"Phoenix Cave, outside entrance",
	"Cyan's Dream, cliffside",
	"Cyan's Dream, caves",
	"Cyan's Dream, Phantom Train second dining car",
	"Cyan's Dream, Phantom Train first seating car",
	"Albrook, outdoors (WoB, including shadowed by Floating Island)",
	"Albrook, outdoors (WoR)",
	"Albrook, inn (always)",
	"Albrook, weapon shop (always)",
	"Albrook, armor shop (always)",
	"Albrook, item shop (always)",
	"Kefka's Tower, second group metal area (door in mid-air)",
	"Albrook, cafe / relic shop (always)",
	"Kefka's Tower, prison",
	"Albrook, docks / Magitek ship at sea (always)",
	"--",
	"Kefka's Tower, exterior",
	"Kefka's Tower, Gold Drgn's room",
	"Kefka's Tower, Kefka's lair, red background",
	"Kefka's Tower, switches and weights room",
	"Kefka's Tower, second group first cave",
	"Kefka's Tower, third group, first and second nondescript cave tunnels",
	"Thamasa, outdoors (WoB, after Leo dies / WoR, Relm and Gungho talk)",
	"Thamasa, outdoors (WoB, during Esper visit and Kefka scenes)",
	"--",
	"Thamasa, outdoors (WoB pre-Espers / Shadow's last dream / \"That evening\")",
	"Thamasa, outdoors (WoR)",
	"Thamasa, arsenal (always)",
	"Thamasa, inn (always)",
	"Thamasa, item shop (always)",
	"Thamasa, elder's house (always)",
	"Thamasa, both floors of Strago's house (always)",
	"Thamasa, relic shop (always)",
	"Thamasa, inside the burning house",
	"Kefka's Tower, Magitek Research room",
	"Cave in the Veldt",
	"Kefka's Tower, Skull Drgn / Goddess / hallways before weights room",
	"Kefka's Tower, decision point and Doom's room",
	"Kefka's Tower, Kefka's lair, blue background",
	"Kefka's Tower, Kefka's lair, black background",
	"Floating Island, save point cave",
	"Fanatics' Tower, second set of stairs",
	"Fanatics' Tower, third set of stairs",
	"Fanatics' Tower, fourth set of stairs",
	"Fanatics' Tower, ground level",
	"Fanatics' Tower, first set of stairs",
	"Fanatics' Tower, top of tower, outdoors",
	"Fanatics' Tower, room on 7th floor",
	"Fanatics' Tower, room at top of tower",
	"Fanatics' Tower, room on 16th floor",
	"Fanatics' Tower, room on 25th floor",
	"Fanatics' Tower, room on 34th floor",
	"Fanatics' Tower, hidden room on 6th floor",
	"Espers' Gathering Place, cave with statues",
	"Espers' Gathering Place, cliffside without overlook",
	"Espers' Gathering Place, cliffside overlooking waterfall",
	"Espers' Gathering Place, cliffside overlooking mountains",
	"Espers' Gathering Place, most caves",
	"Floating Island, outdoors, without background clouds (end of the WoB)",
	"Imperial Base near Sealed Gate, outdoors",
	"Imperial Base near Sealed Gate, indoors",
	"--",
	"--",
	"Mountain cliffs, collapsing (end of the WoB)",
	"Cave to the Sealed Gate, first cave",
	"Cave to the Sealed Gate, second cave",
	"Cave to the Sealed Gate, big lava cave / treasure cave / cave before gate",
	"Cave to the Sealed Gate, lava cave with moving bridges",
	"Cave to the Sealed Gate, save point cave",
	"--",
	"--",
	"Town-like, ground splits open (end of the WoB)",
	"Forested cliffs, rise and fall and split (end of the WoB)",
	"Cave to the Sealed Gate, sealed gate room",
	"Jidoor, outdoors (people watch as the Floating Island passes overhead)",
	"Floating Island, outdoors, dark background (collapsing)",
	"Floating Island, outdoors, with background clouds (normal)",
	"Town-like, ground splits open (rise of the Floating Island)",
	"Solitary Island, outside house",
	"Solitary Island, inside house",
	"Solitary Island, beach with fish",
	"Solitary Island, north cliffs",
	"Solitary Island, beach w/o fish (Celes fails suicide / Celes rafts away)",
	"Cave to Ancient Castle, all caves except save point",
	"Cave to Ancient Castle, save point",
	"--",
	"Ebot's Rock, misc caves",
	"Ebot's Rock, entrance / hungry chest and Hidon / save point",
	"Ancient Castle, all rooms except library and basement",
	"Ancient Castle, exterior",
	"Ancient Castle, library / basement",
	"Kefka's Tower, second group pipes area",
	"Kefka's Tower, third group factory areas (inc. ending - Relm's scene)",
	"Kefka's Tower, teleporters to Kefka",
	"Kefka's Tower, room behind Poltergeist",
	"Colosseum, all rooms",
	"--",
	"--",
};

void realMain(int iTextMode, CString iFf6Fn);
void readDialogue(CFile* m_pFile, int pointer_loc, int num_pointers);
void readDialogue2(CFile *m_pFile);
void npcParser(CString iFf6Fn);
void triggerParser(CString iFf6Fn);
void chestParser(CString iFf6Fn);
void locationParser(CString iFf6Fn);
void mapEventParser(CString iFf6Fn);
void xkasEventPointers(CString iFf6Fn);
//int repointerer(CString iFf6Fn, DWORD ps, DWORD ds, WORD f, BYTE t, WORD dm, WORD pm);
int serialise_script(CString iScriptFn, CString iFf6Fn);
BYTE ascii2nibble(BYTE iAsciiChar);

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		BOOL lDoTextDecode = FALSE;
		BOOL lDoHexDecode = FALSE;
		BOOL lDoHexEncode = FALSE;
		BOOL lDoNPCDecode = FALSE;
		BOOL lDoTriggerDecode = FALSE;
		BOOL lDoChestDecode = FALSE;
		BOOL lDoLocationDecode = FALSE;
		BOOL lDoMapEventPointer = FALSE;
//		BOOL lDoRepointer = FALSE;
//		BOOL lDoGetRepointerHelp = FALSE;
		BOOL lDoGetHelp = FALSE;
		BOOL lDoXkasOutput = FALSE;
		BOOL lDoXkasPointer = FALSE;
		CString lTmpStr;
		CString lRomFn, lScriptFn;
/*
		WORD first = 0x00;
		BYTE terminal = 0x00;
		DWORD data_max = 0xFFFF;
		DWORD data_start = 0x0000;
		DWORD ptr_max = 0xFFFF;
		DWORD ptr_start = 0x0000;
		DWORD temp = 0x0000;
		
		// These will be used for the Repointer function, if it is used
		if(strcmp(argv[1], _T("repointer")))
		{
				ptr_start = 0;
				temp = 0;
				{
					for(unsigned int s=strlen(argv[3])-1; s>=0; s--)
					{
						
						temp = ascii2nibble(argv[3][s]);
						if(isxdigit(argv[3][s]))
						{
							ptr_start += (temp<<(4*s));
						}
						else
							return -1;
					}
				}
				DWORD data_start = 0;
				{
					for(unsigned int t=strlen(argv[4])-1; t>=0;t--)
					{
						
						temp = ascii2nibble(argv[4][t]);
						if(isxdigit(argv[4][t]))
						{
							data_start += (temp<<(4*t));
						}
						else
							return -1;
					}
				}

		}
*/		//
		printf(_T("EventDisasm Version 3.1\n\n"));
		printf(_T("Original findings & code by Yousei, Jan. 2000\n"));
		printf(_T("Modified by Lord J, March 2005\n"));
		printf(_T("More findings and modifications added by Imzogelmo, June 2005-March 2009\n\n"));

		if(argc<3)
			lDoGetHelp = TRUE;
		else
		{
			if(!strcmp(argv[1], _T("/dt")) || !strcmp(argv[1], _T("-dt")) )
				lDoTextDecode = TRUE;
			else if(!strcmp(argv[1], _T("/dh")) || !strcmp(argv[1], _T("-dh")) )
				lDoHexDecode = TRUE;
			else if(!strcmp(argv[1], _T("/eh")) || !strcmp(argv[1], _T("-eh")) )
				lDoHexEncode = TRUE;
			else if(!strcmp(argv[1], _T("/dn")) || !strcmp(argv[1], _T("-dn")) )
				lDoNPCDecode = TRUE;
			else if(!strcmp(argv[1], _T("/dg")) || !strcmp(argv[1], _T("-dg")) )
				lDoTriggerDecode = TRUE;
			else if(!strcmp(argv[1], _T("/dc")) || !strcmp(argv[1], _T("-dc")) )
				lDoChestDecode = TRUE;
			else if(!strcmp(argv[1], _T("/dl")) || !strcmp(argv[1], _T("-dl")) )
				lDoLocationDecode = TRUE;
			else if(!strcmp(argv[1], _T("/mp")) || !strcmp(argv[1], _T("-mp")) )
				lDoMapEventPointer = TRUE;
//			else if(!strcmp(argv[1], _T("repointer")) || !strcmp(argv[1], _T("Repointer")) )
//				lDoRepointer = TRUE;
			else if(!strcmp(argv[1], _T("/xo")) || !strcmp(argv[1], _T("-xo")) )
				lDoXkasOutput = TRUE;
			else if(!strcmp(argv[1], _T("/xp")) || !strcmp(argv[1], _T("-xp")) )
				lDoXkasPointer = TRUE;
			else
				lDoGetHelp = TRUE;
     			
			lRomFn = argv[2];

			if(lDoHexEncode && (argc<4))
				lDoGetHelp = TRUE;
			else if(lDoHexEncode)
				lScriptFn = argv[3];
		}

		if(lDoGetHelp)
		{
			printf(_T("Usage\n"));
			printf(_T("EventDisasm /dt <FF3us/FF6 image> : decode game script in text mode\n"));
			printf(_T("EventDisasm /dh <FF3us/FF6 image> : decode game script in hex mode\n"));
			printf(_T("EventDisasm /eh <FF3us/FF6 image> <hex script> : encode game script in hex mode\n"));
			printf(_T("EventDisasm /dn <FF3us/FF6 image> : decode NPC data\n"));
			printf(_T("EventDisasm /dg <FF3us/FF6 image> : decode event triggers\n"));
			printf(_T("EventDisasm /dc <FF3us/FF6 image> : decode treasure chest data\n"));
			/*
			printf(_T("EventDisasm /dl <FF3us/FF6 image> : decode location data\n"));
			*/
			printf(_T("EventDisasm /mp <FF3us/FF6 image> : dump map event pointers\n"));
			printf(_T("EventDisasm /xo <FF3us/FF6 image> : dump xkas assembly file\n"));
			printf(_T("EventDisasm /xp <FF3us/FF6 image> : dump xkas event pointer file\n"));
			printf(_T("EventDisasm /? : this help message\n"));

		}
		else
		{
			if(lDoTextDecode)
			{
				printf(_T("Exporting %s's script to text file...\n"), lRomFn);
			}
			else if(lDoHexDecode)
			{
				printf(_T("Exporting %s's script to hex file...\n"), lRomFn);
			}
			else if (lDoNPCDecode)
			{
				printf(_T("Exporting %s's NPC data to text file...\n"), lRomFn);
			}
			else if (lDoTriggerDecode)
			{
				printf(_T("Exporting %s's event trigger data to text file...\n"), lRomFn);
			}
			else if (lDoChestDecode)
			{
				printf(_T("Exporting %s's treasure chest data to text file...\n"), lRomFn);
			}
			else if (lDoLocationDecode)
			{
				printf(_T("Exporting %s's location data to text file...\n"), lRomFn);
			}
			else if (lDoMapEventPointer)
			{
				printf(_T("Exporting %s's map event pointers to text file...\n"), lRomFn);
			}
/*			else if (lDoRepointer)
			{
				printf(_T("Reading %s's data and writing new pointers to the ROM...\n"), lRomFn);
			}
*/			else if(lDoHexEncode)
			{
				printf(_T("Merging %s hex script with %s...\n"), lScriptFn, lRomFn);
			}
			else if(lDoXkasOutput)
			{
				printf(_T("Exporting %s's bytes to xkas assembly file...\n"), lRomFn);
			}
			else // if(lDoXkasPointer)
			{
				printf(_T("Exporting %s's event pointers to xkas format...\n"), lRomFn);
			}

			if(lDoTextDecode || lDoHexDecode || lDoXkasOutput)
			{
				if(lDoXkasOutput)
				{
					realMain(2, lRomFn);
					for(int i = 0; i < dialogue.GetSize(); i++)
						delete dialogue[i];
					dialogue.RemoveAll();
				}
				else
				{
					realMain(lDoTextDecode, lRomFn);
					for(int i = 0; i < dialogue.GetSize(); i++)
						delete dialogue[i];
					dialogue.RemoveAll();
				}
			}
			else if (lDoNPCDecode)
			{
				npcParser(lRomFn);
			}
			else if (lDoTriggerDecode)
			{
				triggerParser(lRomFn);
			}
			else if (lDoChestDecode)
			{
				chestParser(lRomFn);
			}
			else if (lDoLocationDecode)
			{
				locationParser(lRomFn);
			}
			else if (lDoMapEventPointer)
			{
				mapEventParser(lRomFn);
			}
			else if (lDoXkasPointer)
			{
				xkasEventPointers(lRomFn);
			}
    		else if(lDoHexEncode)
				serialise_script(lScriptFn, lRomFn);
		}
	}

	return nRetCode;
}


void realMain(int iTextMode, CString iFf6Fn)
{
	CFile file;

	if(file.Open(iFf6Fn, CFile::modeRead|CFile::shareDenyNone) == NULL)
	{
		printf(_T("Errors reading %s\n"), iFf6Fn);
		return;
	}

	WORD nHeader = (file.GetLength() % 0x8000);
	ofstream outFile;
	CString lScriptFn;
	if(iTextMode == 2)
		lScriptFn = XKAS_OUTPUT_FN;
	else
		lScriptFn = iTextMode?TXTSCRIPT_FN:HEXSCRIPT_FN;
	outFile.open(lScriptFn);
	if(outFile == NULL)
	{
		printf(_T("Errors creating %s\n"), lScriptFn);
		return;
	}
	CString choice;
	printf(_T("Use original dialogue locations (y/n)?"));
	scanf("%s", choice);
	
	if(choice == "y" || choice == "Y")
		readDialogue(&file, 0x0CE402 + nHeader, 3362); // Use for original
	else
		readDialogue(&file, 0x370000 + nHeader, 8192); // Use for Pandora's Box 

	DWORD dwOffset = 0;
	DWORD pc;
	
	DWORD dwQueueStart = 0;
	BYTE bQueueLen = 0;

	CString t;
	BYTE b[16];
	WORD w[16];
	DWORD d[16];
	CString s[16];
	BOOL bFirst;
	BOOL eventScript = TRUE;		// Are we in the standard event script?
	BOOL vehicleScript = FALSE;		// Are we in a vehicle script?
	BOOL B0Loop = FALSE;			// Are we in a B0..B1 loop?
	BOOL CharactersInCaseWord;		// Is this CaseWord loaded with some sort of characters' indexes?
	BOOL onFoot = TRUE;				// Is the movement script describing a character or vehicle? (needs revision)
	BOOL characterScript = FALSE;	// Are we in the character movement script?
	BOOL mapScript = FALSE;			// Are we in the overworld character map script
	BOOL tempFlag = FALSE;			// After loading a $1FF map, you get a single vehicle script command before going 
									// back to the event script
	int nChoices = 0;
	int x, y;
	int lEnTxt = 0;
	int lEnBytes = 1;
	int lEnXkas = 0;
	int lBakPtr;

	file.Seek(SCRIPT_START, CFile::begin);
	// end at 0x0CE800

	if (iTextMode == 2)
	{
		lEnXkas = 1;
		lEnTxt = 0;
		lEnBytes = 0;
	}
	else
	{
		lEnTxt = iTextMode?1:0;
		lEnBytes = iTextMode?0:1;
	}
	

	printf(_T("Decoding events, text mode %d...\n"), iTextMode);

	dwOffset = file.GetPosition();
	while(dwOffset < (SCRIPT_END + nHeader)) //master while loop
	{
		if (!(file.GetPosition() < dwQueueStart + bQueueLen))
			characterScript = FALSE;
	
		// Read the opcode.
		BYTE opcode = 0;

	
		if(eventScript)
		{
			do
			{

				for(int i = 0; i < 16; i++)
				{
					b[i] = w[i] = d[i] = 0;
					s[i].Empty();
				}

				bFirst = TRUE;

				dwOffset = file.GetPosition();
				pc = dwOffset + 0xC00000 - nHeader;
				file.Read(&opcode, 1);

				if((choice == "y") || (choice == "Y")) // If using the original FF3us, these locations will need 'massaging'.
				{
					// Special checks for weird events
					if (((pc >= 0xCA004E) && (pc < 0xCA009C)) || ((pc >= 0xCA5EB4) && (pc < 0xCA5EF6)) ||
						((pc >= 0xCA5F0A) && (pc < 0xCA5F23)))
					{
						eventScript = FALSE;
						vehicleScript = TRUE;
					}
					else if ((pc == 0xCA8C14) || (pc == 0xCA8C58) || (pc == 0xCA5EB5) || (pc == 0xCA5F0B) ||
							 (pc == 0xCA5F38) || (pc == 0xCA5AD3))
					{
						eventScript = FALSE;
						vehicleScript = TRUE;
					}
					else if (((pc >= 0xCB0BB6) && (pc < 0xCB0BB9)) || ((pc >= 0xCBD2ED) && (pc < 0xCBD309)) || 
							 ((pc >= 0xCA694E) && (pc < 0xCA6952)))
					{
						eventScript = FALSE;
						mapScript = TRUE;
					}
				}
			
				dwQueueStart = 0;
				bQueueLen = 0;
				
				
				
				if(lEnBytes)
				{
					t.Format("%02X/%04X: %02X", (pc & 0xFF0000) >> 16, pc & 0xFFFF, opcode);
				}
				else if (lEnXkas)
				{
					t.Format("Old%06X: DB $%02X ", pc, opcode);
				}
				else
				{
					t.Format("%02X/%04X: %02X    ", (pc & 0xFF0000) >> 16, pc & 0xFFFF, opcode);
				}
				
				if(B0Loop) // Indent between B0 (start loop) and B1 (end loop)
					t += "    ";

				outFile << t;

				switch(opcode)
				{
					case 0x35:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Pause execution until object A's queue complete", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Pause execution until action queue for object $%02X (%s) is complete", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x36:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Disable phase-through for object A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							
							if(b[0] >= 0x00 && b[0] < 0x10)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Disable ability to pass through other objects for object $%02X (%s)", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x37:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Assign to object A graphics set B", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Assign graphics $%02X to object $%02X (%s)", b[1], b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x38:
						if(lEnXkas)
						{
							outFile << "; Hold screen";
						}
						if(lEnTxt)
						{
							outFile << "Hold screen";
						}
						break;

					case 0x39:
						if(lEnXkas)
						{
							outFile << "; Free screen";
						}
						if(lEnTxt)
						{
							outFile << "Free screen";
						}						
						break;

					case 0x3A:
						if(lEnXkas)
						{
							outFile << "; Enable movement while events execute";
						}
						if(lEnTxt)
						{
							outFile << "Enable player to move while event commands execute";
						}
						
						break;

					case 0x3B:
						if(lEnXkas)
						{
							outFile << " ; Position character in ready-to-go stance";
						}
						if(lEnTxt)
						{
							outFile << "Position character in a \"ready-to-go\" stance";
						}
						
						break;

					case 0x3C:
						file.Read(b, 4);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", b[0], b[1], b[2], b[3]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X : DB $%02X : DB $%02X ; Setup party with A, B, C, D",  b[0], b[1], b[2], b[3]);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(x = 0; x < 4; x++)
							{
								if(b[x] >= 0x00 && b[x] < 0x0E)
									s[x] = FixedTextToCString(characters[b[x]].name, 6, TAG_END, 0);
								else if(b[x] >= 0x0E && b[x] < 0x10)
									s[x].Format("PC $%02X", b[x]);
								else if(b[x] >= 0x10 && b[x] <= 0x30)
									s[x].Format("NPC $%02X", b[x]);
								else if(b[x] >= 0x31 && b[x] <= 0x34)
									s[x].Format("Party Character %d", b[x] - 0x31);
								else
									s[x] = "<Invalid Character>";
							}

							t.Format("Set up the party as follows: $%02X (%s), $%02X (%s), $%02X (%s), $%02X (%s)", b[0], s[0], b[1], s[1], b[2], s[2], b[3], s[3]);
							outFile << t;
						}
						break;

					case 0x3D:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Create object A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Create object $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0x3E:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Delete object A", b[0]);
							outFile << t;
						}

						if(lEnTxt)
						{
							t.Format("Delete object $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0x3F:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Assign character B to party A (party 0 = remove)", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							if(b[1] != 0)
								t.Format("Assign character $%02X (%s) to party %d", b[0], s[0], b[1]);
							else
								t.Format("Remove character $%02X (%s) from the party", b[0], s[0]);

							outFile << t;
						}
						break;

					case 0x40:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Assign properties B to character A", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Assign properties $%02X to character $%02X (%s)", b[1], b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x41:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Show object A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Show object $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0x42:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Hide object A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Hide object $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0x43:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Assign palette B to character A", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Assign palette $%02X to character $%02X (%s)", b[1], b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x44:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}						
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Place character A on vehicle B (high bit of B = character is shown)", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							if((b[1] & 0x7F) == 0x00)
								s[1] = "No vehicle";
							else if((b[1] & 0x7F) == 0x20)
								s[1] = "Chocobo";
							else if((b[1] & 0x7F) == 0x40)
								s[1] = "Magitek Armor";
							else if((b[1] & 0x7F) == 0x60)
								s[1] = "Raft";

							if(b[1] & 0x80)
								s[2] = " (Character is shown)";
							else
								s[2] = " (Character is not shown)";

							t.Format("Place character $%02X (%s) on vehicle $%02X (%s)%s", b[0], s[0], b[1] & 0x7F, s[1], s[2]);
							outFile << t;
						}
						break;

					case 0x45:
						if(lEnBytes)
						{
							t.Format("%02X");
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format("; Refresh objects");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Refresh objects";
						}
						break;

					case 0x46:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Make party A the active party", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Make party %d the current party", b[0]);
							outFile << t;
						}
						break;

					case 0x47:
						if(lEnXkas)
						{
							t.Format("; Make character in slot 0 the lead character");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Make character in slot 0 the lead character";
						}
						break;

					case 0x48:
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;

							if((w[0] & 0x3FFF) < dialogue.GetSize())
							{
								dialogue[w[0] & 0x3FFF]->ConvertToASCII(t, DI_ConvertMode, DICM_List, TAG_END, false, 0);

								int nChoicePtr = 0;
								nChoices = 0;
								nChoicePtr = t.Find("^");
								while(nChoicePtr != -1)
								{
									nChoices++;
									nChoicePtr = t.Find("^", nChoicePtr + 1);
								}
							}
							else
							{
								nChoices = 0;
							}
						}
						if(lEnXkas)
						{
							(w[0] & 0x4000) ? s[0] = " (Show text only)" : s[0] = " (Show text with window)";
							(w[0] & 0x8000) ? s[1] = " (At bottom of screen)" : s[1] = " (At top of screen)";
							t.Format(": DW $%04X ; Display msg. $%04X, continue executing commands%s%s", w[0], w[0] & 0x3FFF, s[0], s[1]);
							outFile << t;
							
							if((w[0] & 0x3FFF) < dialogue.GetSize())
							{
								dialogue[w[0] & 0x3FFF]->ConvertToASCII(t, DI_ConvertMode, DICM_List, TAG_END, true, 0);
								//outFile << "\n         ; " << t;

								// Get number of choices.
								int nChoicePtr = 0;
								nChoices = 0;
								nChoicePtr = t.Find("^");
								while(nChoicePtr != -1)
								{
									nChoices++;
									nChoicePtr = t.Find("^", nChoicePtr + 1);
								}
							}
							else
							{
								outFile << "               ;<Invalid Dialogue>" << endl;
								nChoices = 0;
							}
						}
						if(lEnTxt)
						{
							(w[0] & 0x4000) ? s[0] = " (Show text only)" : s[0] = " (Show text with window)";
							(w[0] & 0x8000) ? s[1] = " (At bottom of screen)" : s[1] = " (At top of screen)";
							t.Format("Display dialogue message $%04X, continue executing commands%s%s", w[0] & 0x3FFF, s[0], s[1]);
							outFile << t;
							
							if((w[0] & 0x3FFF) < dialogue.GetSize())
							{
								dialogue[w[0] & 0x3FFF]->ConvertToASCII(t, DI_ConvertMode, DICM_List, TAG_END, false, 0);
								outFile << "\n               " << t;

								int nChoicePtr = 0;
								nChoices = 0;
								nChoicePtr = t.Find("^");
								while(nChoicePtr != -1)
								{
									nChoices++;
									nChoicePtr = t.Find("^", nChoicePtr + 1);
								}
							}
							else
							{
								outFile << "               <Invalid Dialogue>" << endl;
								nChoices = 0;
							}
						}
						break;

					case 0x49:
						if(lEnXkas)
						{
							t.Format("; If dialogue windows is up, wait for keypress and dismiss");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "If dialogue window is up, wait for keypress then dismiss";
						}
						break;

					case 0x4A:
						if(lEnXkas)
						{
							outFile << "; Unknown command";
						}
						if(lEnTxt)
						{
							outFile << "Command $4A";
						}
						break;

					case 0x4B:
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;

							if((w[0] & 0x3FFF) < dialogue.GetSize())
							{
								dialogue[w[0] & 0x3FFF]->ConvertToASCII(t, DI_ConvertMode, DICM_List, TAG_END, false, 0);

								// Get number of choices.
								int nChoicePtr = 0;
								nChoices = 0;
								nChoicePtr = t.Find("^");
								while(nChoicePtr != -1)
								{
									nChoices++;
									nChoicePtr = t.Find("^", nChoicePtr + 1);
								}
							}
							else
							{
								nChoices = 0;
							}
						}
						if(lEnXkas)
						{
							(w[0] & 0x4000) ? s[0] = " (Show text only)" : s[0] = " (Show text with window)";
							(w[0] & 0x8000) ? s[1] = " (At bottom of screen)" : s[1] = " (At top of screen)";
							t.Format(": DW $%04X ; Display msg. %04X, wait for button press%s%s", w[0], w[0] & 0x3FFF, s[0], s[1]);
							outFile << t;
							
							if((w[0] & 0x3FFF) < dialogue.GetSize())
							{
								dialogue[w[0] & 0x3FFF]->ConvertToASCII(t, DI_ConvertMode, DICM_List, TAG_END, true, 0);
								//outFile << "\n         ; " << t;

								// Get number of choices.
								int nChoicePtr = 0;
								nChoices = 0;
								nChoicePtr = t.Find("^");
								while(nChoicePtr != -1)
								{
									nChoices++;
									nChoicePtr = t.Find("^", nChoicePtr + 1);
								}
							}
							else
							{
								outFile << "            ;<Invalid Dialogue>" << endl;
								nChoices = 0;
							}
						}

						if(lEnTxt)
						{
							(w[0] & 0x4000) ? s[0] = " (Show text only)" : s[0] = " (Show text with window)";
							(w[0] & 0x8000) ? s[1] = " (At bottom of screen)" : s[1] = " (At top of screen)";
							t.Format("Display dialogue message $%04X, wait for button press%s%s", w[0] & 0x3FFF, s[0], s[1]);
							outFile << t;

							if((w[0] & 0x3FFF) < dialogue.GetSize())
							{
								dialogue[w[0] & 0x3FFF]->ConvertToASCII(t, DI_ConvertMode, DICM_List, TAG_END, false, 0);
								outFile << "\n               " << t;

								// Get number of choices.
								int nChoicePtr = 0;
								nChoices = 0;
								nChoicePtr = t.Find("^");
								while(nChoicePtr != -1)
								{
									nChoices++;
									nChoicePtr = t.Find("^", nChoicePtr + 1);
								}
							}
							else
							{
								outFile << "               <Invalid Dialogue>" << endl;
								nChoices = 0;
							}
						}
						break;

					case 0x4C:
						file.Read(b, 2);
						b[2] = (b[1] & 0x3F);
						s[0] = g_strBackgroundNames[b[2]];
						(b[1] & 0x80) ? s[1] = "mosaic effect disabled" : s[1] = "mosaic effect enabled";
						(b[1] & 0x40) ? s[2] = "swoosh sound disabled" : s[2] = "swoosh sound enabled";

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Center screen on party and invoke battle, enemy set A, bkgrd. B&3F (%s), (%s), (%s)", b[0], b[1], s[0], s[1], s[2]);
							outFile << t;
						}
						if(lEnTxt)
						{							
							t.Format("Center screen on party and invoke battle, enemy set $%02X, background $%02X (%s), (%s), (%s)", b[0], b[2], s[0], s[1], s[2]);
							outFile << t;
						}
						break;

					case 0x4D:
						file.Read(b, 2);
						b[2] = (b[1] & 0x3F);
						s[0] = g_strBackgroundNames[b[2]];
						(b[1] & 0x80) ? s[1] = "mosaic effect disabled" : s[1] = "mosaic effect enabled";
						(b[1] & 0x40) ? s[2] = "swoosh sound disabled" : s[2] = "swoosh sound enabled";

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							
							t.Format(": DB $%02X : DB $%02X ; Invoke battle, enemy set A, bkgrd. B&3F (%s), (%s), (%s)", b[0], b[1], s[0], s[1], s[2]);
							outFile << t;
						}
						if(lEnTxt)
						{							
							t.Format("Invoke battle, enemy set $%02X, background $%02X (%s), (%s), (%s)", b[0], b[2], s[0], s[1], s[2]);
							outFile << t;
						}
						break;

					case 0x4E:
						if(lEnXkas)
						{
							t.Format("; Invoke battle, random encounter as determined by zone");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Invoke battle, random encounter as determined by zone";
						}
						break;

					case 0x4F:
						if(lEnXkas)
						{
							t.Format("; Exit the current location");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Exit the current location";
						}
						break;

					case 0x50:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Tint screen (cumulative) with color A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Tint screen (cumulative) with color $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0x51:
						file.Read(b, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X : DB $%02X ; Add/Subtract/Unknown(A) bkgrd. color range from B to C (intensity is A & x03)", b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if((b[0] & 0xE0) == 0x20)
							s[0] = "Add";
							else if((b[0] & 0xE0) == 0xA0)
								s[0] = "Subtract";
							else 
								s[0] = "Do <unknown operation>";
							x = (b[0] & 0x1C) >> 1;
							y = 0;
							if(x & 0x80) // red
								y |= 0x02;
							if(x & 0x40) // green
								y |= 0x04;
							if(x & 0x20) // blue
								y |= 0x08;
							s[1] = g_strColorComponents[y];
							t.Format("Modify background color range from [%02X, %02X]: %s (%s) at intensity %d", b[1], b[2], s[0], s[1], (b[0] & 0x03));
							outFile << t;
						}
						break;

					case 0x52:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Tint characters (cumulative) with color A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Tint characters (cumulative) with color $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0x53:
						file.Read(b, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X : DB $%02X ; Add/Subtract/Unknown(A) object color range from B to C (intensity is A & x03)", b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if((b[0] & 0xE0) == 0x20)
							s[0] = "Add";
							else if((b[0] & 0xE0) == 0xA0)
								s[0] = "Subtract";
							else 
								s[0] = "Do unknown operation";
							x = (b[0] & 0x1C) >> 1;
							y = 0;
							if(x & 0x80) // red
								y |= 0x02;
							if(x & 0x40) // green
								y |= 0x04;
							if(x & 0x20) // blue
								y |= 0x08;
							s[1] = g_strColorComponents[y];
							t.Format("Modify object color range from [%02X, %02X]: %s (%s) at intensity %d", b[1], b[2], s[0], s[1], (b[0] & 0x03));
							outFile << t;
						}
						break;

					case 0x54:
						if(lEnXkas)
						{
							outFile << "; End effects of commands for modified color components and screen flashes";
						}
						if(lEnTxt)
						{
							outFile << "End effects of commands for modifed color components and screen flashes";
						}
						break;

					case 0x55:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Flash screeen with color components/intensity (high nibble/low nibble)", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							x = (b[0] & 0xF0) >> 4;
							y = (b[0] & 0x0F);

							s[0] = g_strColorComponents[x];

							t.Format("Flash screen with color component(s) %d (%s), at intensity %d", x, s[0], y);
							outFile << t;
						}
						break;

					case 0x56:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Increase color components/intensity (high nibble/low nibble)", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							x = (b[0] & 0xF0) >> 4;
							y = (b[0] & 0x0F);

							s[0] = g_strColorComponents[x];

							// TODO: not sure what to do
							t.Format("Increase color component(s) %d (%s), at intensity %d", b[0], s[0], y);
							outFile << t;
						}
						break;

					case 0x57:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Decrease color components/intensity (high nibble/low nibble)", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							x = (b[0] & 0xF0) >> 4;
							y = (b[0] & 0x0F);

							s[0] = g_strColorComponents[x];

							// TODO: not sure what to do
							t.Format("Decrease color component(s) %d (%s), at intensity %d", b[0], s[0], y);
							outFile << t;
						}
						break;

					case 0x58:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Shake screen (A?)", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Shake screen ($%02X)", b[0]);
							outFile << t;
						}
						break;

					case 0x59:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Unfade screen at speed A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Unfade screen at speed $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0x5A:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Fade screen at speed A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Fade screen at speed $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0x5B:
						if(lEnXkas)
						{
							outFile << "; Unknown command";
						}
						if(lEnTxt)
						{
							outFile << "Command $5B";
						}
						break;

					case 0x5C:
						if(lEnXkas)
						{
							outFile << "; Pause execution until fade in or fade out complete";
						}
						if(lEnTxt)
						{
							outFile << "Pause execution until fade in or fade out is complete";
						}
						break;

					case 0x5D:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Scroll BG0, speed A x B", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Scroll BG0, speed %d x %d", b[0], b[1]);
							outFile << t;
						}
						break;

					case 0x5E:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Scroll BG1, speed A x B", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Scroll BG1, speed %d x %d", b[0], b[1]);
							outFile << t;
						}
						break;

					case 0x5F:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Scroll BG2, speed A x B", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Scroll BG2, speed %d x %d", b[0], b[1]);
							outFile << t;
						}
						break;

					case 0x60:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Change bkgrd. layer A to palette B", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Change background layer $%02X to palette $%02X", b[0], b[1]);
							outFile << t;
						}
						break;

					case 0x61:
						file.Read(b, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X : DB $%02X ; Colorize range [B,C] to color A", b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Colorize color range [$%02X, $%02X] to color $%02X", b[1], b[2], b[0]);
							outFile << t;
						}
						break;

					case 0x62:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Mosaic screen, speed A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Mosaic screen, speed %d", b[0]);
							outFile << t;
						}
						break;

					case 0x63:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Create spotlight effect with radius A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Create spotlight effect with radius %d", b[0]);
							outFile << t;
						}
						break;

					case 0x64:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Unknown command, params A, B", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Command $64, $%02X, $%02X", b[0], b[1]);
							outFile << t;
						}
						break;

					case 0x65:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Unknown command, params A, B", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Command $65, $%02X, $%02X", b[0], b[1]);
							outFile << t;
						}
						break;

					case 0x66:
						file.Read(b, 2);
						file.Read(d, 3);
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X : DL Old%06X-$CA0000; If character A&0x7F has any status bits B (byte 1) set (or clear, if X high bit set), branch to C", b[0], b[1], d[0]+0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $66";
						}
						break;

					case 0x67:
						file.Read(b, 2);
						file.Read(d, 3);
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X : DL Old%06X-$CA0000; If character A&0x7F has any status bits B (byte 4) set (or clear, if X high bit set), branch to C", b[0], b[1], d[0]+0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $67";
						}
						break;

					case 0x68:
						file.Read(b, 2);
						file.Read(d, 3);
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X : DL Old%06X-$CA0000; If character A&0x7F has all status bits B (byte 1) set (or clear, if A high bit set), branch to C", b[0], b[1], d[0]+0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $68";
						}
						break;

					case 0x69:
						file.Read(b, 2);
						file.Read(d, 3);
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X : DL Old%06X-$CA0000; If character A&0x7F has all status bits B (byte 4) set (or clear, if A high bit set), branch to C", b[0], b[1], d[0]+0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $69";
						}
						break;

					case 0x6A:
						file.Read(w, 2);
						file.Read(b, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, b[0], b[1], b[2]);
							outFile << t;
						}
						else if (((w[0] & 0x01FF) < 0x0003) || ((w[0] & 0x01FF) >= 0x01FE))
							{
								if (b[2] & 0x01)
								{
									s[0] = ", party is in the airship";
									onFoot = FALSE;
									vehicleScript = TRUE;
								}
								else if (b[2] & 0x02)
								{
									s[0] = ", party is in overworld chocobo mode";
									onFoot = FALSE;
									vehicleScript = TRUE;
								}	
								else
								{
									s[0].Format(", flags $%02X", b[2]);
									mapScript = TRUE;
								}

							/*	if ((w[0] & 0x0400) && ((w[0] & 0x01FF) < 0x0002))
								{
									mapScript = TRUE;
									vehicleScript = FALSE;
								}
								else
								{
									vehicleScript = TRUE;
									mapScript = FALSE;
								}

							*/	if ((w[0] & 0x01FF) >= 0x01FE) 
									tempFlag = TRUE;

								characterScript = FALSE;
								eventScript = FALSE;
							}
							else
								eventScript = TRUE;
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DB $%02X : DB $%02X : DB $%02X; Load map A, place party at (B,C), Flags D (Facing on 0x3000 bits of map)", w[0], b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if ((w[0] & 0x01FF) < 0x19F)
								s[1] = g_strLocationNames[(w[0] & 0x01FF)];
							else
								s[1] = "<unknown or out-of-range map index>";

							if (s[1][1] == '-')
								s[1] = "<in-range, but untested map index>";

							s[2] = ", facing";
							if ((w[0] & 0x3000) == 0x3000)
								s[2] += " left";
							else if ((w[0] & 0x3000) == 0x2000)
								s[2] += " down";
							else if ((w[0] & 0x3000) == 0x1000)
								s[2] += " right";
							else if ((w[0] & 0x3000) == 0x0000)
								s[2] += " up";
							
							
		
							t.Format("Load map $%04X (%s) after fade out, (upper bits $%04X), place party at (%d, %d)%s%s", (w[0] & 0x01FF), s[1], (w[0] &0xFE00), b[0], b[1], s[2], s[0]);
							outFile << t;
						}
						break;

					case 0x6B:
						file.Read(w, 2);
						file.Read(b, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, b[0], b[1], b[2]);
							outFile << t;
						}
						else if (((w[0] & 0x01FF) < 0x0003) || ((w[0] & 0x01FF) >= 0x01FE))
							{
								if (b[2] & 0x01)
								{
									s[0] = ", party is in the airship";
									onFoot = FALSE;
									vehicleScript = TRUE;
									eventScript = FALSE;
								}
								else if (b[2] & 0x02)
								{
									s[0] = ", party is in overworld chocobo mode";
									onFoot = FALSE;
									vehicleScript = TRUE;
									eventScript = FALSE;
								}	
								else if (w[0] & 0x0400)
								{
									mapScript = TRUE;
									eventScript = FALSE;
								}
								else
								{
									s[0].Format(", flags $%02X", b[2]);
									mapScript = TRUE;
									eventScript = FALSE;
								}

							/*	if ((w[0] & 0x0400) && ((w[0] & 0x01FF) < 0x0002))
								{
									mapScript = TRUE;
									vehicleScript = FALSE;
								}
								else
								{
									vehicleScript = TRUE;
									mapScript = FALSE;
								}

							*/	if (((w[0] & 0x01FF) >= 0x01FE) )
									tempFlag = TRUE;

								characterScript = FALSE;
								
							}
							else
								eventScript = TRUE;

						if(lEnXkas)
						{
							t.Format(": DW $%04X : DB $%02X : DB $%02X : DB $%02X; Load map A instantly, place party at (B,C), Flags D (Facing on 0x3000 bits of map)", w[0], b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnTxt)
						{
							

							if ((w[0] & 0x01FF) < 0x19F)
								s[1] = g_strLocationNames[(w[0] & 0x01FF)];
							else
								s[1] = "<unknown or out-of-range map index>";

							if (s[1][1] == '-')
								s[1] = "<in-range, but untested map index>";
						

							s[2] = ", facing";
							if ((w[0] & 0x3000) == 0x3000)
								s[2] += " left";
							else if ((w[0] & 0x3000) == 0x2000)
								s[2] += " down";
							else if ((w[0] & 0x3000) == 0x1000)
								s[2] += " right";
							else if ((w[0] & 0x3000) == 0x0000)
								s[2] += " up";

							t.Format("Load map $%04X (%s) instantly, (upper bits $%04X), place party at (%d, %d)%s%s", (w[0] & 0x01FF), s[1], (w[0] &0xFE00), b[0], b[1], s[2], s[0]);
							outFile << t;
						}
						break;

					case 0x6C:
						file.Read(w, 2);
						file.Read(b, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DB $%02X : DB $%02X : DB $%02X ; Set parent map to A, parent coords to (B,C), facing D", w[0], b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if ((w[0] & 0x01FF) < 0x19F)
								s[1] = g_strLocationNames[(w[0] & 0x01FF)];
							else
								s[1] = "<unknown or out-of-range map index>";

							if (s[1][1] == '-')
								s[1] = "<in-range, but untested map index>";

							s[2] = "facing";
							if ((b[2]) == 0x03)
								s[2] += " right";
							else if ((b[2]) == 0x02)
								s[2] += " up";
							else if ((b[2]) == 0x01)
								s[2] += " left";
							else if ((b[2]) == 0x00)
								s[2] += " down";

							t.Format("Set parent map to $%04X (%s), parent coordinates to (%d, %d), %s", w[0], s[1], b[0], b[1], s[2]);
							outFile << t;
						}
						break;

					case 0x6D:
						file.Read(b, 1);
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; If item A is in the inventory, set bit 6 of $1EB7 ($1BE)", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $6D";
						}
						break;
			
					case 0x6E:
						file.Read(b, 2);
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; If char. A has B equipped, set bit 6 of $1EB7 ($1BE)", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $6E";
						}
						break;
					
					case 0x6F:
						file.Read(w, 2);
						file.Read(d, 3);
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DL Old%06X|$%800000-$CA0000 ; If $1DD9 is greater/less than A, branch to B (high bit of B determines greater/less)", w[0], d[0]&0x800000+0xCA0000, d[0]& 0x800000);
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $6F";
						}
						break;

					case 0x70:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Scroll BG0, (256 x A + B)", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Scroll BG0 (256 x %d + %d)", b[0], b[1]);
							outFile << t;
						}
						break;

					case 0x71:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Scroll BG1, (256 x A + B)", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Scroll BG1 (256 x %d + %d)", b[0], b[1]);
							outFile << t;
						}
						break;

					case 0x72:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Scroll BG2, (256 x A + B)", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Scroll BG2 (256 x %d + %d)", b[0], b[1]);
							outFile << t;
						}
						break;

					case 0x73:
						
					case 0x74:
						file.Read(b, 4);

						lBakPtr = file.GetPosition();
						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", b[0], b[1], b[2], b[3]);
							outFile << t;

							for(y = 0; y < b[2]; y++)
							{
								outFile << endl;
								dwOffset = file.GetPosition();
								pc = dwOffset + 0xC00000 - nHeader;

								t.Format("%02X/%04X:       ", (pc & 0xFF0000) >> 16, pc & 0xFFFF);
								outFile << t;

								file.Read(&b[15], 1);
								t.Format("%02X", b[15]);
								outFile << t;

								for(x = 0; x < b[3] - 1; x++)
								{
									file.Read(&b[15], 1);
									t.Format("%02X", b[15]);
									outFile << t;
								}
							}
						}

						if(lEnTxt || lEnXkas)
						{

							if(b[1] & 0x80)
								s[0] = "layer 3";
							else if(b[1] & 0x40)
								s[0] = "layer 2";
							else 
								s[0] = "layer 1";

							if (opcode == 0x73)
								s[1] = ", refresh immediately";
							else if (opcode == 0x74)
								s[1] = ", wait for opcode $75 to refresh";
							else
								s[1] = ", error-contact Imzogelmo";

							if (lEnTxt)
							{
								t.Format("Replace current map's %s at (%d, %d) with the following (%d x %d) chunk%s", s[0], b[0], (b[1] & 0x3F), b[3], b[2], s[1]);
								outFile << t;

								for(y = 0; y < b[2]; y++)
								{
									outFile << endl;

									dwOffset = file.GetPosition();
									pc = dwOffset + 0xC00000 - nHeader;

									t.Format("%02X/%04X:       ", (pc & 0xFF0000) >> 16, pc & 0xFFFF);
									outFile << t;

									file.Read(&b[15], 1);
									t.Format("$%02X", b[15]);
									outFile << t;

									for(x = 0; x < b[3] - 1; x++)
									{
										// TODO: not sure OK for deserialisation
										file.Read(&b[15], 1);
										t.Format(", $%02X", b[15]);
										outFile << t;
									
									}
								}
							}
							else // (lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X : DB $%02X : DB $%02X ; Replace current map's %s (layer det. by upper 2 bits on B) at (A,B) with this DxC chunk%s", b[0], b[1], b[2], b[3], s[0], s[1]);
								outFile << t;

								for(y = 0; y < b[2]; y++)
								{
									outFile << endl;

									dwOffset = file.GetPosition();
									pc = dwOffset + 0xC00000 - nHeader;

									t.Format("Old%06X:", pc);
									outFile << t;

									file.Read(&b[15], 1);
									t.Format(" DB $%02X ", b[15]);
									outFile << t;

									for(x = 0; x < b[3] - 1; x++)
									{
										// TODO: not sure OK for deserialisation
										file.Read(&b[15], 1);
										t.Format(": DB $%02X ", b[15]);
										outFile << t;
									
									}
								}
							}
						}
						break;

					case 0x75:
						if(lEnXkas)
						{
							outFile << "; Refresh map after alteration";
						}
						if(lEnTxt)
						{
							outFile << "Refresh map after alteration";
						}
						break;

					case 0x76:
						file.Read(w, 2);
						file.Read(b, 1);
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DB $%02X ; Load value for display in text; address $7E0000 + A, B determines width: 0/1/2 = 8/16/24 bit", w[0], b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $76";
						}
						break;

					case 0x77:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Perform level averaging for char. slot A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							t.Format("Perform level averaging on character $%02X (%s) and calculate new maximum HP/MP", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x78:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Enable A to pass through other objects", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Enable ability to pass through other objects for object $%02X (%s)", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x79:
						file.Read(b, 1);
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%04X", b[0], w[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DW $%04X ; Place party A on map B", b[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if ((w[0] & 0x01FF) < 0x19F)
								s[1] = g_strLocationNames[(w[0] & 0x01FF)];
							else
								s[1] = "<unknown or out-of-range map index>";

							if (s[1][1] == '-')
								s[1] = "<in-range, but untested map index>";

							t.Format("Place party %d on map $%04X (%s)", b[0], w[0], s[1]);
							outFile << t;
						}
						break;

					case 0x7A:
						file.Read(b, 1);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%06X", b[0], d[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DL Old%06X-$CA0000 ; Change event address for object A to B", b[0], d[0]+0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Change event address for object $%02X to address $%06X", b[0], 0xCA0000 + d[0]);
							outFile << t;
						}
						break;

					case 0x7B:
						if(lEnXkas)
						{
							t.Format("; Restore backup party (in $055D) to active status");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Restore backup party (in $055D) to active status");
							outFile << t;
						}
						break;

					case 0x7C:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Enable event activation for object A if it contacts any party", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Enable activation of event for object $%02X (%s) if it comes into contact with any party", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x7D:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Disable event activation for object A if it contacts any party", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Disable activation of event for object $%02X (%s) if it comes into contact with any party", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x7E:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Move chars. to (A, B)", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move characters to (%d, %d)", b[0], b[1]);
							outFile << t;
						}
						break;

					case 0x7F:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Change actor slot A's name to B", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							s[0] = FixedTextToCString(characters[b[1]].name, 6, TAG_END, 0);
							t.Format("Change character $%02X's name to $%02X (%s)", b[0], b[1], s[0]);
							outFile << t;
						}
						break;

					case 0x80:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Add item A [WoB:(%s) WoR:(%s)] to inventory", b[0], FixedTextToCString(items[b[0]].name, 13, TAG_END, 0), FixedTextToCString(items[b[0]+256].name, 13, TAG_END, 0));
							//t.Format(": DB $%02X ; Add item A (%s) to inventory", b[0], FixedTextToCString(items[b[0]].name, 13, TAG_END, 0)); //For original game
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Add item $%02X (%s) to inventory", b[0], FixedTextToCString(items[b[0]].name, 13, TAG_END, 0));
							outFile << t;
						}
						break;

					case 0x81:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Remove item A [WoB:(%s) WoR:(%s)] from inventory", b[0], FixedTextToCString(items[b[0]].name, 13, TAG_END, 0), FixedTextToCString(items[b[0]+256].name, 13, TAG_END, 0));
							//t.Format(": DB $%02X ; Remove item A (%s) from inventory", b[0], FixedTextToCString(items[b[0]].name, 13, TAG_END, 0)); //For original game
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Remove item $%02X (%s) from inventory", b[0], FixedTextToCString(items[b[0]].name, 13, TAG_END, 0));
							outFile << t;
						}
						break;

					case 0x82:
						if(lEnXkas)
						{
							t.Format("; Store party 1 as backup party (in $055D)");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Store party 1 as backup party (in $055D)";
						}
						break;

					case 0x83:
						if(lEnXkas)
						{
							t.Format("; Unused command or data");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $83";
						}
						break;

					case 0x84:
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X ; Give %d Gil to party", w[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Give %d GP to party", w[0]);
							outFile << t;
						}
						break;

					case 0x85:
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X ; Take %d Gil from party", w[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Take %d GP from party", w[0]);
							outFile << t;
						}
						break;

					case 0x86:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						else 
						{
							if(b[0] > 0x35 && b[0] < 0x51)
								s[0] = FixedTextToCString(espers[b[0] - 0x36].name, 8, TAG_END, 0);
							else
								s[0] = "<Invalid Esper>";
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Gain esper %s", b[0], s[0]);
							outFile << t;
						}
						if(lEnTxt)
						{							
							t.Format("Give esper $%02X (%s) to party", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x87:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						else
						{
							if(b[0] > 0x35 && b[0] < 0x51)
								s[0] = FixedTextToCString(espers[b[0] - 0x36].name, 8, TAG_END, 0);
							else
								s[0] = "<Invalid Esper>";
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Lose esper %s", b[0], s[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Take esper $%02X (%s) from party", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x88:
						file.Read(b, 1);
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%04X", b[0], w[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DW $%04X ; Remove actor A's statuses B (bits 0 are cleared)", b[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							w[0] ^= 0xFFFF;
							x = 15;
							do
							{
								if(w[0] >= (1 << x))
								{
									w[0] -= (1 << x);
									s[1] += g_strStatusNames[x];
									if(w[0] != 0)
										s[1] += ", ";
								}
								x--;
							}
							while (w[0] != 0);

							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Remove the following status ailments from character $%02X (%s): %s", b[0], s[0], s[1]);
							outFile << t;
						}
						break;

					case 0x89:
						file.Read(b, 1);
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%04X", b[0], w[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DW $%04X ; Inflict actor A with statuses B (bits 1 are set)", b[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							x = 15;
							do
							{
								if(w[0] >= (1 << x))
								{
									w[0] -= (1 << x);
									s[1] += g_strStatusNames[x];
									if(w[0] != 0)
										s[1] += ", ";
								}
								x--;
							}
							while (w[0] != 0);
							
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Inflict the following status ailments on character $%02X (%s): %s", b[0], s[0], s[1]);
							outFile << t;
						}
						break;

					case 0x8A:
						file.Read(b, 1);
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%04X", b[0], w[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DW $%04X ; Toggle actor A's statuses B (bits 1 are flipped)", b[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							x = 15;
							do
							{
								if(w[0] >= (1 << x))
								{
									w[0] -= (1 << x);
									s[1] += g_strStatusNames[x];
									if(w[0] != 0)
										s[1] += ", ";
								}
								x--;
							}
							while (w[0] != 0);

							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Toggle the following status ailments for character $%02X (%s): %s", b[0], s[0], s[1]);
							outFile << t;
						}
						break;

					case 0x8B:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							if(b[1] == 0x7F)
								s[1] = "set to maximum";
							else if(b[1] & 0x80)
								s[1].Format("subtract %d (set to 1 if that would put HP below 0)", 1 << (b[1] & 0x7F)); 
							else 
								s[1].Format("add %d", 1 << (b[1] & 0x7F));

							t.Format(": DB $%02X : DB $%02X ; Modify actor A's HP, param B (%s)", b[0], b[1], s[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							if(b[1] == 0x7F)
								s[1] = "set to maximum";
							else if(b[1] & 0x80)
								s[1].Format("subtract %d (set to 1 if that would put HP below 0)", 1 << (b[1] & 0x7F)); 
							else 
								s[1].Format("add %d", 1 << (b[1] & 0x7F));

							t.Format("For character $%02X (%s), take HP and %s", b[0], s[0], s[1]);
							outFile << t;
						}
						break;

					case 0x8C:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							if(b[1] == 0x7F)
								s[1] = "set to maximum";
							else if(b[1] & 0x80)
								s[1].Format("subtract %d )", 1 << (b[1] & 0x7F)); 
							else 
								s[1].Format("add %d", 1 << (b[1] & 0x7F));
							t.Format(": DB $%02X : DB $%02X ; Modify actor A's MP, param B (%s) (add/subtract only with patch)", b[0], b[1], s[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							if(b[1] == 0x7F)
								s[1] = "set to maximum";
							/* // This part is wrong... although it would be consistent with HP
							else if(b[1] & 0x7F)
								s[1].Format("subtract %d", 1 << (b[1] & 0x7F)); 
							else 
								s[1].Format("add %d", 1 << (b[1] & 0x7F));
							*/
							else 
								s[1] = "add 0";

							t.Format("For character $%02X (%s), take MP and %s", b[0], s[0], s[1]);
							outFile << t;
						}
						break;

					case 0x8D:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Remove all equipment from actor A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Remove all equipment from character $%02X (%s)", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x8E:
						if(lEnXkas)
						{
							t.Format("; Invoke battle from MiaB and with area default bkgrd.");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Invoke battle: enemy set obtained from treasure chest's monster-in-a-box, "
									<< "background is area's default";
						}
						break;

					case 0x8F:
						if(lEnXkas)
						{
							t.Format("; Unlock all Bushido techniques");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Unlock all of Cyan's SwdTechs";
						}
						break;

					case 0x90:
						if(lEnXkas)
						{
							t.Format("; Grant Bum Rush Blitz");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Grant Sabin the Bum Rush";
						}
						break;

					case 0x91:
						if(lEnXkas)
						{
							t.Format("; Pause 15 units");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Pause for 15 units";
						}
						break;

					case 0x92:
						if(lEnXkas)
						{
							t.Format("; Pause 30 units");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Pause for 30 units";
						}
						break;

					case 0x93:
						if(lEnXkas)
						{
							t.Format("; Pause 45 units");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Pause for 45 units";
						}
						break;

					case 0x94:
						if(lEnXkas)
						{
							t.Format("; Pause 60 units");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Pause for 60 units";
						}
						break;

					case 0x95:
						if(lEnXkas)
						{
							t.Format("; Pause 120 units");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Pause for 120 units";
						}
						break;

					case 0x96:
						if(lEnXkas)
						{
							t.Format("; Restore screen from fade");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Restore screen from fade";
						}
						break;

					case 0x97:
						if(lEnXkas)
						{
							t.Format("; Fade screen to black");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Fade screen to black";
						}
						break;

					case 0x98:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Invoke name change screen for actor A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Invoke name change screen for character $%02X (%s)", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x99:
						file.Read(b, 1);
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%04X", b[0], w[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DW $%04X ; Invoke party select screen, A groups, force chars. in bitfield B", b[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							s[1] = "(";
							w[1] = w[0];
							x = 0;
							
							do
							{
								if(w[0] & (1 << x))
								{
									s[1] += FixedTextToCString(characters[x].name, 6, TAG_END, 0);
									s[1] += ")";
									w[0] ^= (1 << x);
									
								if(w[0] != 0)
									s[1] += ", (";
								}
								x++;
							}
							while((x < 16) && (w[0] != 0));

							s[0].Format("force characters: [$%04X] %s", w[1], s[1]);
							t.Format("Invoke party selection screen (%d groups) (%s)", b[0] & 0x7F, s[0]);
							// Note: I don't know what b[0] & 0x80 is...
							outFile << t;
						}
						break;

					case 0x9A:
						if(lEnXkas)
						{
							t.Format("; Invoke Colosseum item select screen");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Invoke Colosseum item selection screen";
						}
						break;

					case 0x9B:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Invoke shop A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Invoke shop $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0x9C:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Place optimum equipment on actor A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Place optimum equipment on character $%02X (%s)", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0x9D:
						if(lEnXkas)
						{
							t.Format("; Invoke final battle fighting order screen");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Invoke party fighting order screen (from final battle)";
						}
						break;

					case 0x9E:
						if(lEnXkas)
						{
							t.Format("; Unknown command");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $9E";
						}
						break;

					case 0x9F:
						if(lEnXkas)
						{
							t.Format("; Unknown command");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $9F";
						}
						break;

					case 0xA0:
						file.Read(w, 2);
						file.Read(d, 3); // these 3 bytes are an address to go to if timer does expires, along with some flag bits 
						s[0] = (d[0] & 0x800000) ? "(Countdown pauses in menu and battle" : "(Countdown continues in menu and battle";
						s[1] = (d[0] & 0x400000) ? "(Countdown shown while walking [must have tiles for it, only timer 0 can use]" : "(Countdown not shown while walking";
						s[2] = (d[0] & 0x200000) ? "(Enable exit menu/battle on timer expiration" : "(Disable exit menu/battle on timer expiration";
						s[3] = (d[0] & 0x100000) ? "(Countdown overrides the game clock display" : "(Countdown does not override the game clock display";

						if(lEnBytes)
						{
							t.Format("%04X%062X", w[0], d[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DL Old%06X-$CA0000|$%06X; Set timer: A units, jump to B if expired (flags on upper bits)", w[0], (d[0] & 0x3FFFF) + 0xCA0000, (d[0] & 0xFC0000));
							outFile << t;
							int x;
							for (x = 0; x<4; x++)
							{
								if (d[0] & (0x800000 >> x))
								{
									t.Format("\n;%*s", 15+strlen(s[x]), s[x]);
									outFile << t;
								}
							}

						}
						if(lEnTxt)
						{
							t.Format("Set timer %01d to $%04X [%01dm: %02ds: %02dj], jump to subroutine $%06X if it expires. Flags:  \n%*s) \n%*s) \n%*s) \n%*s)",
								 (d[0] & 0x0C0000) >> 18, w[0], w[0] / 3600, (w[0] % 3600) / 60, w[0] % 60, (d[0] & 0x3FFFF) + 0xCA0000, 15 + strlen(s[0]), s[0], 
								 15 + strlen(s[1]), s[1], 15 + strlen(s[2]), s[2], 15 + strlen(s[3]), s[3]);
							     // About the flags: The nibble in question is binary encoded.  
							     // 0x10 makes the countdown override the game clock display.
								 // 0x20 makes the menu/battle be exited when countdown is complete
							     // 0x40 makes the countdown display visible while walking around (when in an area with the tiles for digits enabled).
							     // 0x80 causes the countdown to pause during battles and while in the menu
							outFile << t;
						}
						break;

					case 0xA1:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Reset timer A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Reset timer %01d", b[0]);
							outFile << t;
						}
						break;

					case 0xA2:
						if(lEnXkas)
						{
							outFile << "; Unknown command?";
						}
						if(lEnTxt)
						{
							outFile << "Command $A2";
						}
						break;

					case 0xA3:
						file.Read(w, 2);
						file.Read(b, 1);
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DB $%02X ; Use address A for gil, B &80 is subtract, low nibble of B indicates number of bytes for size", w[0], b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $A3";
						}
						break;

					case 0xA4:
						
						if(lEnXkas)
						{
							outFile << "; Unknown command?";
						}
						if(lEnTxt)
						{
							outFile << "Command $A4";
						}
						break;
							
					case 0xA5:
						file.Read(d, 3);
						file.Read(b, 1);
						if(lEnXkas)
						{
							t.Format(": DL Old%06X-$CA0000|$%06X : DB $%02X ; Jump/call address A with chance B/256, (optionally) store result to event word $%02X", (d[0] & 0x3FFFF) + 0xCA0000, (d[0] & 0xFC0000), b[0], ((d[0] & 0x1C0000) >> 18));
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command $A5";
						}
						break;

					case 0xA6:
						if(lEnXkas)
						{
							outFile << "; Delete any rotating pyramids";
						}
						if(lEnTxt)
						{
							outFile << "Delete any rotating pyramids";
						}
						break;

					case 0xA7:
						file.Read(b, 1);
						
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Create a rotating pyramid around actor A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{

							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";

							t.Format("Create a rotating pyramid around character $%02X (%s)", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0xA8:
						if(lEnXkas)
						{
							outFile << "; Show floating island soaring into the sky";
						}
						if(lEnTxt)
						{
							outFile << "Show floating island soaring into the sky";
						}
						break;

					case 0xA9:
						if(lEnXkas)
						{
							outFile << "; Show title screen";
						}
						if(lEnTxt)
						{
							outFile << "Show title screen";
						}
						break;

					case 0xAA:
						if(lEnXkas)
						{
							outFile << "; Show intro with Magiteks in snowfield";
						}
						if(lEnTxt)
						{
							outFile << "Show intro with Magitek Armor walking through snowfields";
						}
						break;

					case 0xAB:
						if(lEnXkas)
						{
							outFile << "; Show game loading screen";
						}
						if(lEnTxt)
						{
							outFile << "Invoke game loading screen";
						}
						break;

					case 0xAC:
						if(lEnXkas)
						{
							outFile << "; Unknown command $AC";
						}
						if(lEnTxt)
						{
							outFile << "Command $AC";
						}
						break;

					case 0xAD:
						if(lEnXkas)
						{
							outFile << "; Show world tearing apart";
						}
						if(lEnTxt)
						{
							outFile << "Show world getting torn apart";
						}
						break;

					case 0xAE:
						if(lEnXkas)
						{
							outFile << "; Show train ride out of Magitek Factory";
						}
						if(lEnTxt)
						{
							outFile << "Show train car ride out of Magitek Factory";
						}
						break;

					case 0xAF:
						if(lEnXkas)
						{
							outFile << "; Invoke Colosseum battle";
						}
						if(lEnTxt)
						{
							outFile << "Invoke random Colosseum battle";
						}
						break;

					case 0xB0:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Repeat code A times (if not $FF) or until button press with $BC command (if $FF)", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if (b[0] == 0xFF)
								t.Format("Execute the following commands until broken by $BC command detecting confirm button press");
							else

								t.Format("Execute the following commands until $B1 %d times", b[0]);
							outFile << t;
						}
						B0Loop = TRUE;
						break;

					case 0xB1:
						if(lEnXkas)
						{
							outFile << "; End block of repeating commands";
						}
						if(lEnTxt)
						{
							outFile << "End block of repeating commands";
						}
						B0Loop = FALSE;
						break;

					case 0xB2:
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DL Old%06X-$CA0000 ; Call sub. A", d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Call subroutine $%06X", d[0] + 0xCA0000);
							if(d[0] == 0x00CFBD)
								t += " (heals all HP/MP/Statuses except M-Tek & Dog Block)";
							if(d[0] == 0x02E499)
								t += " (heals all HP/MP/Statuses except Dog Block)";
							if(d[0] == 0x012DFA)
								t += " (clears general purpose event bits)";
							outFile << t;
						}
						break;

					case 0xB3:
						file.Read(b, 1);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", b[0], d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DL Old%06X-$CA0000 ; Call sub. B, A times", b[0], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Call subroutine $%06X, %d times", d[0] + 0xCA0000, b[0]);
							if(d[0] == 0x00CFBD)
								t += " (heals all HP/MP/Statuses except M-Tek & Dog Block)";
							if(d[0] == 0x02E499)
								t += " (heals all HP/MP/Statuses except Dog Block)";
							if(d[0] == 0x012DFA)
								t += " (clears general purpose event bits)";
							outFile << t;
						}
						break;

					case 0xB4:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Pause for A units", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Pause for %d units", b[0]);
							outFile << t;
						}
						break;

					case 0xB5:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Pause for 15 * A units", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Pause for 15 * %d (%d) units", b[0], b[0] * 15);
							outFile << t;
						}
						break;

					case 0xB6:
						file.Read(d, 3);

						lBakPtr = file.GetPosition();
						t.Empty();
						if(lEnBytes)
						{
							//while((b[15] < 8) && ((d[0] & 0xFF) != 0xFE))
							for(b[15] = 0; b[15] < nChoices; b[15]++)
							{
								s[0].Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
								t += s[0];

								d[0] = 0;
								file.Read(d, 3);
							}

							file.Seek(-3, CFile::current);

							outFile << t;
						}
						if(lEnXkas)
						{
							if (nChoices < 1 || nChoices > 6)
							{
								t.Format(": DL Old%06X-$CA0000 ", d[0] + 0xCA0000);
								t += "; Misalignment with dump, dialogue read error";
								outFile << t;
							}
							else
							{
								t = "";
								for(b[15] = 0; b[15] < nChoices; b[15]++)
								{
									
									s[0].Format(": DL Old%06X-$CA0000 ", d[0] + 0xCA0000);
									t += s[0];	

									d[0] = 0;
									file.Read(d, 3);																
								}

								file.Seek(-3, CFile::current);

								/*t = t.Left(t.GetLength() - 2);*/  t += "; Indexed branch to address from prior dialogue selection";

								outFile << t;
							}
						}
						if(lEnTxt)
						{
							
							t.Format("Indexed branch based on prior dialogue selection [");

							//while((b[15] < 8) && ((d[0] & 0xFF) != 0xFE))
							for(b[15] = 0; b[15] < nChoices; b[15]++)
							{
								// TODO: not sure OK for deserialisation
								s[0].Format("$%06X, ", d[0] + 0xCA0000);
								t += s[0];

								d[0] = 0;
								file.Read(d, 3);
							}

							file.Seek(-3, CFile::current);

							t = t.Left(t.GetLength() - 2);  t += "]";
							outFile << t;
						}
						break;

					case 0xB7:
						file.Read(b, 1);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", b[0], d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DL Old%06X-$CA0000 ; If battle event bit($7E:1DC9 + A/8) [$7E%04X:%d] is clear, branch to B", b[0], d[0]+ 0xCA0000, 0x1DC9 + b[0] / 8, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("If bit $1DC9($%02X) [$%04X, bit %d] is clear, branch to $%06X", b[0], 0x1DC9 + b[0] / 8, b[0] & 7, d[0] + 0xCA0000);
							outFile << t;
						}
						break;

					case 0xB8:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Set battle event bit($7E:1DC9 + A/8) [$7E%04X:%d]", b[0], 0x1DC9 + b[0] / 8, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set bit $1DC9($%02X) [$%04X, bit %d]", b[0], 0x1DC9 + b[0] / 8, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xB9:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear battle event bit($7E:1DC9 + A/8) [$7E%04X:%d]", b[0], 0x1DC9 + b[0] / 8, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear bit $1DC9($%02X) [$%04X, bit %d]", b[0], 0x1DC9 + b[0] / 8, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xBA:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Play ending cinematic A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{		
							t.Format("Play ending cinematic $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0xBB:
						if(lEnXkas)
						{
							outFile << "; Command BB is only used once, change this comment if use is determined";
						}
						if(lEnTxt)
						{
							outFile << "Command $BB";
						}
						break;

					case 0xBC:
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%04X", w[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X ; If event bit $7E:1E80 + (A & 0x7FFF)/8 [$7E$%04X:$d] is set/clear (high bit = Set), return from subroutine", w[0], (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(w[0] & 0x8000) s[0] = "is set"; else s[0] = "is clear";

							t.Format("If bit $1E80($%03X) [$%04X, bit %d] %s, return", w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0]);
							outFile << t;
							B0Loop = FALSE;
						}
						break;

					case 0xBD:
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DL Old%06X-$CA0000 ; Pseudo-randomly jump to A 50%% of the time (stores RNG in $1FC6)", d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							//t.Format("Increment $1F6D and branch to $%06X if $C0FD00 + ($1F6D) >= $80", d[0] + 0xCA0000);
							t.Format("Pseudo-randomly jump to $%06X 50%% of the time", d[0] + 0xCA0000);
							outFile << t;
						}
						break;

					case 0xBE:  // Case select based on CaseWord at $1EB4-5 
						file.Read(b, 1);

						lBakPtr = file.GetPosition();
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;

							for(b[15] = 0; b[15] < (b[0] & 0x7F); b[15]++)
							{
								d[0] = 0;
								file.Read(&d[0], 3);

								t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
								outFile << t;
							}
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Case select of A&0x7F choices", b[0]);
							if(b[0] & 0x80) t+= " (0x80 is set)";							

							for(b[15] = 0; b[15] < (b[0] & 0x7F); b[15]++)
							{
								d[0] = 0;
								file.Read(&d[0], 3);
																				
								s[0].Format("DL Old%06X-$CA0000|$%01X00000 ; If $%02X is in the caseword, call $%06X, else", 
									(d[0] & 0x0FFFFF) + 0xCA0000, (d[0] & 0xF00000) >> 20, (d[0] & 0xF00000) >> 20, (d[0] & 0x0FFFFF) + 0xCA0000);
								t += "\n               ";
								t += s[0];
							}

							t = t.Left(t.GetLength() - 6); //crop off the final "; else"
							outFile << t;
							
						}

						if(lEnTxt)
						{
							if(lEnBytes)
							{
								file.Seek(lBakPtr, CFile::begin);
							}
							t.Empty();

							for(b[15] = 0; b[15] < (b[0] & 0x7F); b[15]++)
							{
								d[0] = 0;
								file.Read(&d[0], 3);
								
								if (CharactersInCaseWord)
								{
									s[1] = FixedTextToCString(characters[((d[0] & 0xF00000) >> 20)].name, 6, TAG_END, 0);
								
									s[0].Format("If character $%02X (%s) is in the current CaseWord, call subroutine $%06X; else", 
										((d[0] & 0xF00000) >> 20), s[1], (d[0] & 0x0FFFFF) + 0xCA0000);
								}
								else
								{
									s[0].Format("If $%02X is in the current CaseWord, call subroutine $%06X; else", 
										((d[0] & 0xF00000) >> 20), (d[0] & 0x0FFFFF) + 0xCA0000);
								}
								if(bFirst != TRUE)
									t += "\n               ";

								bFirst = FALSE;

								t += s[0];
							}

							t = t.Left(t.GetLength() - 6); //crop off the final "; else"
							outFile << t;
							if(b[0] & 0x80) outFile << " (0x80 is set)";
						}
						break;

					case 0xBF:
						if(lEnXkas)
						{
							outFile << "; Show airship scene from ending" << endl;
						}
						if(lEnTxt)
						{
							outFile << "Show airship scene from ending" << endl;
						}
						break;

					// Conditionality commands != fun
					case 0xC0:
						file.Read(w, 2);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DL Old%06X-$CA0000 ; If $7E1E80 + (A & 0x7FFF) is set/clear (dep. on high bit), branch to B", w[0], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(w[0] & 0x8000) s[0] = "is set"; else s[0] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xC1:
						file.Read(w, 4);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If $7E1E80 + (A & 0x7FFF) or $7E1E80 + (B & 0x7FFF) are set/clear (dep. on high bit), branch to C", w[0], w[1], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 2; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xC2:
						file.Read(w, 6);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A|B|C are set/clear, branch to D", w[0], w[1], w[2], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 3; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xC3:
						file.Read(w, 8);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A|B|C|D are set/clear, branch to E", w[0], w[1], w[2], w[3], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 4; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xC4:
						file.Read(w, 10);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A|B|C|D|E are set/clear, branch to F", w[0], w[1], w[2], w[3], w[4], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 5; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xC5:
						file.Read(w, 12);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A|B|C|D|E|F are set/clear, branch to G", w[0], w[1], w[2], w[3], w[4], w[5], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 6; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xC6:
						file.Read(w, 14);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A|B|C|D|E|F|G are set/clear, branch to H", w[0], w[1], w[2], w[3], w[4], w[5], w[6], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 7; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xC7:
						file.Read(w, 16);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8, w[7]&0x00FF, w[7]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A|B|C|D|E|F|G|H are set/clear, branch to I", w[0], w[1], w[2], w[3], w[4], w[5], w[6], w[7], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 8; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";


							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								w[7] & 0x7FFF, (w[7] & 0x7FFF) / 8 + 0x1E80, w[7] & 7, s[7],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xC8:
						file.Read(w, 2);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DL Old%06X-$CA0000 ; If $7E1E80 + (A & 0x7FFF) is set/clear (dep. on high bit), branch to B", w[0], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(w[0] & 0x8000) s[0] = "is set"; else s[0] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xC9:
						file.Read(w, 4);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If $7E1E80 + (A & 0x7FFF) and $7E1E80 + (B & 0x7FFF) set/clear (dep. on high bit), branch to C", w[0], w[1], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 2; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xCA:
						file.Read(w, 6);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C are set/clear (dep. on high bit), branch to D", w[0], w[1], w[2], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 3; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xCB:
						file.Read(w, 8);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D are set/clear (dep. on high bit), branch to E", w[0], w[1], w[2], w[3], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 4; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xCC:
						file.Read(w, 10);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E are set/clear (dep. on high bit), branch to F", w[0], w[1], w[2], w[3], w[4], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 5; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xCD:
						file.Read(w, 12);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F are set/clear (dep. on high bit), branch to G", w[0], w[1], w[2], w[3], w[4], w[5], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 6; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xCE:
						file.Read(w, 14);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F&G are set/clear (dep. on high bit), branch to H", w[0], w[1], w[2], w[3], w[4], w[5], w[6], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 7; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xCF:
						file.Read(w, 16);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8, w[7]&0x00FF, w[7]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F&G&H are set/clear (dep. on high bit), branch to I", w[0], w[1], w[2], w[3], w[4], w[5], w[6], w[7], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 8; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								w[7] & 0x7FFF, (w[7] & 0x7FFF) / 8 + 0x1E80, w[7] & 7, s[7],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xD0:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ;   Set event bit $7E1E80+(A/8) ($0%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1E80, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set event bit $1E80($0%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xD1:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear event bit $7E1E80+(A/8) ($0%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1E80, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear event bit $1E80($0%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xD2:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ;   Set event bit $7E1EA0+(A/8) ($1%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set event bit $1E80($1%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
							if (b[0] == 0xCE) t += " (Enables party switching with the Y button)";
							outFile << t;
						}
						break;

					case 0xD3:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear event bit $7E1EA0+(A/8) ($1%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear event bit $1E80($1%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
							if (b[0] == 0xCE) t += " (Disables party switching with the Y button)";
							outFile << t;
						}
						break;

					case 0xD4:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ;   Set event bit $7E1EC0+(A/8) ($2%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set event bit $1E80($2%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xD5:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear event bit $7E1EC0+(A/8) ($2%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear event bit $1E80($2%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xD6:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ;   Set event bit $7E1EE0+(A/8) ($3%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1EE0, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set event bit $1E80($3%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EE0, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xD7:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear event bit $7E1EE0+(A/8) ($3%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1EE0, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear event bit $1E80($3%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EE0, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xD8:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ;   Set event bit $7E1F00+(A/8) ($4%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1F00, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set event bit $1E80($4%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F00, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xD9:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear event bit $7E1F00+(A/8) ($4%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1F00, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear event bit $1E80($4%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F00, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xDA:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ;   Set event bit $7E1F20+(A/8) ($5%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1F20, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set event bit $1E80($5%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F20, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xDB:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear event bit $7E1F20+(A/8) ($5%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1F20, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear event bit $1E80($5%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F20, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xDC:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ;   Set event bit $7E1F40+(A/8) ($6%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1F40, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set event bit $1E80($6%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F40, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xDD:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear event bit $7E1F40+(A/8) ($6%02X) [$%04X, bit %d]", b[0], b[0], b[0] / 8 + 0x1F40, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear event bit $1E80($6%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F40, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xDE:
						if(lEnXkas)
						{
							outFile << "; Load CaseWord with the characters in the currently active party";
						}
						if(lEnTxt)
						{
							outFile << "Load CaseWord with the characters in the currently active party?";
							CharactersInCaseWord = TRUE;
						}
						break;

					case 0xDF:
						if(lEnXkas)
						{
							outFile << "; Load CaseWord with the characters who have been created?";
						}
						if(lEnTxt)
						{
							outFile << "Load CaseWord with the characters who have been created?";
							CharactersInCaseWord = TRUE;
						}
						break;

					case 0xE0:
						if(lEnXkas)
						{
							outFile << "; Load CaseWord with the characters encountered so far?";
						}
						if(lEnTxt)
						{
							outFile << "Load CaseWord with characters encountered so far?";
							CharactersInCaseWord = TRUE;
						}
						break;

					case 0xE1:
						if(lEnXkas)
						{
							outFile << "; Load CaseWord with the characters who are collected (excludes Veldt-jumped Gau)";
						}
						if(lEnTxt)
						{
							outFile << "Load CaseWord with characters who are collected (excludes Veldt-jumped Gau)";
							CharactersInCaseWord = TRUE; //although this may be wrong
						}
						break;

					case 0xE2:
						if(lEnXkas)
						{
							outFile << "; Set bit in CaseWord for the lead character in the current party";
						}
						if(lEnTxt)
						{
							outFile << "Set bit in CaseWord for the lead character in the current party";
							CharactersInCaseWord = TRUE;
						}
						break;

					case 0xE3:
						if(lEnXkas)
						{
							outFile << "; Load CaseWord with available characters?";
						}
						if(lEnTxt)
						{
							outFile << "Load CaseWord with available characters?";
							CharactersInCaseWord = TRUE;
						}
						break;

					case 0xE4:
						if(lEnXkas)
						{
							outFile << "; Set CaseWord bit corresponding to the number of the currently active party";
						}
						if(lEnTxt)
						{
							outFile << "Set CaseWord bit corresponding to the number of the currently active party";
							CharactersInCaseWord = FALSE;
						}
						break;

					case 0xE5:
						if(lEnXkas)
						{
							outFile << "; Unknown command";
						}
						if(lEnTxt)
						{
							outFile << "Command $E5";
						}
						break;

					case 0xE6:
						if(lEnXkas)
						{
							outFile << "; Unknown command";
						}
						if(lEnTxt)
						{
							outFile << "Command $E6";
						}
						break;

					case 0xE7:
						file.Read(b, 1);
						
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Show portrait for character A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(b[0] >= 0x00 && b[0] < 0x0E)
								s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
							else if(b[0] >= 0x0E && b[0] < 0x10)
								s[0].Format("Actor in slot %d", b[0]);
							else if(b[0] >= 0x10 && b[0] <= 0x2F)
								s[0].Format("NPC $%02X", b[0]);
							else if(b[0] == 0x30)
								s[0].Format("Camera");
							else if(b[0] >= 0x31 && b[0] <= 0x34)
								s[0].Format("Party Character %d", b[0] - 0x31);
							else
								s[0] = "<Invalid Character>";
							
							t.Format("Show portrait for character $%02X (%s)", b[0], s[0]);
							outFile << t;
						}
						break;

					case 0xE8:
						file.Read(b, 1);
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", b[0], w[0]&0x00FF, w[0]>>8);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DW $%04X ; Set word ($1FC2 + 2*A) to B", b[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set word $1FC2($%02X) [$%04X] to $%04X", b[0], 0x1FC2 + b[0] * 2, w[0]);
							outFile << t;
						}
						break;

					case 0xE9:
						file.Read(b, 1);
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", b[0], w[0]&0x00FF, w[0]>>8);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DW $%04X ; Increment word ($1FC2 + 2*A) by B", b[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Increment word $1FC2($%02X) [$%04X] by $%04X", b[0], 0x1FC2 + b[0] * 2, w[0]);
							outFile << t;
						}
						break;

					case 0xEA:
						file.Read(b, 1);
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", b[0], w[0]&0x00FF, w[0]>>8);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DW $%04X ; Decrement word ($1FC2 + 2*A) by B", b[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Decrement word $1FC2($%02X) [$%04X] by $%04X", b[0], 0x1FC2 + b[0] * 2, w[0]);
							outFile << t;
						}
						break;

					case 0xEB:
						file.Read(b, 1);
						file.Read(w, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", b[0], w[0]&0x00FF, w[0]>>8);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DW $%04X ; Compare word ($1FC2 + 2*A) to B,set $1A0 for equal to, $1A1 for greater than, $1A2 for less than", b[0], w[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Compare word $1FC2($%02X) [$%04X] to $%04X, set $1A0 for equal to, $1A1 for greater than, $1A2 for less than", b[0], 0x1FC2 + b[0] *2, w[0]);
							CharactersInCaseWord = FALSE;
							outFile << t;
						}
						break;

					case 0xEC:
						if(lEnTxt)
						{
							outFile << "Command EC";
						}
						break;

					case 0xED:
						file.Read(b, 2);
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Add/Subtract to Skill of Character A, skill/amount B (See breakdown)", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Command ED";
						}
						break;

					case 0xEE:
						if(lEnTxt)
						{
							outFile << "Command EE";
						}
						break;

					case 0xEF:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							if ((b[0] & 0x7F) <= 84)
								s[0] = g_strSongNames[(b[0] & 0x7F)];
							else 
								s[0] = "<invalid song>";

							if ((b[0] & 0x80) == 0x80)
								s[1] = "set";
							else
								s[1] = "clear";
							
							t.Format(": DB $%02X : DB $%02X ; Play song A (%s), (high bit %s) volume B (%03.2f%%)", b[0], b[1], s[0], s[1], b[1] / 0xFF);
							outFile << t;
						}
						if(lEnTxt)
						{
							if ((b[0] & 0x7F) <= 84)
								s[0] = g_strSongNames[(b[0] & 0x7F)];
							else 
								s[0] = "<invalid song>";

							if ((b[0] & 0x80) == 0x80)
								s[1] = "set";
							else
								s[1] = "clear";

							t.Format("Play song %d (%s), (high bit %s) volume %02f%%", (b[0] & 0x7F), s[0], s[1], b[1] / 0xFF);
							outFile << t;
						}
						break;

					case 0xF0:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
						
							if ((b[0] & 0x7F) <= 84)
								s[0] = g_strSongNames[(b[0] & 0x7F)];
							else 
								s[0] = "<invalid song>";

							if ((b[0] & 0x80) == 0x80)
								s[1] = "set";
							else
								s[1] = "clear";

							t.Format(": DB $%02X ; Play song A (%s), (high bit %s), full volume", b[0], s[0], s[1]);
							outFile << t;

						}

						if(lEnTxt)
						{
							if ((b[0] & 0x7F) <= 84)
								s[0] = g_strSongNames[(b[0] & 0x7F)];
							else 
								s[0] = "<invalid song>";

							if ((b[0] & 0x80) == 0x80)
								s[1] = "set";
							else
								s[1] = "clear";

							t.Format("Play song %d (%s), (high bit %s), full volume", (b[0] & 0x7F), s[0], s[1]);
							outFile << t;
						}
						break;

					case 0xF1:
						file.Read(b, 2);

						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Fade in song A (%s) (high bit %s) with transition time  B (%d)", b[0], b[1], s[0], s[1], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							if ((b[0] & 0x7F) <= 84)
								s[0] = g_strSongNames[(b[0] & 0x7F)];
							else 
								s[0] = "<invalid song>";

							if ((b[0] & 0x80) == 0x80)
								s[1] = "set";
							else
								s[1] = "clear";

							t.Format("Fade in song %d (%s) (high bit %s) with transition time %d", (b[0] & 0x7F), s[0], s[1], b[1]);
							outFile << t;
						}
						break;

					case 0xF2:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Fade out current song with trans. time A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Fade out current song with transition time %d", b[0]);
							outFile << t;
						}
						break;

					case 0xF3:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Fade in prev. faded out song with trans. time A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Fade in previously faded out song with transition time %d", b[0]);
							outFile << t;
						}
						break;

					case 0xF4:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Play sound effect A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Play sound effect %d", b[0]);
							outFile << t;
						}
						break;

					case 0xF5:
						file.Read(b, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X : DB $%02X ; Play sound effect A, with trans. time B and spekaer balance C ($80 is center, values increase left to right)", b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Play sound effect %d, with transition time %d and spekaer balance $%02X ($80 is center, values increase left to right)", b[0], b[1], b[2]);
							outFile << t;
						}
						break;

					case 0xF6:
						file.Read(b, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X", b[0], b[1], b[2]);
							outFile << t;
						}
						if(lEnXkas)
						{
							if (b[0] == 0x10)
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: Play song $%02X (%s) at vol. $%02X (may have other effects)", b[0], b[1], b[2], b[0], b[1], g_strSongNames[(b[1] & 0x7F)], b[2]);
							else if (b[0] == 0x11)
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: Play song $%02X (%s) at vol. $%02X (with unknown other effects)", b[0], b[1], b[2], b[0], b[1], g_strSongNames[(b[1] & 0x7F)], b[2]);
							else if (b[0] == 0x80)
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: Set vol. of currently playing song and SFXs to $%02X, trans. time %d", b[0], b[1], b[2],  b[0], b[2], b[1]);
							else if (b[0] == 0x81)
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: Change vol. of currently playing song to $%02X, trans. time %d", b[0], b[1], b[2], b[0], b[2], b[1]); 
							else if (b[0] == 0x82)
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: Change vol. of currently playing SFX to $%02X, trans. time %d", b[0], b[1], b[2], b[0], b[2], b[1]); 
							else if (b[0] == 0x83)
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: Change pan control of currently playing SFX to $%02X, trans. time %d ($80 is center, values increase left to right)", b[0], b[1], b[2], b[0], b[2], b[1]);
							else if (b[0] == 0x84)
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: Change tempo of currently playing song by %3d, trans. time %d", b[0], b[1], b[2], b[0], b[2], b[1]);
							else if (b[0] == 0x85)
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: Change pitch of currently playing song by %3d, trans. time %d", b[0], b[1], b[2], b[0], b[2], b[1]);
							else if (b[0] == 0xF1)
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: Stop currently playing song, unused bytes $%02X, $%02X", b[0], b[1], b[2], b[0], b[2], b[1]);
							else if (b[0] == 0xF2)
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: Stop currently playing SFX, unused bytes $%02X, $%02X", b[0], b[1], b[2], b[0], b[2], b[1]);
							else
								t.Format(": DB $%02X : DB $%02X : DB $%02X ; Subcommand $%02X: unknown bytes $%02X, $%02X", b[0], b[1], b[2], b[0], b[1], b[2]);

							outFile << t;
						}
						if(lEnTxt)
						{
							if (b[0] == 0x10)
								t.Format("Subcommand $%02X: Play song $%02X (%s) at volume $%02X (may have other effects)", b[0], b[1], g_strSongNames[(b[1] & 0x7F)], b[2]);
							else if (b[0] == 0x11)
								t.Format("Subcommand $%02X: Play song $%02X (%s) at volume $%02X (with unknown other effects)", b[0], b[1], g_strSongNames[(b[1] & 0x7F)], b[2]);
							else if (b[0] == 0x80)
								t.Format("Subcommand $%02X: Set volume of currently playing song and sound effects to $%02X, transistion time %d",  b[0], b[2], b[1]);
							else if (b[0] == 0x81)
								t.Format("Subcommand $%02X: Change volume of currently playing song to $%02X, transition time %d", b[0], b[2], b[1]); 
							else if (b[0] == 0x82)
								t.Format("Subcommand $%02X: Change volume of currently playing sound effect to $%02X, transition time %d", b[0], b[2], b[1]); 
							else if (b[0] == 0x83)
								t.Format("Subcommand $%02X: Change pan control of currently playing sound effect to $%02X, transition time %d ($80 is center, values increase left to right)", b[0], b[2], b[1]);
							else if (b[0] == 0x84)
								t.Format("Subcommand $%02X: Change tempo of currently playing song by %3d, transition time %d", b[0], b[2], b[1]);
							else if (b[0] == 0x85)
								t.Format("Subcommand $%02X: Change pitch of currently playing song by %3d, transition time %d", b[0], b[2], b[1]);
							else if (b[0] == 0xF1)
								t.Format("Subcommand $%02X: Stop currently playing song, unused bytes $%02X, $%02X", b[0], b[2], b[1]);
							else if (b[0] == 0xF2)
								t.Format("Subcommand $%02X: Stop currently playing sound effect, unused bytes $%02X, $%02X", b[0], b[2], b[1]);
							else
								t.Format("Subcommand $%02X: unknown bytes $%02X, $%02X", b[0], b[1], b[2]);

							outFile << t;
						}
						break;

					case 0xF7:
						if(lEnXkas)
						{
							outFile << "; End most recent loop of currently playing song";
						}
						if(lEnTxt)
						{
							outFile << "End most recent loop of currently playing song";
						}
						break;

					case 0xF8:
						if(lEnTxt)
						{
							outFile << "Command $F8";
						}
						break;

					case 0xF9:
						file.Read(b, 1);

						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Pause execution until music passes through point A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Pause execution until the music passes through predetermined point $%02X", b[0]);
							outFile << t;
						}
						break;

					case 0xFA:
						if(lEnXkas)
						{
							outFile << "; Stop temporarily played song";
						}
						if(lEnTxt)
						{
							outFile << "Stop temporarily played song";
						}
						break;

					case 0xFB:
						if(lEnXkas)
						{
							outFile << "; Apply a special effect (echo) to the currently playing sound effect";
						}
						if(lEnTxt)
						{
							outFile << "Apply a special effect (echo?) to the currently playing sound effect";
						}
						break;
					case 0xFC:
						file.Read(b, 1);
						if (b[0] == 0x00)
						{
							s[0] = "Event Script";
							eventScript = TRUE;
							characterScript = FALSE;
							vehicleScript = FALSE;
							mapScript = FALSE;
						}
						else if (b[0] == 0x01)
						{
							s[0] = "Character Script";
							eventScript = FALSE;
							characterScript = TRUE;
							vehicleScript = FALSE;
							mapScript = FALSE;
						}
						else if (b[0] == 0x02)
						{
							s[0] = "Vehicle Script";
							eventScript = FALSE;
							characterScript = FALSE;
							vehicleScript = TRUE;
							mapScript = FALSE;
						}
						else if (b[0] == 0x03)
						{
							s[0] = "Map Script";
							eventScript = FALSE;
							characterScript = FALSE;
							vehicleScript = FALSE;
							mapScript = TRUE;
						}
						else
							s[0] = "Invalid script";
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Manual script change to A (%s)", b[0], s[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Manual script change to %s", s[0]);
							outFile << t;
						}
						break;
					case 0xFD:
						if(lEnXkas)
						{
							outFile << "; No operation";
						}
						if(lEnTxt)
						{
							outFile << "No operation";
						}
						break;
					case 0xFE:
						if(lEnXkas)
						{
							outFile << "; Return" << endl;
						}
						if(lEnTxt)
						{
							outFile << "Return" << endl;
						}
						break;
					case 0xFF:
						if(lEnXkas)
						{
							outFile << "; End script" << endl;
						}
						if(lEnTxt)
						{
							outFile << "End script" << endl;
						}

					default:
						if(opcode >= 0x00 && opcode <= 0x34)
						{
							file.Read(b, 1);

							lBakPtr = file.GetPosition();
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;

								outFile << endl;					
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Begin act. queue for char., A&0x7F bytes long (if high bit set, wait 'til complete)", b[0]);
								outFile << t;
							}
							if(lEnTxt)
							{
								if(lEnBytes)
								{
									file.Seek(lBakPtr, CFile::begin);
								}
								if(opcode >= 0x00 && opcode < 0x0E)
									s[0] = FixedTextToCString(characters[opcode].name, 6, TAG_END, 0);
								else if(opcode >= 0x0E && opcode < 0x10)
									s[0].Format("PC $%02X",opcode);
								else if(opcode >= 0x10 && opcode <= 0x2F)
									s[0].Format("NPC $%02X", opcode);
								else if(opcode == 0x30)
									s[0].Format("Camera");
								else if(opcode >= 0x31 && opcode <= 0x34)
									s[0].Format("Party Character %d", opcode - 0x31);
								else
									s[0] = "<Invalid Character>";

								if(b[0] & 0x80) s[1] = "(Wait until complete)"; else s[1] = "";
								t.Format("Begin action queue for character $%02X (%s), %d bytes long %s", opcode, s[0], b[0] & 0x7F, s[1]);
								outFile << t;
							}
							opcode = 0;

							eventScript = FALSE;
							//mapScript = TRUE;
							characterScript = TRUE;
							opcode = 0;

							dwQueueStart = file.GetPosition();
							bQueueLen = (b[0] & 0x7F);
						
						}
						break;
					
				}
				outFile << endl; 
			}
			while(eventScript && (dwOffset < SCRIPT_END));//end while(eventScript)
			
		}//end if (eventScript)

		else if(characterScript)
		{
		/*	if((file.GetPosition() >= (dwQueueStart + bQueueLen)))
			{
				characterScript = FALSE;
				eventScript = TRUE;
			}
		*/
			while(/*(file.GetPosition() < (dwQueueStart + bQueueLen)) && */(characterScript))
			{
				for(int i = 0; i < 16; i++)
				{
					b[i] = w[i] = d[i] = 0;
					s[i].Empty();
				}

				if((file.GetPosition() >= (dwQueueStart + bQueueLen)))
				{
					characterScript = FALSE;
					eventScript = TRUE;
					break;
				}

				onFoot ? s[15] = "character" : s[15] = "vehicle/entity";

				dwOffset = file.GetPosition();
				pc = dwOffset + 0xC00000 - nHeader;

				file.Read(&opcode, 1);
				if(lEnBytes || lEnTxt)
					t.Format("%02X/%04X: %02X        ", (pc & 0xFF0000) >> 16, pc & 0xFFFF, opcode);
				else // (lEnXkas)
					t.Format("Old%06X: DB $%02X     ", pc, opcode);

				if (B0Loop)
					t += "    ";
				outFile << t;

				switch(opcode)
				{
					case 0x80:
						if(lEnXkas)
						{
							t.Format("; Move up 1 tile");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 1 tile", s[15]);
							outFile << t;
						}
						break;
					case 0x81:
						if(lEnXkas)
						{
							t.Format("; Move right 1 tile");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 1 tile", s[15]);
							outFile << t;
						}
						break;
					case 0x82:
						if(lEnXkas)
						{
							t.Format("; Move down 1 tile");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 1 tile", s[15]);
							outFile << t; 
						}
						break;
					case 0x83:
						if(lEnXkas)
						{
							t.Format("; Move left 1 tile");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 1 tile", s[15]);
							outFile << t; 
						}
						break;

					case 0x84:
						if(lEnXkas)
						{
							t.Format("; Move up 2 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 2 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x85:
						if(lEnXkas)
						{
							t.Format("; Move right 2 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 2 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x86:
						if(lEnXkas)
						{
							t.Format("; Move down 2 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 2 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x87:
						if(lEnXkas)
						{
							t.Format("; Move left 2 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 2 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x88:
						if(lEnXkas)
						{
							t.Format("; Move up 3 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 3 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x89:
						if(lEnXkas)
						{
							t.Format("; Move right 3 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 3 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x8A:
						if(lEnXkas)
						{
							t.Format("; Move down 3 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 3 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x8B:
						if(lEnXkas)
						{
							t.Format("; Move left 3 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 3 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x8C:
						if(lEnXkas)
						{
							t.Format("; Move up 4 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 4 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x8D:
						if(lEnXkas)
						{
							t.Format("; Move right 4 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 4 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x8E:
						if(lEnXkas)
						{
							t.Format("; Move down 4 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 4 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x8F:
						if(lEnXkas)
						{
							t.Format("; Move left 4 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 4 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x90:
						if(lEnXkas)
						{
							t.Format("; Move up 5 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 5 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x91:
						if(lEnXkas)
						{
							t.Format("; Move right 5 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 5 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x92:
						if(lEnXkas)
						{
							t.Format("; Move down 5 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 5 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x93:
						if(lEnXkas)
						{
							t.Format("; Move left 5 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 5 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x94:
						if(lEnXkas)
						{
							t.Format("; Move up 6 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 6 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x95:
						if(lEnXkas)
						{
							t.Format("; Move right 6 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 6 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x96:
						if(lEnXkas)
						{
							t.Format("; Move down 6 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 6 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x97:
						if(lEnXkas)
						{
							t.Format("; Move left 6 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 6 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x98:
						if(lEnXkas)
						{
							t.Format("; Move up 7 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 7 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x99:
						if(lEnXkas)
						{
							t.Format("; Move right 7 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 7 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x9A:
						if(lEnXkas)
						{
							t.Format("; Move down 7 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 7 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x9B:
						if(lEnXkas)
						{
							t.Format("; Move left 7 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 7 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x9C:
						if(lEnXkas)
						{
							t.Format("; Move up 8 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 8 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x9D:
						if(lEnXkas)
						{
							t.Format("; Move right 8 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 8 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x9E:
						if(lEnXkas)
						{
							t.Format("; Move down 8 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 8 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x9F:
						if(lEnXkas)
						{
							t.Format("; Move left 8 tiles");
							outFile << t; 
						}						
						if(lEnTxt)
						{
							t.Format("Move %s left 8 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0xA0:			
						if(lEnXkas)
						{
							t.Format("; Move right/up 1x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/up 1x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA1:
						if(lEnXkas)
						{
							t.Format("; Move right/down 1x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/down 1x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA2:
						if(lEnXkas)
						{
							t.Format("; Move left/down 1x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/down 1x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA3:
						if(lEnXkas)
						{
							t.Format("; Move left/up 1x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/up 1x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA4:
						if(lEnXkas)
						{
							t.Format("; Move right/up 1x2 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/up 1x2 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA5:
						if(lEnXkas)
						{
							t.Format("; Move right/up 2x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/up 2x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA6:
						if(lEnXkas)
						{
							t.Format("; Move right/down 2x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/down 2x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA7:
						if(lEnXkas)
						{
							t.Format("; Move right/down 1x2 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/down 1x2 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA8:
						if(lEnXkas)
						{
							t.Format("; Move left/down 1x2 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/down 1x2 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA9:
						if(lEnXkas)
						{
							t.Format("; Move left/down 2x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/down 2x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xAA:
						if(lEnXkas)
						{
							t.Format("; Move left/up 2x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/up 2x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xAB:
						if(lEnXkas)
						{
							t.Format("; Move left/up 1x2 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/up 1x2 tiles", s[15]);
							outFile << t; 
						}
						break;

				// Conditionality commands != fun
					case 0xB0:
						file.Read(w, 2);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DL Old%06X-$CA0000 ; If bit A&0x7FFF is set/clear (based on high bit), branch to B", w[0], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(w[0] & 0x8000) s[0] = "is set"; else s[0] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}

						break;

					case 0xB1:
						file.Read(w, 4);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B are set/clear (based on high bits), branch to C", w[0], w[1], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 2; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB2:
						file.Read(w, 6);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C are set/clear (based on high bits), branch to D", w[0], w[1], w[2], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 3; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB3:
						file.Read(w, 8);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D are set/clear (based on high bits), branch to E", w[0], w[1], w[2], w[3], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 4; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB4:
						file.Read(w, 10);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E are set/clear (based on high bits), branch to F", w[0], w[1], w[2], w[3], w[4], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 5; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB5:
						file.Read(w, 12);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E|F are set/clear (based on high bits), branch to G", w[0], w[1], w[2], w[3], w[4], w[5], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 6; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB6:
						file.Read(w, 14);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E|F|G are set/clear (based on high bits), branch to H", w[0], w[1], w[2], w[3], w[4], w[5], w[6], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 7; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB7:
						file.Read(w, 16);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8, w[7]&0x00FF, w[7]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E|F|G|H are set/clear (based on high bits), branch to I", w[0], w[1], w[2], w[3], w[4], w[5], w[6], w[7], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 8; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";


							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								w[7] & 0x7FFF, (w[7] & 0x7FFF) / 8 + 0x1E80, w[7] & 7, s[7],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB8:
						file.Read(w, 2);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DL Old%06X-$CA0000 ; If bit A&0x7FFF is set/clear (based on high bit), branch to B", w[0], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(w[0] & 0x8000) s[0] = "is set"; else s[0] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB9:
						file.Read(w, 4);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B are set/clear (based on high bits), branch to C", w[0], w[1], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 2; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBA:
						file.Read(w, 6);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C are set/clear (based on high bits), branch to D", w[0], w[1], w[2], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 3; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBB:
						file.Read(w, 8);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D are set/clear (based on high bits), branch to E", w[0], w[1], w[2], w[3], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 4; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBC:
						file.Read(w, 10);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E are set/clear (based on high bits), branch to F", w[0], w[1], w[2], w[3], w[4], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 5; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBD:
						file.Read(w, 12);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F are set/clear (based on high bits), branch to G", w[0], w[1], w[2], w[3], w[4], w[5], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 6; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBE:
						file.Read(w, 14);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F&G are set/clear (based on high bits), branch to H", w[0], w[1], w[2], w[3], w[4], w[5], w[6], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 7; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBF:
						file.Read(w, 16);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8, w[7]&0x00FF, w[7]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F&G&H are set/clear (based on high bits), branch to I", w[0], w[1], w[2], w[3], w[4], w[5], w[6], w[7], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 8; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								w[7] & 0x7FFF, (w[7] & 0x7FFF) / 8 + 0x1E80, w[7] & 7, s[7],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xC0:
						if(lEnXkas)
						{
							outFile << "; Set event speed to slowest";
						}
						if(lEnTxt)
						{
							t.Format("Set %s's event speed to slowest", s[15]);
							outFile << t; 
						}
						break;

					case 0xC1:
						if(lEnXkas)
						{
							outFile << "; Set event speed to slow";
						}
						if(lEnTxt)
						{
							t.Format("Set %s's event speed to slow", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xC2:
						if(lEnXkas)
						{
							outFile << "; Set event speed to normal";
						}
						if(lEnTxt)
						{
							t.Format("Set %s's event speed to normal", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xC3:
						if(lEnXkas)
						{
							outFile << "; Set event speed to fast";
						}
						if(lEnTxt)
						{
							t.Format("Set %s's event speed to fast", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xC4:
						if(lEnXkas)
						{
							outFile << "; Set event speed to faster";
						}
						if(lEnTxt)
						{
							t.Format("Set %s's event speed to faster", s[15]);
							outFile << t; 
						}
						break;

					case 0xC5:
						if(lEnXkas)
						{
							outFile << "; Set event speed to fastest";
						}
						if(lEnTxt)
						{
							t.Format("Set %s's event speed to fastest", s[15]);
							outFile << t; 
						}
						break;

					case 0xC6:
						if(lEnXkas)
						{
							outFile << "; Set entity to walk when moving";
						}
						if(lEnTxt)
						{
							t.Format("Set %s to walk when moving", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xC7:
						if(lEnXkas)
						{
							outFile << "; Set entity to stay still when moving";
						}
						if(lEnTxt)
						{
							t.Format("Set %s to stay still when moving", s[15]);
							outFile << t; 
						}
						break;

					case 0xC8:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%04X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Set object layering priority to A (low nibble unknown)", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set object layering priority to %d, (low nibble %d)", (b[0] & 0xF0 >> 4), (b[0] & 0x0F));
							outFile << t;
						}
						break;
					case 0xC9:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%04X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Place object on vehicle A", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Place object on vehicle $%02X [to decode later]", b[0]);
							outFile << t;
						}
						break;

					case 0xCC:
						if(lEnXkas)
						{
							t.Format("; Turn object upward");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Turn %s up", s[15]);
							outFile << t;
						}
						break;
					
					case 0xCD:
						if(lEnXkas)
						{
							t.Format("; Turn object right");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Turn %s right", s[15]);
							outFile << t;
						}
						break;
					
					case 0xCE:
						if(lEnXkas)
						{
							t.Format("; Turn object downward");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Turn %s down", s[15]);
							outFile << t;
						}
						break;
					
					case 0xCF:
						if(lEnXkas)
						{
							t.Format("; Turn object left");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Turn %s left", s[15]);
							outFile << t;
						}
						break;

					case 0xD0:
						if(lEnXkas)
						{
							t.Format("; Make object visible");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Make %s visible", s[15]);
							outFile << t;
						}
						break;
					
					case 0xD1:
						if(lEnXkas)
						{
							t.Format("; Make object disappear");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Make %s disappear", s[15]);
							outFile << t;
						}
						break;

					case 0xD2:
						if(lEnXkas)
						{
							t.Format("; Unknown command");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Queue command $D2";
						}
						break;

					case 0xD3:
						if(lEnXkas)
						{
							t.Format("; Unknown command");
							outFile << t;
						}
						if(lEnTxt)
						{
							outFile << "Queue command $D3";							
						}
						break;

					case 0xD4:
						file.Read(d, 3);
						if(lEnBytes)
						{
							t.Format("%06X", d[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DL Old%06X-$CA0000 ; If ($08 & 0x80 == 0), branch to address A", d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							// I'm not sure if this is right
							t.Format("If ($08 & 0x80 == 0), branch to $%06X", (d[0] + 0xCA0000));						
							outFile << t;
						}
						break;

					case 0xD5:
						file.Read(b, 2);
						if(lEnBytes)
						{
							t.Format("%02X%02X", b[0], b[1]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X : DB $%02X ; Set position to A,B", b[0], b[1]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set %s's position to (%d, %d)", s[15], b[0], b[1]);
							outFile << t;
						}
						break;

					case 0xD6:
						if(lEnXkas)
						{
							outFile << "; Unknown command";
						}
						if(lEnTxt)
						{
							outFile << "Queue command $D6";							
						}
						break;

					case 0xD7:
						if(lEnXkas)
						{
							outFile << "; Center screen on entity";
						}
						if(lEnTxt)
						{
							t.Format("Center screen on %s", s[15]);
							outFile << t;
						}
						break;
						
					case 0xD8:
						if(lEnXkas)
						{
							outFile << "; Unfade screen";
						}
						if(lEnTxt)
						{
							outFile << "Unfade screen";
						}
						break;
						
					case 0xD9:
						if(lEnXkas)
						{
							outFile << "; Fade screen";
						}
						if(lEnTxt)
						{
							outFile << "Fade screen";
						}
						break;
						
					case 0xDA:
						if(lEnXkas)
						{
							outFile << "; Unknown command";
						}
						if(lEnTxt)
						{
							outFile << "Queue command $DA";	
						}
						break;
						
					case 0xDB:
						if(lEnXkas)
						{
							outFile << "; Unknown command";
						}
						if(lEnTxt)
						{
							outFile << "Queue command $DB";
						}
						break;

					case 0xDC:
						if(lEnXkas)
						{
							outFile << "; Make entity jump low";
						}
						if(lEnTxt)
						{
							t.Format("Make %s jump (low)", s[15]);
							outFile << t;
						}
						break;
					
					case 0xDD:
						if(lEnXkas)
						{
							outFile << "; Make entity jump high";
						}
						if(lEnTxt)
						{
							t.Format("Make %s jump (high)", s[15]);
							outFile << t;
						}
						break;

					case 0xE0:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Pause for 4*A frames", b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Pause for 4 * %d (%d) frames", b[0], b[0] * 4);
							outFile << t;
						}
						break;

					case 0xE1:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Set event bit $7E1E80 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set event bit $1E80($0%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xE2:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Set event bit $7E1EA0 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set event bit $1E80($1%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xE3:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Set event bit $7E1EC0 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Set event bit $1E80($2%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xE4:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear event bit $7E1E80 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear event bit $1E80($0%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xE5:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear event bit $7E1EA0 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear event bit $1E80($1%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xE6:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Clear event bit $7E1EC0 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Clear event bit $1E80($2%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
							outFile << t;
						}
						break;

					case 0xE7:
						if(lEnXkas)
						{
							outFile << "; Unknown command";
						}
						if(lEnTxt)
						{
							outFile << "Queue command $E7";
						}
						break;

					case 0xF9:
						file.Read(d, 3);
						if(lEnBytes)
						{
							t.Format("%06X", d[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DL Old%06X-$CA0000 ; Branch out of queue to A", d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							// I'm not sure if this is right
							t.Format("Branch out of queue to $%06X", d[0] + 0xCA0000);
							outFile << t;
						}
						break;

					case 0xFA:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Pseudo-randomly branch A bytes backwards (Old%06X) with 50%% chance", b[0], pc - b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							//t.Format("Increment $1F6D and branch %d bytes backwards ($%06X) if ($C0FD00 + ($1F6D)) >= $80", b[0], pc - b[0]);
							t.Format("Pseudo-randomly choose to branch %d bytes backwards ($%06X) with 50 %% chance", b[0], pc - b[0]);
							outFile << t;
						}
						break;

					case 0xFB:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Pseudo-randomly branch A bytes forwards (Old%06X) with 50%% chance", b[0], pc + b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							//t.Format("Increment $1F6D and branch %d bytes forwards ($%06X) if ($C0FD00 + ($1F6D)) >= $80", b[0], pc + b[0]);
							t.Format("Pseudo-randomly choose to branch %d bytes forwards ($%06X) with 50 %% chance", b[0], pc + b[0]);
							outFile << t;
						}
						break;
					
					case 0xFC:
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Branch A bytes backwards (Old%06X)", b[0], pc - b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Branch %d bytes backwards ($%06X)", b[0], pc - b[0]);
							outFile << t;
						}
						break;
					
					case 0xFD:			
						file.Read(b, 1);
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DB $%02X ; Branch A bytes forwards (Old%06X)", b[0], pc + b[0]);
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Branch %d bytes forwards ($%06X)", b[0], pc + b[0]);
							outFile << t;
						}
						break;

					case 0xFE:
						if(lEnBytes)
						{
							t.Format("%02X", b[0]);
							outFile << t;
						}
						if(lEnXkas)
						{
							outFile << "; Return";
						}
						if(lEnTxt)
						{
							t.Format("Return");
							outFile << t;
						}
						characterScript = FALSE;
						eventScript = TRUE;
						//B0Loop = FALSE;
						break;

					case 0xFF:
						if(lEnXkas)
						{
							outFile << "; End queue";
						}
						if(lEnTxt)
						{
							outFile << "End queue";
						}
						characterScript = FALSE;
						eventScript = TRUE;
						//B0Loop = FALSE;
						
						break;
					
					default:
						if(lEnXkas)
						{
							outFile << "; Do graphical action of opcode";
						}
						if(lEnTxt)
						{
			
							if(opcode >= 0x00 && opcode <= 0x3F)
							{
								s[14].Empty();
								if (opcode == 0x09)
									s[14] = "(kneeling)";
								else if (opcode == 0x16)
									s[14] = "(facing forward, head cocked left)";

								t.Format("Do %s graphical action $%02X %s", s[15], opcode, s[14]);
								outFile << t;
							}
							else if(opcode >= 0x40 && opcode <= 0x7F)
							{
								t.Format("Do %s graphical action $%02X, flipped horizontally", s[15], opcode & 0x3F);
								outFile << t;
							}
							else
								outFile << "Invalid or unknown queue command";
						}

					}// end switch

					outFile << endl;

				}//end while

		} // end if (characterScript)

		else if (mapScript)
		{
			/*	if((file.GetPosition() >= dwQueueStart + bQueueLen))
				{
					mapScript = FALSE;
					eventScript = TRUE;
				}
			*/
				while(/*(file.GetPosition() < dwQueueStart + bQueueLen) && */(mapScript))
				{
					for(int i = 0; i < 16; i++)
					{
						b[i] = w[i] = d[i] = 0;
						s[i].Empty();
					}

					if ((tempFlag))
					{
						eventScript = TRUE;
						mapScript = FALSE;
						tempFlag = FALSE;
					}


					onFoot ? s[15] = "character" : s[15] = "vehicle/entity";

					dwOffset = file.GetPosition();
					pc = dwOffset + 0xC00000 - nHeader;
					
						

					file.Read(&opcode, 1);
					if(lEnTxt || lEnBytes)
						t.Format("%02X/%04X: %02X        ", (pc & 0xFF0000) >> 16, pc & 0xFFFF, opcode);
					else // (lEnXkas)
						t.Format("Old%06X: DB $%02X ", pc, opcode);

					if (B0Loop)
						t += "    ";
					outFile << t;

					switch(opcode)
					{
					case 0x80:
						if(lEnXkas)
						{
							t.Format("; Move up 1 tile");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 1 tile", s[15]);
							outFile << t;
						}
						break;
					case 0x81:
						if(lEnXkas)
						{
							t.Format("; Move right 1 tile");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 1 tile", s[15]);
							outFile << t;
						}
						break;
					case 0x82:
						if(lEnXkas)
						{
							t.Format("; Move down 1 tile");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 1 tile", s[15]);
							outFile << t; 
						}
						break;
					case 0x83:
						if(lEnXkas)
						{
							t.Format("; Move left 1 tile");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 1 tile", s[15]);
							outFile << t; 
						}
						break;

					case 0x84:
						if(lEnXkas)
						{
							t.Format("; Move up 2 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 2 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x85:
						if(lEnXkas)
						{
							t.Format("; Move right 2 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 2 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x86:
						if(lEnXkas)
						{
							t.Format("; Move down 2 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 2 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x87:
						if(lEnXkas)
						{
							t.Format("; Move left 2 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 2 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x88:
						if(lEnXkas)
						{
							t.Format("; Move up 3 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 3 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x89:
						if(lEnXkas)
						{
							t.Format("; Move right 3 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 3 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x8A:
						if(lEnXkas)
						{
							t.Format("; Move down 3 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 3 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x8B:
						if(lEnXkas)
						{
							t.Format("; Move left 3 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 3 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x8C:
						if(lEnXkas)
						{
							t.Format("; Move up 4 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 4 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x8D:
						if(lEnXkas)
						{
							t.Format("; Move right 4 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 4 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x8E:
						if(lEnXkas)
						{
							t.Format("; Move down 4 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 4 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x8F:
						if(lEnXkas)
						{
							t.Format("; Move left 4 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 4 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x90:
						if(lEnXkas)
						{
							t.Format("; Move up 5 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 5 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x91:
						if(lEnXkas)
						{
							t.Format("; Move right 5 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 5 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x92:
						if(lEnXkas)
						{
							t.Format("; Move down 5 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 5 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x93:
						if(lEnXkas)
						{
							t.Format("; Move left 5 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 5 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x94:
						if(lEnXkas)
						{
							t.Format("; Move up 6 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 6 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x95:
						if(lEnXkas)
						{
							t.Format("; Move right 6 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 6 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x96:
						if(lEnXkas)
						{
							t.Format("; Move down 6 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 6 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x97:
						if(lEnXkas)
						{
							t.Format("; Move left 6 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 6 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x98:
						if(lEnXkas)
						{
							t.Format("; Move up 7 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 7 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x99:
						if(lEnXkas)
						{
							t.Format("; Move right 7 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 7 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x9A:
						if(lEnXkas)
						{
							t.Format("; Move down 7 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 7 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x9B:
						if(lEnXkas)
						{
							t.Format("; Move left 7 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s left 7 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0x9C:
						if(lEnXkas)
						{
							t.Format("; Move up 8 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s up 8 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x9D:
						if(lEnXkas)
						{
							t.Format("; Move right 8 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s right 8 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x9E:
						if(lEnXkas)
						{
							t.Format("; Move down 8 tiles");
							outFile << t; 
						}
						if(lEnTxt)
						{
							t.Format("Move %s down 8 tiles", s[15]);
							outFile << t; 
						}
						break;
					case 0x9F:
						if(lEnXkas)
						{
							t.Format("; Move left 8 tiles");
							outFile << t; 
						}						
						if(lEnTxt)
						{
							t.Format("Move %s left 8 tiles", s[15]);
							outFile << t; 
						}
						break;

					case 0xA0:			
						if(lEnXkas)
						{
							t.Format("; Move right/up 1x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/up 1x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA1:
						if(lEnXkas)
						{
							t.Format("; Move right/down 1x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/down 1x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA2:
						if(lEnXkas)
						{
							t.Format("; Move left/down 1x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/down 1x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA3:
						if(lEnXkas)
						{
							t.Format("; Move left/up 1x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/up 1x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA4:
						if(lEnXkas)
						{
							t.Format("; Move right/up 1x2 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/up 1x2 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA5:
						if(lEnXkas)
						{
							t.Format("; Move right/up 2x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/up 2x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA6:
						if(lEnXkas)
						{
							t.Format("; Move right/down 2x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/down 2x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA7:
						if(lEnXkas)
						{
							t.Format("; Move right/down 1x2 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s right/down 1x2 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA8:
						if(lEnXkas)
						{
							t.Format("; Move left/down 1x2 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/down 1x2 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xA9:
						if(lEnXkas)
						{
							t.Format("; Move left/down 2x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/down 2x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xAA:
						if(lEnXkas)
						{
							t.Format("; Move left/up 2x1 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/up 2x1 tiles", s[15]);
							outFile << t; 
						}
						break;
					
					case 0xAB:
						if(lEnXkas)
						{
							t.Format("; Move left/up 1x2 tiles");
							outFile << t;
						}
						if(lEnTxt)
						{
							t.Format("Move %s left/up 1x2 tiles", s[15]);
							outFile << t; 
						}
						break;

				// Conditionality commands != fun
					case 0xB0:
						file.Read(w, 2);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DL Old%06X-$CA0000 ; If bit A&0x7FFF is set/clear (based on high bit), branch to B", w[0], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(w[0] & 0x8000) s[0] = "is set"; else s[0] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}

						break;

					case 0xB1:
						file.Read(w, 4);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B are set/clear (based on high bits), branch to C", w[0], w[1], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 2; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB2:
						file.Read(w, 6);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C are set/clear (based on high bits), branch to D", w[0], w[1], w[2], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 3; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB3:
						file.Read(w, 8);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D are set/clear (based on high bits), branch to E", w[0], w[1], w[2], w[3], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 4; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB4:
						file.Read(w, 10);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E are set/clear (based on high bits), branch to F", w[0], w[1], w[2], w[3], w[4], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 5; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB5:
						file.Read(w, 12);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E|F are set/clear (based on high bits), branch to G", w[0], w[1], w[2], w[3], w[4], w[5], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 6; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB6:
						file.Read(w, 14);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E|F|G are set/clear (based on high bits), branch to H", w[0], w[1], w[2], w[3], w[4], w[5], w[6], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 7; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB7:
						file.Read(w, 16);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8, w[7]&0x00FF, w[7]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E|F|G|H are set/clear (based on high bits), branch to I", w[0], w[1], w[2], w[3], w[4], w[5], w[6], w[7], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 8; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";


							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								w[7] & 0x7FFF, (w[7] & 0x7FFF) / 8 + 0x1E80, w[7] & 7, s[7],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB8:
						file.Read(w, 2);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DL Old%06X-$CA0000 ; If bit A&0x7FFF is set/clear (based on high bit), branch to B", w[0], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(w[0] & 0x8000) s[0] = "is set"; else s[0] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB9:
						file.Read(w, 4);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B are set/clear (based on high bits), branch to C", w[0], w[1], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 2; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBA:
						file.Read(w, 6);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C are set/clear (based on high bits), branch to D", w[0], w[1], w[2], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 3; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBB:
						file.Read(w, 8);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D are set/clear (based on high bits), branch to E", w[0], w[1], w[2], w[3], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 4; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBC:
						file.Read(w, 10);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E are set/clear (based on high bits), branch to F", w[0], w[1], w[2], w[3], w[4], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 5; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBD:
						file.Read(w, 12);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F are set/clear (based on high bits), branch to G", w[0], w[1], w[2], w[3], w[4], w[5], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 6; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBE:
						file.Read(w, 14);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F&G are set/clear (based on high bits), branch to H", w[0], w[1], w[2], w[3], w[4], w[5], w[6], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 7; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBF:
						file.Read(w, 16);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8, w[7]&0x00FF, w[7]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F&G&H are set/clear (based on high bits), branch to I", w[0], w[1], w[2], w[3], w[4], w[5], w[6], w[7], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 8; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								w[7] & 0x7FFF, (w[7] & 0x7FFF) / 8 + 0x1E80, w[7] & 7, s[7],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;						
						case 0xC0:
							if(lEnXkas)
							{
								outFile << "; Set event speed to slowest";
							}
							if(lEnTxt)
							{
								t.Format("Set %s's event speed to slowest", s[15]);
								outFile << t;
							}
							break;
						
						case 0xC1:
							if(lEnXkas)
							{
								outFile << "; Set event speed to slow";
							}
							if(lEnTxt)
							{
								t.Format("Set %s's event speed to slow", s[15]);
								outFile << t;
							}
							break;
						
						case 0xC2:
							if(lEnXkas)
							{
								outFile << "; Set event speed to normal";
							}
							if(lEnTxt)
							{
								t.Format("Set %s's event speed to normal", s[15]);
								outFile << t;
							}
							break;
						
						case 0xC3:
							if(lEnXkas)
							{
								outFile << "; Set event speed to fast";
							}
							if(lEnTxt)
							{
								t.Format("Set %s's event speed to fast", s[15]);
								outFile << t;
							}
							break;
						
						case 0xC4:
							if(lEnXkas)
							{
								outFile << "; Set event speed to faster";
							}
							if(lEnTxt)
							{
								t.Format("Set %s's event speed to faster", s[15]);
								outFile << t;
							}
							break;

												
						case 0xC5:
							if(lEnXkas)
							{
								outFile << "; Set event speed to fastest";
							}
							if(lEnTxt)
							{
								t.Format("Set %s's event speed to fastest", s[15]);
								outFile << t;
							}
							break;

						case 0xC6:
							if(lEnXkas)
							{
								outFile << "; Unknown command";
							}
							if(lEnTxt)
							{
								t.Format("Map commmand $C6");
								outFile << t;
							}
							break;
						
						case 0xC7:
							file.Read(b, 2);
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Unknown command, params A and B", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Map command $C7, $%02X, $%02X", b[0], b[1]);
								outFile << t;
							}
							break;

						case 0xC8:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%04X", w[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Set event bit $7E1E80 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Set bit $1E80($%02X) [$%04X, bit %d]", b[0], 0x1E80 + ((b[0] & 0xFFF8) >> 3), b[0] & 7);
								outFile << t;
							}
							break;
						case 0xC9:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%04X", w[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Clear event bit $7E1E80 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Clear bit $1E80($%02X) [$%04X, bit %d]", b[0], 0x1E80 + ((b[0] & 0xFFF8) >> 3), b[0] & 7);
								outFile << t;
							}
							break;

						case 0xCC:
							if(lEnXkas)
							{
								outFile << "; Turn entity upward";
							}
							if(lEnTxt)
							{
								t.Format("Turn %s up", s[15]);
								outFile << t;
							}
							break;
						
						case 0xCD:
							if(lEnXkas)
							{
								outFile << "; Turn entity right";
							}
							if(lEnTxt)
							{
								t.Format("Turn %s right", s[15]);
								outFile << t;
							}
							break;
						
						case 0xCE:
							if(lEnXkas)
							{
								outFile << "; Turn entity downward";
							}
							if(lEnTxt)
							{
								t.Format("Turn %s down", s[15]);
								outFile << t;
							}
							break;
						
						case 0xCF:
							if(lEnXkas)
							{
								outFile << "; Turn entity left";
							}
							if(lEnTxt)
							{
								t.Format("Turn %s left", s[15]);
								outFile << t;
							}
							break;

						case 0xD0:
							if(lEnXkas)
							{
								outFile << "; Make entity visible";
							}
							if(lEnTxt)
							{
								t.Format("Make %s visible", s[15]);
								outFile << t;
							}
							break;
						
						case 0xD1:
							if(lEnXkas)
							{
								outFile << "; Make entity disappear";
							}
							if(lEnTxt)
							{
								t.Format("Make %s disappear", s[15]);
								outFile << t;
							}
							break;
						 // I'm not sure if these 2 are correct, and they'd need some other massaging anyway...
						case 0xD2:
							file.Read(w, 2);
							file.Read(b, 3);
							
							if ((w[0] & 0x01FF) < 0x19F)
								s[1] = g_strLocationNames[(w[0] & 0x01FF)];
							else
								s[1] = "<unknown or out-of-range map index>";

							if (s[1][1] == '-')
								s[1] = "<in-range, but untested map index>";
							
							if ((w[0] & 0x0400) && (w[0] & 0x01FF < 0x0002))						
							{
									
								onFoot = FALSE; // maybe?	
								mapScript = TRUE;
								eventScript = FALSE;
								vehicleScript = FALSE;
							}
							else
							{
								mapScript = FALSE;
								eventScript = TRUE;
							}

							if (((w[0] & 0x01FF) < 0x0002) && (b[2] & 0x40))
							{
								vehicleScript = TRUE;
								eventScript = FALSE;
							}
							if(lEnXkas)
							{
								t.Format(": DW $%04X : DB $%02X : DB $%02X : DB $%02X ; Load map A&0x01FF, position (B,C), flags D", w[0], b[0], b[1], b[2]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Load map $%04X (%s), position (%02d, %02d), mode $%02X", (w[0] & 0x01FF), s[1], b[0], b[1], b[2]);
								outFile << t;
							}

							break;
							
						case 0xD3:
							file.Read(w, 2);
							file.Read(b, 3);
							
							if ((w[0] & 0x01FF) < 0x19F)
								s[1] = g_strLocationNames[(w[0] & 0x01FF)];
							else
								s[1] = "<unknown or out-of-range map index>";

							if (s[1][1] == '-')
								s[1] = "<in-range, but untested map index>";

							if ((w[0] & 0x0400) && (w[0] & 0x01FF < 0x0002))						
							{
									
								onFoot = FALSE; // maybe?	
								mapScript = TRUE;
								eventScript = FALSE;
								vehicleScript = FALSE;
							}
							else
							{
								mapScript = FALSE;
								eventScript = TRUE;
							}

							if (((w[0] & 0x01FF) < 0x0002) && (b[2] & 0x40))
							{
								vehicleScript = TRUE;
								eventScript = FALSE;
							}
							if(lEnXkas)
							{
								t.Format(": DW $%04X : DB $%02X : DB $%02X : DB $%02X ; Load map A&0x01FF, position (B,C), flags D", w[0], b[0], b[1], b[2]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Load map $%04X (%s), position (%02d, %02d), mode $%02X", (w[0] & 0x01FF), s[1], b[0], b[1], b[2]);
								outFile << t;
							}

							break;
							
						case 0xD4:
							file.Read(d, 3);
							if(lEnBytes)
							{
								t.Format("%06X", d[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DL Old%06X-$CA0000 ; If ($08 & 0x80 == 0), branch to A", d[0] + 0xCA0000);
								outFile << t;
							}
							if(lEnTxt)
							{
								// I'm not sure if this is right
								t.Format("If ($08 & 0x80 == 0), branch to $%06X", d[0] + 0xCA0000);
								outFile << t;
							}
							break;

						case 0xD5:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Set entity's position to (A, B)", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Set %s's position to (%d, %d)", s[15], b[0], b[1]);
								outFile << t;
							}
							break;

						case 0xD7:
							if(lEnXkas)
							{
								outFile << "; Center screen on entity";
							}
							if(lEnTxt)
							{
								t.Format("Center screen on %s", s[15]);
								outFile << t;
							}
							break;
							
						case 0xD8:
							if(lEnXkas)
							{
								outFile << "; Unfade screen";
							}
							if(lEnTxt)
							{
								outFile << "Unfade screen";
							}
							break;
							
						case 0xD9:
							if(lEnXkas)
							{
								outFile << "; Fade screen";
							}
							if(lEnTxt)
							{
								outFile << "Fade screen";
							}
							break;

						case 0xDC:
							if(lEnXkas)
							{
								outFile << "; Unknown command";
							}
							if(lEnTxt)
							{
								t.Format("Map command $DC");
								outFile << t;
							}
							break;
						
						case 0xDD:
							if(lEnXkas)
							{
								outFile << "; Show mini-map";
							}
							if(lEnTxt)
							{
								t.Format("Show mini-map");
								outFile << t;
							}
							break;

						case 0xDF:
							if(lEnXkas)
							{
								outFile << "; Hide mini-map";
							}
							if(lEnTxt)
							{
								t.Format("Hide mini-map");
								outFile << t;
							}
							break;

						case 0xE0:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Pause for A units", b[0]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Pause for %d units", b[0]);
								outFile << t;
							}
							break;

						case 0xE1:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Set event bit $7E1E80 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Set event bit $1E80($0%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
								outFile << t;
							}
							break;

						case 0xE2:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Set event bit $7E1EA0 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Set event bit $1E80($1%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
								outFile << t;
							}
							break;

						case 0xE3:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Set event bit $7E1EC0 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Set event bit $1E80($2%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
								outFile << t;
							}
							break;

						case 0xE4:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Clear event bit $7E1E80 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Clear event bit $1E80($0%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
								outFile << t;
							}
							break;

						case 0xE5:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Clear event bit $7E1EA0 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Clear event bit $1E80($1%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
								outFile << t;
							}
							break;

						case 0xE6:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Clear event bit $7E1EC0 + A/8 [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Clear event bit $1E80($2%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
								outFile << t;
							}
							break;

						case 0xF9:
							file.Read(d, 3);
							if(lEnBytes)
							{
								t.Format("%06X", d[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DL Old%06X-$CA0000 ; Branch out of queue to A", d[0] + 0xCA0000);
								outFile << t;
							}
							if(lEnTxt)
							{
								// I'm not sure if this is right
								t.Format("Branch out of queue to $%06X", d[0] + 0xCA0000);
								outFile << t;
							}
							break;

						case 0xFA:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Pseudo-randomly branch %d bytes backwards ($%06X) with 50%% chance", b[0], b[0], pc - b[0]);
								outFile << t;
							}
							if(lEnTxt)
							{
								//t.Format("Increment $1F6D and branch %d bytes backwards ($%06X) if ($C0FD00 + ($1F6D)) >= $80", b[0], pc - b[0]);
								t.Format("Pseudo-randomly choose to branch %d bytes backwards ($%06X) with 50%% chance", b[0], pc - b[0]);
								outFile << t;
							}
							break;

						case 0xFB:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Pseudo-randomly branch %d bytes forwards ($%06X) with 50%% chance", b[0], b[0], pc + b[0]);
								outFile << t;
							}
							if(lEnTxt)
							{
								//t.Format("Increment $1F6D and branch %d bytes forwards ($%06X) if ($C0FD00 + ($1F6D)) >= $80", b[0], pc + b[0]);
								t.Format("Pseudo-randomly choose to branch %d bytes forwards ($%06X) with 50%% chance", b[0], pc + b[0]);
								outFile << t;
							}
							break;
						
						case 0xFC:
							if(lEnXkas)
							{
								outFile << "; Change character to ship graphic";
							}
							if(lEnTxt)
							{
								t.Format("Change character to ship graphic");
								outFile << t;
							}
							break;
						
						case 0xFD:			
							if(lEnXkas)
							{
								outFile << "; Show Figaro Castle submerging";
							}
							if(lEnTxt)
							{
								t.Format("Show Figaro Castle submerging");
								outFile << t;
							}
							break;
						
						case 0xFE:			
							if(lEnXkas)
							{
								outFile << "; Show Figaro Castle emerging";
							}
							if(lEnTxt)
							{
								t.Format("Show Figaro Castle emerging");
								outFile << t;
							}
							break;												

						case 0xFF:
							if(lEnXkas)
							{
								outFile << "; End map script" << endl;
							}
							if(lEnTxt)
							{
								outFile << "End map script" << endl;
							}
							mapScript = FALSE;
							eventScript = TRUE;
							bQueueLen = 0;
							//B0Loop = FALSE;
							break;
						
						default:
							if(lEnXkas)
							{
								outFile << "; Do graphical action of opcode";
							}
							if(lEnTxt)
							{

								if ((pc == 0xCBD2EE))
								{
									eventScript = FALSE;
									mapScript = TRUE;
								}

								if(opcode >= 0x00 && opcode <= 0x3F)
								{
									t.Format("Do %s graphical action $%02X", s[15], opcode);
									outFile << t;
								}
								else if(opcode >= 0x40 && opcode <= 0x7F)
								{
									t.Format("Do %s graphical action $%02X, flipped horizontally", s[15], opcode & 0x3F);
									outFile << t;
								}
								else
									outFile << "Invalid or unknown map command";
							}
			
						}// end switch

						outFile << endl;

					}//end while

			} // end mapScript
			else //(vehicleScript)
			{
				
				while(vehicleScript)
				{
					for(int i = 0; i < 16; i++)
					{
						b[i] = w[i] = d[i] = 0;
						s[i].Empty();
					}

					dwOffset = file.GetPosition();
					pc = dwOffset + 0xC00000 - nHeader;

					file.Read(&opcode, 1);
					
					// special check for weird functions
					if(!lEnXkas)
						if ((pc == 0xCA009D) || (pc == 0xCA8CA8) || (tempFlag))
						{
							eventScript = TRUE;
							vehicleScript = FALSE;
							tempFlag = FALSE;
						}

					if(lEnTxt || lEnBytes)
						t.Format("%02X/%04X: %02X        ", (pc & 0xFF0000) >> 16, pc & 0xFFFF, opcode);
					else
						t.Format("Old%06X: DB $%02X ", pc, opcode);

					if (B0Loop)
						t += "    ";
					outFile << t;

					s[15] = "vehicle/entity";

					switch(opcode)
					{

						// Conditionality commands != fun

						case 0xB0:
						file.Read(w, 2);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DL Old%06X-$CA0000 ; If bit A&0x7FFF is set/clear (based on high bit), branch to B", w[0], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(w[0] & 0x8000) s[0] = "is set"; else s[0] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}

						break;

					case 0xB1:
						file.Read(w, 4);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B are set/clear (based on high bits), branch to C", w[0], w[1], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 2; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB2:
						file.Read(w, 6);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C are set/clear (based on high bits), branch to D", w[0], w[1], w[2], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 3; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB3:
						file.Read(w, 8);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D are set/clear (based on high bits), branch to E", w[0], w[1], w[2], w[3], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 4; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB4:
						file.Read(w, 10);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E are set/clear (based on high bits), branch to F", w[0], w[1], w[2], w[3], w[4], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 5; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB5:
						file.Read(w, 12);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E|F are set/clear (based on high bits), branch to G", w[0], w[1], w[2], w[3], w[4], w[5], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 6; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB6:
						file.Read(w, 14);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E|F|G are set/clear (based on high bits), branch to H", w[0], w[1], w[2], w[3], w[4], w[5], w[6], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 7; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB7:
						file.Read(w, 16);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8, w[7]&0x00FF, w[7]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If bit A|B|C|D|E|F|G|H are set/clear (based on high bits), branch to I", w[0], w[1], w[2], w[3], w[4], w[5], w[6], w[7], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 8; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";


							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s) or "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								w[7] & 0x7FFF, (w[7] & 0x7FFF) / 8 + 0x1E80, w[7] & 7, s[7],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB8:
						file.Read(w, 2);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X", w[0]&0x00FF, w[0]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DL Old%06X-$CA0000 ; If bit A&0x7FFF is set/clear (based on high bit), branch to B", w[0], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							if(w[0] & 0x8000) s[0] = "is set"; else s[0] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xB9:
						file.Read(w, 4);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B are set/clear (based on high bits), branch to C", w[0], w[1], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 2; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBA:
						file.Read(w, 6);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C are set/clear (based on high bits), branch to D", w[0], w[1], w[2], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 3; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBB:
						file.Read(w, 8);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D are set/clear (based on high bits), branch to E", w[0], w[1], w[2], w[3], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 4; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBC:
						file.Read(w, 10);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E are set/clear (based on high bits), branch to F", w[0], w[1], w[2], w[3], w[4], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 5; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBD:
						file.Read(w, 12);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F are set/clear (based on high bits), branch to G", w[0], w[1], w[2], w[3], w[4], w[5], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 6; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBE:
						file.Read(w, 14);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F&G are set/clear (based on high bits), branch to H", w[0], w[1], w[2], w[3], w[4], w[5], w[6], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 7; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

					case 0xBF:
						file.Read(w, 16);
						file.Read(d, 3);

						if(lEnBytes)
						{
							t.Format("%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", w[0]&0x00FF, w[0]>>8, w[1]&0x00FF, w[1]>>8, w[2]&0x00FF, w[2]>>8, w[3]&0x00FF, w[3]>>8, w[4]&0x00FF, w[4]>>8, w[5]&0x00FF, w[5]>>8, w[6]&0x00FF, w[6]>>8, w[7]&0x00FF, w[7]>>8);
							outFile << t;
							t.Format("%02X%02X%02X", d[0]&0xFF, (d[0]>>8)&0xFF, (d[0]>>16)&0xFF);
							outFile << t;
						}
						if(lEnXkas)
						{
							t.Format(": DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DW $%04X : DL Old%06X-$CA0000 ; If A&B&C&D&E&F&G&H are set/clear (based on high bits), branch to I", w[0], w[1], w[2], w[3], w[4], w[5], w[6], w[7], d[0] + 0xCA0000);
							outFile << t;
						}
						if(lEnTxt)
						{
							for(b[15] = 0; b[15] < 8; b[15]++)
								if(w[b[15]] & 0x8000) s[b[15]] = "is set"; else s[b[15]] = "is clear";

							t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s) and "
								"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
								w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
								w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
								w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
								w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
								w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
								w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
								w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
								w[7] & 0x7FFF, (w[7] & 0x7FFF) / 8 + 0x1E80, w[7] & 7, s[7],
								d[0] + 0xCA0000);
							if (d[0] == 0x005EB3) t += " (simply returns)";
							outFile << t;
						}
						break;

						case 0xC0:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								if(b[0] == 0x10)
									s[0].Format("Change to mode 7 persepective"); 
								else if (b[0] == 0x20)
									s[0].Format("Allow ship to propel without changing direction facing");
								else
									s[0].Format("Unknown mode change");

								t.Format(": DB $%02X ; Modify vehicle script behavior:  %s", b[0], s[0]);
								outFile << t;
							}
							if(lEnTxt)
							{
								if(b[0] == 0x10)
									s[0].Format("Change mode to mode 7 persepective"); 
								else if (b[0] == 0x20)
									s[0].Format("Allow ship to propel without changing direction facing");
								else
									s[0].Format("Unknown mode change");

								t.Format("Modify vehicle script behavior ($%02X):  %s", b[0], s[0]);
								outFile << t;
							}
							break;

						case 0xC1:
							file.Read(w, 2);
							if(lEnBytes)
							{
								t.Format("%04X", w[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DW $%04X ; Set vehicle's facing direction to A (%d degrees) (0 is north, goes counter-clockwise) ", w[0], w[0]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Set vehicle's facing direction to $%04X (%d degrees) (0 is north, goes counter-clockwise) ", w[0], w[0]);
								outFile << t;
							}
							break;

						case 0xC2:
							file.Read(w, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", w[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DW $%04X ; Set vehicle's propulsion direction to A (%d degrees) (0 is north, goes counter-clockwise) ", w[0], w[0]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Set vehicle's propulsion direction to $%04X (%d degrees) (0 is north, goes counter-clockwise), Note: $C0 $20 is required", w[0], w[0]);
								outFile << t;
							}
							break;

						case 0xC3:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Vehicle script command, params A, B", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Vehicle script command $%02X, $%02X, $%02X", opcode, b[0], b[1]);
								outFile << t;
							}
							break;

						case 0xC4:
							file.Read(w, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", w[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DW $%04X ; Set mode 7 height perspective to A", w[0]);
								outFile << t; 
							}
							if(lEnTxt)
							{
								t.Format("Set mode 7 height perspective to $%04X", w[0]);
								outFile << t;
							}
							break;

						case 0xC5:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Set vehicle height to B (max is $7E), unknown byte A", b[0], b[1]);
								outFile << t; 
							}
							if(lEnTxt)
							{
								t.Format("Set vehicle height to $%02X (max is $7E), (unknown byte $%02X)", b[1], b[0]);
								outFile << t;
							}
							break;

						case 0xC6:
							file.Read(w, 2);
							if(lEnBytes)
							{
								t.Format("%04X", w[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DW $%04X ; Propel vehicle at speed A", w[0]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Propel vehicle at speed $%04X", w[0]);
								outFile << t;
							}
							break;


						case 0xC7:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Place airship at position (A, B)", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Place airship at position (%d, %d)", b[0], b[1]);
								outFile << t;
							}
							break;

						case 0xC8:
							file.Read(w, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DW $%04X ; Set event bit $7E1E80 + A/8 [$%04X, bit %d]", w[0], 0x1E80 + w[0]/8, w[0] & 7);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Set bit $1E80($%04X) [$%04X, bit %d]", w[0], 0x1E80 + ((w[0] & 0xFFF8) >> 3), w[0] & 7);
								outFile << t;
							}
							break;
						case 0xC9:
							file.Read(w, 2);
							if(lEnBytes)
							{
								t.Format("%04X", w[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DW $%04X ; Clear event bit $7E1E80 + A/8 [$%04X, bit %d]", w[0], 0x1E80 + w[0]/8, w[0] & 7);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Clear bit $1E80($%04X) [$%04X, bit %d]", w[0], 0x1E80 + ((w[0] & 0xFFF8) >> 3), w[0] & 7);
								outFile << t;
							}
							break;

						case 0xCA:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Invoke battle, enemy set A, background B&0x3F, other flags on high bits of B", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								b[2] = (b[1] & 0x3F);
								s[0] = g_strBackgroundNames[b[2]];
								t.Format("Invoke battle, enemy set $%02X, background $%02X (%s), other flags $%02X", b[0], b[2], s[0], b[1] - b[2]);
								outFile << t;
							}
							break;

						case 0xCB:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Invoke battle, enemy set A, background B&0x3F, other flags on high bits of B", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								b[2] = (b[1] & 0x3F);
								s[0] = g_strBackgroundNames[b[2]];
								t.Format("Invoke battle, enemy set $%02X, background $%02X (%s), other flags $%02X", b[0], b[2], s[0], b[1] - b[2]);
								outFile << t;
							}
							break;

						case 0xCC:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Invoke battle, enemy set A, background B&0x3F, other flags on high bits of B", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								b[2] = (b[1] & 0x3F);
								s[0] = g_strBackgroundNames[b[2]];
								t.Format("Invoke battle, enemy set $%02X, background $%02X (%s), other flags $%02X", b[0], b[2], s[0], b[1] - b[2]);
								outFile << t;
							}
							break;

						case 0xCD:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Invoke battle, enemy set A, background B&0x3F, other flags on high bits of B", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								b[2] = (b[1] & 0x3F);
								s[0] = g_strBackgroundNames[b[2]];
								t.Format("Invoke battle, enemy set $%02X, background $%02X (%s), other flags $%02X", b[0], b[2], s[0], b[1] - b[2]);
								outFile << t;
							}
							break;

						case 0xCE:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Invoke battle, enemy set A, background B&0x3F, other flags on high bits of B", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								b[2] = (b[1] & 0x3F);
								s[0] = g_strBackgroundNames[b[2]];
								t.Format("Invoke battle, enemy set $%02X, background $%02X (%s), other flags $%02X", b[0], b[2], s[0], b[1] - b[2]);
								outFile << t;
							}
							break;

						case 0xCF:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X ; Invoke battle, enemy set A, background B&0x3F, other flags on high bits of B", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								b[2] = (b[1] & 0x3F);
								s[0] = g_strBackgroundNames[b[2]];
								t.Format("Invoke battle, enemy set $%02X, background $%02X (%s), other flags $%02X", b[0], b[2], s[0], b[1] - b[2]);
								outFile << t;
							}
							break;

						case 0xD0:
							if(lEnXkas)
							{
								outFile << "; Show vehicle";
							}
							if(lEnTxt)
							{
								t.Format("Show vehicle");
								outFile << t;
							}
							break;
						
						case 0xD1:
							if(lEnXkas)
							{
								outFile << "; Hide vehicle";
							}
							if(lEnTxt)
							{
								t.Format("Hide vehicle");
								outFile << t;
							}
							break;

						case 0xD2:
							file.Read(w, 2);
							file.Read(b, 3);
							
						    if ((w[0] & 0x0400) && ((w[0] & 0x01FF) < 0x0002))						
							{
									
								onFoot = FALSE; // maybe?	
								mapScript = TRUE;
								eventScript = FALSE;
								vehicleScript = FALSE;
							}
							else
							{
								vehicleScript = FALSE;
								eventScript = TRUE;
							}
							
							if (((w[0] & 0x01FF) < 0x0002) && (b[2] & 0x40))
							{
								vehicleScript = TRUE;
								eventScript = FALSE;
							}

							if(lEnBytes)
							{
								t.Format("%04X%02X%02X%02X", w[0], b[0], b[1], b[2]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DW $%04X : DB $%02X : DB $%02X : DB $%02X ; Load map A&01FF, position (B,C), flags D", w[0], b[0], b[1], b[2]);
								outFile << t;
							}
							if(lEnTxt)
							{
								s[0] = g_strLocationNames[w[0] & 0x01FF];
								t.Format("Load map $%04X (%s), position (%02d, %02d), mode $%02X", (w[0] & 0x01FF), s[0], b[0], b[1], b[2]);
								outFile << t;
							}
							break;
							
						case 0xD3:
							file.Read(w, 2);
							file.Read(b, 3);
							
							if ((w[0] & 0x0400) && ((w[0] & 0x01FF) < 0x0002))						
							{
									
								onFoot = FALSE; // maybe?	
								mapScript = TRUE;
								eventScript = FALSE;
								vehicleScript = FALSE;
							}
							else
							{
								vehicleScript = FALSE;
								eventScript = TRUE;
							}

							if (((w[0] & 0x01FF) < 0x0002) && (b[2] & 0x40))
							{
								mapScript = TRUE;
								eventScript = FALSE;
							}

							if(lEnBytes)
							{
								
								t.Format("%04X%02X%02X%02X", w[0], b[0], b[1], b[2]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DW $%04X : DB $%02X : DB $%02X : DB $%02X ; Load map A&01FF, position (B,C), flags D", w[0], b[0], b[1], b[2]);
								outFile << t;
							}
							if(lEnTxt)
							{
								s[0] = g_strLocationNames[w[0] & 0x01FF];
								t.Format("Load map $%04X (%s), position (%02d, %02d), mode $%02X", (w[0] & 0x01FF), s[0], b[0], b[1], b[2]);
								outFile << t;
							}
							break;

						case 0xD4:
											
						case 0xD5:
							
						case 0xD6:
							
						case 0xD7:
						
						case 0xD8:
							if(lEnXkas)
							{
								outFile << "; Unfade screen";
							}
							if(lEnTxt)
							{
								outFile << "Unfade screen";
							}
							break;
							
						case 0xD9:
							if(lEnXkas)
							{
								outFile << "; Fade screen";
							}
							if(lEnTxt)
							{
								outFile << "Fade screen";
							}
							break;
							
						case 0xDA:
							if(lEnXkas)
							{
								outFile << "; Show flashing arrows indicating the direction you're turning";
							}
							if(lEnTxt)
							{
								outFile << "Show flashing arrows indicating the direction you're turning";
							}
							break;
							
						case 0xDB:
							if(lEnXkas)
							{
								outFile << "; Latch (lock in) the input for direction turned ($1EB6, bit 7 holds the value)";
							}
							if(lEnTxt)
							{
								outFile << "Latch (lock in) the input for direction turned ($1EB6, bit 7 holds the value)";
							}
							break;

						case 0xDC:
							if(lEnXkas)
							{
								outFile << "; Hide flashing arrows that indicate the direction you're turning";
							}
							if(lEnTxt)
							{
								outFile << "Hide flashing arrows that indicate the direction you're turning";
							}
							break;
						
						case 0xDD:
							if(lEnXkas)
							{
								outFile << "; Hide mini-map";
							}
							if(lEnTxt)
							{
								t.Format("Hide mini-map");
								outFile << t;
							}
							break;

						case 0xDE:
							file.Read(b, 2);
							if(lEnBytes)
							{
								t.Format("%02X%02X", b[0], b[1]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X : DB $%02X; Unknown command, params A and B", b[0], b[1]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Command $%02X, $%02X, $%02X", opcode, b[0], b[1]);
								outFile << t;
							}
							break;

						case 0xDF:
							if(lEnXkas)
							{
								outFile << "; Show mini-map";
							}
							if(lEnTxt)
							{
								t.Format("Show mini-map");
								outFile << t;
							}
							break;

						case 0xE0:
							file.Read(b, 1);
							if(lEnBytes)
							{
								t.Format("%02X", b[0]);
								outFile << t;
							}
							if(lEnXkas)
							{
								t.Format(": DB $%02X ; Pause for A units", b[0]);
								outFile << t;
							}
							if(lEnTxt)
							{
								t.Format("Pause for %d units", b[0]);
								outFile << t;
							}
							break;

						case 0xE1:
							
						case 0xE2:							

						case 0xE3:

						case 0xE4:

						case 0xE5:

						case 0xE6:
						
						case 0xE7:
						
						case 0xE8:
						
						case 0xE9:
						
						case 0xEA:
						
						case 0xEB:
						
						case 0xEC:
						
						case 0xED:
						
						case 0xEE:
						
						case 0xEF:
						
						case 0xF0:
						
						case 0xF1:
						
						case 0xF2:
							if(lEnXkas)
							{
								outFile << "; Unknown vehicle script command";
							}
							if(lEnTxt)
							{
								t.Format("Vehicle script command $%02X", opcode);
								outFile << t;
							}
							break;

						case 0xF3:
							if(lEnXkas)
							{
								outFile << "; Show part of world getting zapped";
							}
							if(lEnTxt)
							{
								t.Format("Show part of world getting zapped");
								outFile << t;
							}
							break;

						case 0xF4:
							if(lEnXkas)
							{
								outFile << "; Change graphic to Falcon";
							}
							if(lEnTxt)
							{
								t.Format("Change graphic to Falcon");
								outFile << t;
							}
							break;

						case 0xF5:
							if(lEnXkas)
							{
								outFile << "; Show part of world getting zapped";
							}
							if(lEnTxt)
							{
								t.Format("Show part of world getting zapped");
								outFile << t;
							}
							break;

						case 0xF6:
							if(lEnXkas)
							{
								outFile << "; Unknown vehicle script command";
							}
							if(lEnTxt)
							{
								t.Format("Vehicle script command $%02X", opcode);
								outFile << t;
							}
							break;

						case 0xF7:
							if(lEnXkas)
							{
								outFile << "; Change graphic to pidgeon";
							}
							if(lEnTxt)
							{
								t.Format("Change graphic to pidgeon");
								outFile << t;
							}
							break;

						case 0xF8:
							if(lEnXkas)
							{
								outFile << "; Show part of world getting blown up";
							}
							if(lEnTxt)
							{
								t.Format("Show part of world getting blown up");
								outFile << t;
							}
							break;
/*
						case 0xF9:
							file.Read(d, 3);
							// I'm not sure if this is right
							t.Format("Branch out of queue to $%06X", d[0] + 0xCA0000);
							characterScript = FALSE;
							outFile << t;
							break;
*/
						case 0xFA:
							//file.Read(b, 1);
							if(lEnXkas)
							{
								outFile << "; Show airship emerging from the ocean";
							}
							if(lEnTxt)
							{
								t.Format("Show airship emerging from the ocean");
								outFile << t;
							}
							break;

						case 0xFB:
							if(lEnXkas)
							{
								outFile << "; Show airship smoking";
							}
							if(lEnTxt)
							{
								t.Format("Show airship smoking");
								outFile << t;
							}
							break;
						
						case 0xFC:
							if(lEnXkas)
							{
								outFile << "; Show airship crashing";
							}
							if(lEnTxt)
							{
								t.Format("Show airship crashing");
								outFile << t;
							}
							break;
						
						case 0xFD:
							if(lEnXkas)
							{
								outFile << "; Change graphic to esper Terra";
							}
							if(lEnTxt)
							{
								t.Format("Change graphic to Esper Terra");
								outFile << t;
							}
							break;
						
						case 0xFE:
							if(lEnXkas)
							{
								outFile << "; Show scene with airship heading to Vector";
							}
							if(lEnTxt)
							{
								t.Format("Show scene with airship heading to Vector");
								outFile << t;
							}
							
							break;

						case 0xFF:
							if(lEnXkas)
							{
								outFile << "; End vehicle script" << endl;
							}
							if(lEnTxt)
							{
								t.Format("End vehicle script");
								outFile << t << endl;
							}
							vehicleScript = FALSE;
							eventScript = TRUE;

							if(!lEnXkas)
							{
								// Special checks for weird (branch begins in vehicle script) events
								if (pc == 0xCA8C57)
								{
									vehicleScript = TRUE;
									eventScript = FALSE;
								}
								else if ((pc == 0xCBD2ED))
								{
									eventScript = FALSE;
									vehicleScript = FALSE;
									mapScript = TRUE;
								}
							}

							break;
					
						default:
							if(lEnXkas)
							{

								if(opcode < 0x80)
								{
									file.Read(b, 1);

									b[1] = opcode;
									s[6] = "go down";
									s[5] = "go up";
									s[4] = "turn left";
									s[3] = "turn right";
									s[2] = "move forward";
									s[1] = "decrease speed by $100";
									s[0] = "double speed of turns";

									x = 6;
									do
									{
										if(b[1] >= (1 << x))
										{
											b[1] -= (1 << x);
											s[7] += s[x];
											if(b[1] != 0)
												s[7] += ", ";
										}
										x--;
									}
									while (b[1] != 0);
									
									t.Format(": DB $%02X ; Move vehicle as follows: (%s), A units", b[0], s[7]);
								}
								else
									t.Format(": DB $%02X ; Undecoded vehicle script command", b[0]);

								outFile << t;
							}
							if(lEnTxt)
							{

								if(opcode < 0x80)
								{
									file.Read(b, 1);

									b[1] = opcode;
									s[6] = "go down";
									s[5] = "go up";
									s[4] = "turn left";
									s[3] = "turn right";
									s[2] = "move forward";
									s[1] = "decrease speed by $100";
									s[0] = "double speed of turns";

									x = 6;
									do
									{
										if(b[1] >= (1 << x))
										{
											b[1] -= (1 << x);
											s[7] += s[x];
											if(b[1] != 0)
												s[7] += ", ";
										}
										x--;
									}
									while (b[1] != 0);
									
									t.Format("Move vehicle as follows: (%s), %d units", s[7], b[0]);
								}
								else
									t.Format("Undecoded vehicle script command--$%02X", opcode);

								outFile << t;
							}
						}// end switch

						outFile << endl;

					}//end while (vehicleScript)

				} // end if..else

	}// end master while loop

	outFile.close();
	file.Close();
}

void readDialogue(CFile* m_pFile, int pointerlocation, int num_of_ptrs)
{
	int original = 0;
	int nCurPos = 0;
	int nPointer, nHeader;
	CString verboseMode ="b";
	BYTE* nRom = 0;
	nRom = new BYTE[m_pFile->GetLength()]; // I'm hoping this will get the length of the file
	nHeader = ((m_pFile->GetLength()) % 0x8000); // detect if our rom has a header or not
	// part of original rom or Pandora's Box, determine where are pointers are
	if(pointerlocation == (0x0CE402 + nHeader)) 
	{
		original = 1;
		printf(_T("Original game detected from dialogue pointer\n"));
	}
	else if(pointerlocation == (0x370000 + nHeader))
	{
		original = 0; // a fail-safe check, just in case
		printf(_T("Pandora's Box detected from dialogue pointer\n"));
	}
	else
	{
		original = -1;
		printf(_T("Error with dialogue pointer (WTF?), expected loc: $%06X\n"), pointerlocation);
		return;
	}
	if(original == 1)
	{
		readDialogue2(m_pFile);
		goto done;
	}

	BYTE bTemp[1024];

	
	
	do
	{
		printf(_T("Prefer verbose mode for dialogue loading (y/n)?"));
		scanf("%s", verboseMode);
		if((verboseMode != "y")&&(verboseMode != "n"))
			printf(_T("\nMust use lowercase y or n. Sorry, no fancy interpretation here.\n"));
	}
	while((verboseMode != "y")&&(verboseMode != "n"));

	int x;
    // num_of_ptrs will either be 3362 or 8192

	DWORD dwBegin = 0, dwEnd = 0, dwLength = 0;

	for(x = 0; x < num_of_ptrs; x++)
	{
		DialogueItem* pDlg = new DialogueItem;
		dialogue.Add(pDlg);
		// nPointer will be the location of the current dialogue string
		// pointerlocation is where to look for dialogue pointers, it should only have one of two values
		// nPointer = nRom[pointerlocation + nHeader + x*3];
		nPointer = pointerlocation + x*3;
		//nCurPos = nPointer;
		int nPos = 0;

		dwBegin = 0;
		dwEnd = 0;
		m_pFile->Seek(nPointer, CFile::begin);
		m_pFile->Read(&dwBegin, 3);
		m_pFile->Read(&dwEnd, 3);
 
		dwLength = dwEnd - dwBegin;
		
		
		if (dwBegin < (0xC00000 + nHeader))
		{
			if(verboseMode == "y")
				printf(_T("Underflow at $%06X, dialogue pointer %d, seeking $%06X\n"), nPointer, x, dwBegin);
		}

		if(dwLength <= 0)
		{
			if(verboseMode == "y")
				printf(_T("Negative or zero-length string at $%06X, index %d; skipping...\n"), nPointer, x);
			break;
		}
		else if(dwLength)
		{
			BYTE bChar;
			m_pFile->Seek(dwBegin - 0xC00000 + nHeader, CFile::begin);
 
			do
			{
				m_pFile->Read(&bChar, 1);
				bTemp[nPos++] = bChar;
			}
			while(bChar != 0x00);
 
			bTemp[nPos++] = 0x00;
		
			pDlg->text = new BYTE[nPos];
			pDlg->length = nPos;
		
		}
		/*	else
		{
			pDlg->text = NULL;
			pDlg->length = 0;
		}
		*/	
		CopyMemory(pDlg->text, bTemp, nPos);
	
		if (verboseMode == "y")
			printf(_T("Successfully read in %d dialogue messages up to $%06X\n"), x, dwBegin); // For debugging purposes		
	}
	int n;
	// Read item data.
	m_pFile->Seek(0x363200 + nHeader, CFile::begin);
	for(n = 0; n < 512; n++)
		m_pFile->Read(items[n].name, 16);
 
	// Read esper data.
	m_pFile->Seek(0x310D10 + nHeader, CFile::begin);
	for(n = 0; n < 27; n++)
		m_pFile->Read(espers[n].name, 10);
 
	// Read character data.
	m_pFile->Seek(0x0478C0 + nHeader, CFile::begin);
	for(n = 0; n < 64; n++)
		m_pFile->Read(characters[n].name, 6);
done:
	if (verboseMode == "y")
		printf(_T("Finished reading in %d dialogue messages\n"), x );

	delete[] nRom;
	nRom = 0;
}



void readDialogue2(CFile* m_pFile)
{
	WORD wPageBound = 0;
	m_pFile->Seek(0xCE800, CFile::begin);
	m_pFile->Read(&wPageBound, 2);
 
	BYTE bTemp[1024];
 
	for(DWORD i = 0xCE802; i < 0xD01FE; i += 2)
	{
		int nPos = 0;
 
		DialogueItem* pDlg = new DialogueItem;
		dialogue.Add(pDlg);
 
		WORD wBegin = 0, wEnd = 0;
		m_pFile->Seek(i, CFile::begin);
		m_pFile->Read(&wBegin, 2);
		m_pFile->Read(&wEnd, 2);
 
		DWORD dwBegin = wBegin, dwEnd = wEnd;
 
		if((i - 0xCE802) / 2 + 1 >= wPageBound) dwEnd += 0x10000;
		if((i - 0xCE802) / 2 >= wPageBound) dwBegin += 0x10000;
 
		DWORD dwLength = dwEnd - dwBegin;
 
		if(dwLength)
		{
			BYTE bChar;
			m_pFile->Seek(dwBegin + 0xD0200, CFile::begin);
			m_pFile->Read(&bChar, 1);
 
			while(bChar)
			{
				bTemp[nPos++] = bChar;
				m_pFile->Read(&bChar, 1);
			}
 
			bTemp[nPos++] = 0x00;
 
			pDlg->text = new BYTE[nPos];
			pDlg->length = nPos;
			CopyMemory(pDlg->text, bTemp, nPos);
		}
		else
		{
			pDlg->text = NULL;
			pDlg->length = 0;
		}
	}
	int n;
	// Read item data.
	m_pFile->Seek(0x12B500, CFile::begin);
	for(n = 0; n < 256; n++)
		m_pFile->Read(items[n].name, 13);
 
	// Read esper data.
	m_pFile->Seek(0x26F8E1, CFile::begin);
	for(n = 0; n < 27; n++)
		m_pFile->Read(espers[n].name, 8);
 
	// Read character data.
	m_pFile->Seek(0x047AC0, CFile::begin);
	for(n = 0; n < 64; n++)
		m_pFile->Read(characters[n].name, 6);
}


CString g_dteTable[] = {
//		0,    1,    2,    3,    4,    5,    6,    7,    8,    9,    A,    B,    C,    D,    E,    F
/* 8 */ "e ", " t", ": ", "th", "t ", "he", "s ", "er", " a", "re", "in", "ou", "d ", " w", " s", "an",
/* 9 */ "o ", " h", " o", "r ", "n ", "at", "to", " i", ", ", "ve", "ng", "ha", " m", "Th", "st", "on",
/* A */ "yo", " b", "me", "y ", "en", "it", "ar", "ll", "ea", "I ", "ed", " f", " y", "hi", "is", "es",
/* B */ "or", "l ", " c", "ne", "'s", "nd", "le", "se", " I", "a ", "te", " l", "pe", "as", "ur", "u ",
/* C */ "al", " p", "g ", "om", " d", "f ", " g", "ow", "rs", "be", "ro", "us", "ri", "wa", "we", "Wh",
/* D */ "et", " r", "nt", "m ", "ma", "I'", "li", "ho", "of", "Yo", "h ", " n", "ee", "de", "so", "gh",
/* E */ "ca", "ra", "n'", "ta", "ut", "el", "! ", "fo", "ti", "We", "lo", "e!", "ld", "no", "ac", "ce",
/* F */ "k ", " u", "oo", "ke", "ay", "w ", "!!", "ag", "il", "ly", "co", ". ", "ch", "go", "ge", "e_"
};

DialogueItem::DialogueItem()
{
}

DialogueItem::~DialogueItem()
{
	if(length != 0 && text) delete text;
}

void DialogueItem::ConvertToASCII(CString& str, DWORD tag, DWORD value, BOOL lEnXkas ... )
{
	DWORD propTag = tag;
	DWORD propValue = value;
	CMap<DWORD, DWORD, DWORD, DWORD> tagColl;

	va_list marker;
	va_start(marker, value);
	while(propTag != TAG_END)
	{
		tagColl[propTag] = propValue;
		propTag = va_arg(marker, DWORD);
		propValue = va_arg(marker, DWORD);
	}
	va_end(marker);

	BOOL bTagFound = FALSE;
	DWORD dwValue = 0;

	DWORD dwMode = 0;
	bTagFound = tagColl.Lookup(DI_ConvertMode, dwValue);
	if(bTagFound)
		dwMode = (DWORD)dwValue;
	else
		return;

	int nOffset = 0;
	bTagFound = tagColl.Lookup(DI_Offset, dwValue);
	if(bTagFound)
		nOffset = (int)dwValue;
	else
		nOffset = 0;

	str.Empty();

	if(text == NULL)
	{
		if(dwMode == DICM_List)
			str = "<Empty>";
		else
			str.Empty();

		return;
	}

	for(int i = nOffset; i < length; i++)
	{		
	    if(text[i] == 0x01 && dwMode == DICM_List) str += "\n               ";
		else if(text[i] == 0x01 && dwMode == DICM_Edit) str += "\n";
		else if(text[i] == 0x13 && dwMode == DICM_List) str += "\n\n             ";
		else if(text[i] == 0x13 && dwMode == DICM_Edit) str += "\n\n";
	
		else if(text[i] >= 0x20 && text[i] <= 0x39) str += (BYTE) (text[i] + 0x21);
		else if(text[i] >= 0x3A && text[i] <= 0x53) str += (BYTE) (text[i] + 0x27);
		else if(text[i] >= 0x54 && text[i] <= 0x5D) str += (BYTE) (text[i] - 0x24);

		else if(text[i] >= 0x80 && text[i] <= 0xFF) str += g_dteTable[text[i] - 0x80];

		else if(text[i] == 0x5E) str += "!";
		else if(text[i] == 0x5F) str += "?";
		else if(text[i] == 0x60) str += "/";
		else if(text[i] == 0x61) str += ":";
		else if(text[i] == 0x62) str += "``";			// $ is the right quote in FF3.FNT
		else if(text[i] == 0x63) str += "'";
		else if(text[i] == 0x64) str += "-";
		else if(text[i] == 0x65) str += ".";
		else if(text[i] == 0x66) str += ",";
		else if(text[i] == 0x67) str += "...";			// _ is the ellipsis
		else if(text[i] == 0x68) str += ";";
		else if(text[i] == 0x69) str += "#";
		else if(text[i] == 0x6A) str += "+";
		else if(text[i] == 0x6B) str += "(";
		else if(text[i] == 0x6C) str += ")";
		else if(text[i] == 0x6D) str += "%";
		else if(text[i] == 0x6E) str += "~";
		else if(text[i] == 0x6F) str += "*";
		else if(text[i] == 0x70) str += "@";
		else if(text[i] == 0x71) str += "<music>";			// & is the musical note
		else if(text[i] == 0x72) str += "=";
		else if(text[i] == 0x73) str += "\"";
		else if(text[i] == 0x7F) str += " ";

		
		else if(text[i] == 0x15) str += "^";			// ^ is the multiple choice indicator
		else if(text[i] == 0x17) str += "<centerEnd>";

		else if(text[i] == 0x19) str += "<N>";
		else if(text[i] == 0x1A) str += "<I>";
		else if(text[i] == 0x1B) str += "<S>";

		else if(text[i] == 0x02 && dwMode == DICM_List) str += "TERRA";
		else if(text[i] == 0x03 && dwMode == DICM_List) str += "LOCKE";
		else if(text[i] == 0x04 && dwMode == DICM_List) str += "CYAN";
		else if(text[i] == 0x05 && dwMode == DICM_List) str += "SHADOW";
		else if(text[i] == 0x06 && dwMode == DICM_List) str += "EDGAR";
		else if(text[i] == 0x07 && dwMode == DICM_List) str += "SABIN";
		else if(text[i] == 0x08 && dwMode == DICM_List) str += "CELES";
		else if(text[i] == 0x09 && dwMode == DICM_List) str += "STRAGO";
		else if(text[i] == 0x0A && dwMode == DICM_List) str += "RELM";
		else if(text[i] == 0x0B && dwMode == DICM_List) str += "SETZER";
		else if(text[i] == 0x0C && dwMode == DICM_List) str += "MOG";
		else if(text[i] == 0x0D && dwMode == DICM_List) str += "GAU";
		else if(text[i] == 0x0E && dwMode == DICM_List) str += "GOGO";
		else if(text[i] == 0x0F && dwMode == DICM_List) str += "UMARO";

		else if(text[i] == 0x02 && dwMode == DICM_Edit) str += "<C 1>";
		else if(text[i] == 0x03 && dwMode == DICM_Edit) str += "<C 2>";
		else if(text[i] == 0x04 && dwMode == DICM_Edit) str += "<C 3>";
		else if(text[i] == 0x05 && dwMode == DICM_Edit) str += "<C 4>";
		else if(text[i] == 0x06 && dwMode == DICM_Edit) str += "<C 5>";
		else if(text[i] == 0x07 && dwMode == DICM_Edit) str += "<C 6>";
		else if(text[i] == 0x08 && dwMode == DICM_Edit) str += "<C 7>";
		else if(text[i] == 0x09 && dwMode == DICM_Edit) str += "<C 8>";
		else if(text[i] == 0x0A && dwMode == DICM_Edit) str += "<C 9>";
		else if(text[i] == 0x0B && dwMode == DICM_Edit) str += "<C 10>";
		else if(text[i] == 0x0C && dwMode == DICM_Edit) str += "<C 11>";
		else if(text[i] == 0x0D && dwMode == DICM_Edit) str += "<C 12>";
		else if(text[i] == 0x0E && dwMode == DICM_Edit) str += "<C 13>";
		else if(text[i] == 0x0F && dwMode == DICM_Edit) str += "<C 14>";

		else if((text[i] == 0x10 || text[i] == 0x12) && dwMode == DICM_List) ;
		else if(text[i] == 0x00) ;

		else if(text[i] == 0x10 && dwMode == DICM_Edit) str += "<D>";

		else if(text[i] == 0x14 && dwMode == DICM_List)
		{
			//i++; // uncomment for FF6
			str += "<center>"; // comment for PB
		}
		else if(text[i] == 0x14 && dwMode == DICM_Edit)
		{
			i++;
			BYTE param = text[i];

			CString t;  t.Format("<T %d>", param);
			str += t;
		}

		else if((text[i] == 0x11 || text[i] == 0x16) && dwMode == DICM_List)
		{
			i++;
			while(text[i] != 0x12)
				i++;			
		}
		else if(text[i] == 0x16 && dwMode == DICM_Edit)
		{
			CString t;
			i++;
			BYTE param = text[i];

			t.Format("<WS %d", param);

			while(text[i] != 0x12)
			{
				str += t;

				i++;
				param = text[i];
				t.Format(", %d", param);
			}

			str += ">";
		}
		else if(text[i] == 0x11 && dwMode == DICM_Edit)
		{
			CString t;
			i++;
			BYTE param = text[i];

			t.Format("<WT %d", param);

			while(text[i] != 0x12)
			{
				str += t;

				i++;
				param = text[i];
				t.Format(", %d", param);
			}

			str += ">";
		}

		else
		{
			CString t;
			t.Format("<%02X>", text[i]);
			str += t;
		}
		
	}
}

CString FixedTextToCString(BYTE* text, int length, DWORD tag, DWORD value, ... )
{
	DWORD propTag = tag;
	DWORD propValue = value;
	CMap<DWORD, DWORD, DWORD, DWORD> tagColl;

	va_list marker;
	va_start(marker, value);
	while(propTag != TAG_END)
	{
		tagColl[propTag] = propValue;
		propTag = va_arg(marker, DWORD);
		propValue = va_arg(marker, DWORD);
	}
	va_end(marker);

	BOOL bTagFound = FALSE;
	DWORD dwValue = 0;

	BOOL bTrim = 0;
	bTagFound = tagColl.Lookup(TTCS_TrimTrailingSpaces, dwValue);
	if(bTagFound)
		bTrim = (BOOL)dwValue;
	else
		bTrim = FALSE;

	CString str;

	for(int i = 0; i < length; i++)
	{
		if(text[i] >= 0x80 && text[i] <= 0x99) str += (BYTE) (text[i] - 0x3F);
		else if(text[i] >= 0x9A && text[i] <= 0xB3) str += (BYTE) (text[i] - 0x39);
		else if(text[i] >= 0xB4 && text[i] <= 0xBD) str += (BYTE) (text[i] - 0x84);

		else if(text[i] == 0xBE) str += "!";
		else if(text[i] == 0xBF) str += "?";
		else if(text[i] == 0xC0) str += "/";
		else if(text[i] == 0xC1) str += ":";
		else if(text[i] == 0xC2) str += "\"";
		else if(text[i] == 0xC3) str += "'";
		else if(text[i] == 0xC4) str += "-";
		else if(text[i] == 0xC5) str += ".";
		else if(text[i] == 0xC6) str += ",";
		else if(text[i] == 0xC7) str += "_";
		else if(text[i] == 0xC8) str += ";";
		else if(text[i] == 0xC9) str += "#";
		else if(text[i] == 0xCA) str += "+";
		else if(text[i] == 0xCB) str += "(";
		else if(text[i] == 0xCC) str += ")";
		else if(text[i] == 0xCD) str += "%";
		else if(text[i] == 0xCE) str += "~";
		else if(text[i] == 0xCF) str += "*";
		else if(text[i] == 0xD2) str += "=";
		else if(text[i] == 0xD3) str += "@";
		else if(text[i] == 0xD7) str += "$";
		else if(text[i] == 0xFE) str += " ";
		else if(text[i] == 0xFF) str += " ";
		else
		{
			CString t;
			t.Format("<%02X>", text[i]);
			str += t;
		}
	}

	return str;
}



int serialise_script(CString iScriptFn, CString iFf6Fn)
{
	CStdioFile inFile;
	if(inFile.Open(iScriptFn, CFile::typeText) == NULL)
	{
		printf(_T("Errors reading %s\n"), iScriptFn);
		return -1;
	}

	CString lScriptFn = iScriptFn;
	CFile outFile;
	if(outFile.Open(iFf6Fn, CFile::modeReadWrite|CFile::typeBinary) == NULL)
	{
		printf(_T("Errors opening %s for writing\n"), iFf6Fn);
		return -1;
	}
	outFile.Seek(SCRIPT_START, CFile::begin);

	CString lFileStr;
	char *lStrPtr;
	char *lDebugPtr;
	int lCnt, lCnt2;
	BYTE lConvByte;
	do
	{
		lFileStr.Empty();
		inFile.ReadString(lFileStr);
		lStrPtr = lFileStr.GetBuffer(0);

		if(lFileStr.GetLength()==0)
			break;

		// eliminates PC
		lCnt = 0;
		while(lStrPtr[lCnt] != ':')
			lCnt++;
		lCnt++;

		// eliminates spaces
		while(lStrPtr[lCnt] == ' ')
			lCnt++;

		// process hex
		lCnt2 = 0;
		lConvByte = 0;
		lDebugPtr = &lStrPtr[lCnt];
		while((lStrPtr[lCnt] != '\n') && (lStrPtr[lCnt] != '\0'))
		{
			if(lCnt2%2)
			{
				lConvByte |= ascii2nibble(lStrPtr[lCnt]);
				outFile.Write(&lConvByte, 1);
				lConvByte = 0;
			}
			else
				lConvByte = ascii2nibble(lStrPtr[lCnt])<<4;

			lCnt2++;
			lCnt++;
		}

	} while (lFileStr.GetLength()!=0);

	outFile.Close();
	inFile.Close();

	return 0;
}

BYTE ascii2nibble(BYTE iAsciiChar)
{
	if(iAsciiChar>='a' && iAsciiChar<='f')
	{
		iAsciiChar -= 'a';
		iAsciiChar += 0xA;
	}
	else if(iAsciiChar>='A' && iAsciiChar<='F')
	{
		iAsciiChar -= 'A';
		iAsciiChar += 0xA;
	}
	else if(iAsciiChar>='0' && iAsciiChar<='9')
	{
		iAsciiChar -= '0';
	}
	else
		iAsciiChar = 0xC;

	return(iAsciiChar);
}


void npcParser(CString iFf6Fn)
{
	CFile file;

	if(file.Open(iFf6Fn, CFile::modeRead) == NULL)
	{
		printf(_T("Errors reading %s\n"), iFf6Fn);
		return;
	}

	ofstream outFile;
	CString lScriptFn = NPC_DATA_FN;
	outFile.open(lScriptFn);
	if(outFile == NULL)
	{
		printf(_T("Errors creating %s\n"), lScriptFn);
		return;
	}

	DWORD pc, dwOffset;
	WORD nHeader = (file.GetLength() % 0x8000);
	CString t;
	BYTE b[16];
	WORD w[16];
	DWORD d[16];
	CString s[16];
	WORD mapID;

	t.Format("NPC Data Text version .97\nby Imzogelmo\n\n");
	outFile << t;
	t.Format("Generated from the ROM, using Yousei's info\n\n");
	outFile << t;
	t.Format("Information on undecoded bits/bytes mostly due to research by Novalia Spirit\n\n");
	outFile << t;
	t.Format("Map descriptions by Corundum\n\n");
	outFile << t;


    for(mapID = 0; mapID < 0x1A0; mapID++)
	{
		pc = NPC_POINTERS + mapID * 9 - nHeader + 0xC00000;
		dwOffset = pc + nHeader - 0xC00000;
		file.Seek(NPC_POINTERS + (mapID * 2), CFile::begin);

		for(int i = 0; i < 16; i++)
		{
			b[i] = w[i] = d[i] = 0;
			s[i].Empty();
		}
		
		file.Read(w, 4);

		int numberOfNPCs = (w[1] - w[0]) / 9;
		
		if (numberOfNPCs != 0)
		{
			
			s[6] = g_strLocationNames[mapID];

			if (s[6][1] == '-')
				s[6] = "<unknown map index>";


			t.Format("Map %03d ($%03X): (%s)\n", mapID, mapID, s[6]);
			outFile << t;
			
			t.Format(("    +---------+--------+---------+-------+---+---------+------+------+------+------+-----+-----+---------+-----+-----+----+----+\n"));
			outFile << t;
			t.Format(("    |  SNES   |  ROM   | Event   |Palette| ? |  Byte:  |Horiz.| Vert.|Graph.|Graph.|Walk |Walk | Vehicle |Fac- |Turn@| ?? | ?? |\n"));
			outFile << t;
			t.Format(("    | address | offset | called  | index |   |   Bit   | pos. | pos. | set  |index |under|over |         |ing  |talk?|    |    |\n"));
			outFile << t;
			t.Format(("    +---------+--------+---------+-------+---+---------+------+------+------+------+-----+-----+---------+-----+-----+----+----+\n"));
			outFile << t;

			for (int i = 0; i < numberOfNPCs; i++)
			{
				
				pc = NPC_POINTERS + w[0] + i * 9 - nHeader + 0xC00000;
				dwOffset = pc - 0xC00000 + nHeader;
				
				file.Seek(dwOffset, CFile::begin);

				file.Read(d, 3);
				file.Read(b, 6);
				
				d[1] = (d[0] & 0x03FFFF) + 0xCA0000;

				s[0] = ((b[4] & 0x10) >> 4) ? "yes" : "no ";
				s[1] = ((b[4] & 0x20) >> 5) ? "yes" : "no ";

				if(((b[4] & 0xC0) >> 6) == 3)
					s[2] = "  raft ";
				else if(((b[4] & 0xC0) >> 6) == 2)
					s[2] = "chocobo";
				else if(((b[4] & 0xC0) >> 6) == 1)
					s[2] = "magitek";
				else if(((b[4] & 0xC0) >> 6) == 0)
					s[2] = "  none ";

				if((b[5] & 0x03) == 0)
					s[4] = "U ";
				else if((b[5] & 0x03) == 1)
					s[4] = "R ";
				else if((b[5] & 0x03) == 2)
					s[4] = "D ";
				else // == 3
					s[4] = "L ";

				s[5] = ((b[5] & 0x04) >> 2) ? "no " : "yes";

				/* aaaa aaaa / aaaa aaaa / bb?p ppaa / BBBB BBBb / fHHH HHHH / ssVV VVVV / GGGG GGGG / vvUO IIII / !!!* *TFF /
				   a = address (add CA0000) of event called when "talked to" or otherwise activated
				   b = bit that sets presence
				   B = byte that sets presence (add 1EE0)
				   ? = unknown (possibly high bit of palette)
				   p = palette
				   f = flag indicating a non-sprite, thus, event address is gibberish
				   H = horizontal position
				   s = speed (slowest, slow, fast, fastest)
				   V = vertical position
				   G = graphics set
				   I = graphics index
				   O = walk over
				   U = walk under
				   v = vehicle (none, magitek, chocobo, or raft)
				   ! = unknown
				   * = unknown
				   T = turn when spoken to
				   F = facing (as in, which direction: up, right, down, left)                                                    */
			
				t.Format("%02X. |$%02X/%04X |x%06X |$%02X/%04X |   %01d   | %01d | $%04X:%01d |  %02X  |  %02X  |  %02X  |   %01X  | %s | %s | %s |  %s | %s |  %d |  %d |\n", 
					i + 0x10, (pc & 0xFF0000) >> 16, pc & 0x00FFFF, dwOffset, (d[1] & 0xFF0000) >> 16, d[1] & 0x00FFFF, (d[0] & 0x1C0000) >> 18, (d[0] & 0x200000) >> 21,
					(b[0] >> 1) + 0x1EE0, ((d[0] & 0xC00000) >> 22) + ((b[0] & 01) << 2), b[1], b[2], b[3], b[4] & 0x0F, s[0], s[1], s[2], s[4], s[5], (b[5] & 0x18) >> 3, (b[5] & 0xE0) >> 5);
				outFile << t;
			}
			t.Format(("    +---------+--------+---------+-------+---+---------+------+------+------+------+-----+-----+---------+-----+-----+----+----+\n"));
			outFile << t << "\n";
			
		} // end if
             
	}

	outFile.close();
	file.Close();

	return;
}

void triggerParser(CString iFf6Fn)
{
	CFile file;

	if(file.Open(iFf6Fn, CFile::modeRead) == NULL)
	{
		printf(_T("Errors reading %s\n"), iFf6Fn);
		return;
	}

	ofstream outFile;
	CString lScriptFn = TRIGGER_DATA_FN;
	outFile.open(lScriptFn);
	if(outFile == NULL)
	{
		printf(_T("Errors creating %s\n"), lScriptFn);
		return;
	}
	
	DWORD pc, dwOffset;
	WORD nHeader = (file.GetLength() % 0x8000);
	CString t;
	BYTE b[16];
	WORD w[16];
	DWORD d[16];
	CString s[16];
	WORD mapID;

	t.Format("Event Trigger Text, ver. 1.11\nby Imzogelmo\n\n");
	outFile << t;
	t.Format("Generated from the ROM, using Yousei's info\n\n");
	outFile << t;
	t.Format("Map descriptions by Corundum\n\n");
	outFile << t;

    for(mapID = 0; mapID < 0x1A0; mapID++)
	{
		pc = TRIGGER_POINTERS + mapID * 5 - nHeader + 0xC00000;
		dwOffset = pc + nHeader - 0xC00000;
		file.Seek(TRIGGER_POINTERS + (mapID * 2), CFile::begin);

		for(int i = 0; i < 16; i++)
		{
			b[i] = w[i] = d[i] = 0;
			s[i].Empty();
		}
		
		file.Read(w, 4);

		int numberOfTriggers = (w[1] - w[0]) / 5;
		
		if (numberOfTriggers != 0)
		{
	
			s[6] = g_strLocationNames[mapID];

			if (s[6][1] == '-')
				s[6] = "<unknown map index>";


			t.Format("Map %03d ($%03X): (%s)\n", mapID, mapID, s[6]);
			outFile << t;

			t.Format(("    +----------+---------+------+------+----------+\n"));
			outFile << t;
			t.Format(("    |  SNES    |   ROM   |Horiz.| Vert.|  Event   |\n"));
			outFile << t;
			t.Format(("    | Address  |  Offset | pos. | pos. |  called  |\n"));
			outFile << t;
			t.Format(("    +----------+---------+------+------+----------+\n"));
			outFile << t;

			for (int i = 0; i < numberOfTriggers; i++)
			{
				
				pc = TRIGGER_POINTERS + w[0] + i * 5 - nHeader + 0xC00000;
				dwOffset = pc - 0xC00000 + nHeader;
				
				file.Seek(dwOffset, CFile::begin);

				file.Read(b, 2);
				file.Read(d, 3);
				
				//d[1] = (d[0] & 0x03FFFF) + 0xCA0000;
				d[1] = d[0] + 0xCA0000;

				t.Format("%02X. | $%02X/%04X | x%06X |  %02X  |  %02X  | $%02X/%04X |\n",
					i, (pc & 0xFF0000) >> 16, pc & 0x00FFFF, dwOffset, b[0], b[1], (d[1] & 0xFF0000) >> 16, d[1] & 0x00FFFF);
				outFile << t;
			}

			t.Format("    +----------+---------+------+------+----------+\n\n");
			outFile << t;
		}

	}
	outFile.close();
	file.Close();

	return;
}

void chestParser(CString iFf6Fn)
{
	CFile file;

	if(file.Open(iFf6Fn, CFile::modeRead) == NULL)
	{
		printf(_T("Errors reading %s\n"), iFf6Fn);
		return;
	}

	ofstream outFile;
	CString lScriptFn = CHEST_DATA_FN;
	outFile.open(lScriptFn);
	if(outFile == NULL)
	{
		printf(_T("Errors creating %s\n"), lScriptFn);
		return;
	}
	
	DWORD pc, dwOffset;
	WORD nHeader = (file.GetLength() % 0x8000);
	CString t;
	BYTE b[16];
	WORD w[16];
	DWORD d[16];
	CString s[16];
	WORD mapID;

	//get the item names from the ROM
	//readDialogue(&file, 0x0CE602, 3362); // Use for original
	readDialogue(&file, 0x370000 + nHeader, 8192); // Use for Pandora's Box 

	t.Format("Chest Data Text, ver. .90\nby Imzogelmo\n\n");
	outFile << t;
	t.Format("Map descriptions by Corundum\n\n");
	outFile << t;

    for(mapID = 0; mapID < 0x1A0; mapID++)
	{
		pc = CHEST_POINTERS + mapID * 5 - nHeader + 0xC00000;
		dwOffset = pc + nHeader - 0xC00000;
		file.Seek(CHEST_POINTERS + (mapID * 2), CFile::begin);

		for(int i = 0; i < 16; i++)
		{
			b[i] = w[i] = d[i] = 0;
			s[i].Empty();
		}

		file.Read(w, 4);

		int numberOfChests = (w[1] - w[0]) / 5;
		
		if (numberOfChests != 0)
		{
			
			s[6] = g_strLocationNames[mapID];

			if (s[6][1] == '-')
				s[6] = "<unknown map index>";

			t.Format("Map %03d ($%03X): (%s)\n", mapID, mapID, s[6]);
			outFile << t;

			t.Format(("    +----------+---------+------+------+----------+------+--------------------+\n"));
			outFile << t;
			t.Format(("    |  SNES    |   ROM   |Horiz.| Vert.| Encoding | Type | Contents           |\n"));
			outFile << t;
			t.Format(("    | Address  |  Offset | pos. | pos. |[byte:bit]|      |                    |\n"));
			outFile << t;
			t.Format(("    +----------+---------+------+------+----------+------+--------------------+\n"));
			outFile << t;

			for (int i = 0; i < numberOfChests; i++)
			{
				
				pc = CHEST_START + w[0] + i * 5 - nHeader + 0xC00000;
				dwOffset = pc - 0xC00000 + nHeader;
				
				file.Seek(dwOffset, CFile::begin);

				file.Read(b, 5);

				b[5] = (b[2] & 0xF8) >> 3;
				if (b[3] & 0x01)
					b[5] += 32;
				
				b[3] = (b[3] & 0xE0) >> 4;

				if (b[3] > 4)
				{
					s[0].Format(" Gold");
					w[4] = b[4] * 100;
					s[1].Format("%d GP", w[4]);
				}
				else if (b[3] > 2)
				{
					s[0].Format(" Item");
					s[1].Format("%s", FixedTextToCString(items[b[4]].name, 13, TAG_END, 0)); 
				}
				else if (b[3] > 1)
				{
					s[0].Format(" MiaB");
					s[1].Format(" 2-Pack # %d", b[4]);
				}
				else
				{	
					s[0].Format("Empty");
					s[1].Format(" N/A");
				}


				t.Format("%02X. | $%02X/%04X | x%06X |  %02X  |  %02X  | [$%04X:%1X]|%s | %s %*s\n",
					i, (pc & 0xFF0000) >> 16, pc & 0x00FFFF, dwOffset, b[0], b[1], 0x1e40 + b[5], b[2] & 0x07, s[0], s[1], 19 - strlen(s[1]), "|" );
				outFile << t;
			}

			t.Format(("    +----------+---------+------+------+----------+------+--------------------+\n\n"));
			outFile << t;
		}

	}
	outFile.close();
	file.Close();

	return;
}

void locationParser(CString iFf6Fn)
{
	CFile file;

	if(file.Open(iFf6Fn, CFile::modeRead) == NULL)
	{
		printf(_T("Errors reading %s\n"), iFf6Fn);
		return;
	}

	ofstream outFile;
	CString lScriptFn = LOCATION_FN;
	outFile.open(lScriptFn);
	if(outFile == NULL)
	{
		printf(_T("Errors creating %s\n"), lScriptFn);
		return;
	}
	
	DWORD pc, dwOffset;
	WORD nHeader = (file.GetLength() % 0x8000);
	CString t;
	BYTE b[33];
	//WORD w[16];
	//DWORD d[16];
	//CString s[16];
	WORD mapID;

	t.Format("Location Data Text, ver. .30\nby Imzogelmo\n\n");
	outFile << t;
	t.Format("Generated from the ROM, using Yousei's info\n\n");
	outFile << t;
	t.Format("Map descriptions by Corundum\n\n");
	outFile << t;

	for(mapID = 0; mapID < 0x1A0; mapID++)
	{
		pc = LOCATION_START + mapID * 33 - nHeader + 0xC00000;
		dwOffset = pc - 0xC00000 + nHeader;
				
		file.Seek(dwOffset, CFile::begin);

		file.Read(b, 33);

		t.Format("%03d. %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X", mapID, b[0], b[1], b[2], b[3], b[4], b[5], b[6], b[7], b[8], b[9], b[10], b[11], b[12], b[13], 
			b[14], b[15], b[16], b[17], b[18], b[19], b[20], b[21], b[22], b[23], b[24], b[25], b[26], b[27], b[28], b[29], b[30], b[31], b[32]);
		outFile << t << endl;
	}
	outFile.close();
	file.Close();

	return;
}

void mapEventParser(CString iFf6Fn)
{
	CFile file;

	if(file.Open(iFf6Fn, CFile::modeRead) == NULL)
	{
		printf(_T("Errors reading %s\n"), iFf6Fn);
		return;
	}

	ofstream outFile;
	CString lScriptFn = MAP_EVENT_FN;
	outFile.open(lScriptFn);
	if(outFile == NULL)
	{
		printf(_T("Errors creating %s\n"), lScriptFn);
		return;
	}

	DWORD pc, dwOffset;
	WORD nHeader = (file.GetLength() % 0x8000);
	CString t;
	DWORD d[1];
	CString s[16];
	WORD mapID;

	t.Format("Map Event Pointers, ver. 0.15\nby Imzogelmo\n\n");
	outFile << t;
	t.Format("Generated from the ROM\n\n");
	outFile << t;
	t.Format("Map descriptions by Corundum\n\n");
	outFile << t;

	for(mapID = 0; mapID <= 0x1FF; mapID++)
	{
		pc = MAP_EVENT_POINTERS + mapID * 3 - nHeader + 0xC00000;
		dwOffset = pc - 0xC00000 + nHeader;
        
		d[0] = 0L;

		file.Seek(dwOffset, CFile::begin);

		file.Read(d, 3);

		s[0] = g_strLocationNames[mapID];

		if (s[0][1] == '-')
			s[0] = "<unknown map index>";
		
		if (mapID > 0x19F)
			s[0] = "<invalid or out-of-range map index>";

		t.Format("Map %03d ($%03X): (%s)\n", mapID, mapID, s[0]);
		outFile << t;

		t.Format("Address: %06X     Pointer Value: %06X \n\n", pc, d[0]+0xCA0000);
		outFile << t;

	}
	outFile.close();
	file.Close();
	
	return;
}

void xkasEventPointers(CString iFf6Fn)
{
	CFile file;

	if(file.Open(iFf6Fn, CFile::modeRead) == NULL)
	{
		printf(_T("Errors reading %s\n"), iFf6Fn);
		return;
	}

	ofstream outFile;
	CString lScriptFn = XKAS_EVENT_PTR;
	outFile.open(lScriptFn);
	if(outFile == NULL)
	{
		printf(_T("Errors creating %s\n"), lScriptFn);
		return;
	}

	DWORD pc = 0, dwOffset = 0;
	WORD nHeader = (file.GetLength() % 0x8000);
	CString t;
	BYTE b[16];
	WORD w[16];
	DWORD d[16];
	CString s[16];
	WORD mapID;

	t.Format(";Xkas Event Pointers, ver. 0.15\n;by Imzogelmo\n\n");
	outFile << t;
	t.Format(";Generated from the ROM\n\n");
	outFile << t;
	t.Format(";Map descriptions by Corundum\n\n");
	outFile << t;

	DWORD mapStart = 0xD1FA00;
	DWORD npcStart = 0xCE0000;
	DWORD triggerStart = 0xC40000;
    
	//First do the map pointers, as they're easy...
	printf(_T("Enter map pointer start address (FF3us = D1FA00, PB = D1FA00): "));
	scanf("%X", &mapStart);
	

	for(mapID = 0; mapID <= 0x19F; mapID++)
	{	
		d[0] = 0L;
		pc = mapStart + mapID * 3;
		dwOffset = pc - 0xC00000 + nHeader;		
		file.Seek(dwOffset, CFile::begin);

		file.Read(d, 3);
		//printf(_T("Output is at %06X [$%06X]\n"), pc, dwOffset);
		s[0] = g_strLocationNames[mapID];

		if (s[0][1] == '-')
			s[0] = "<unknown map index>";
		
		if (mapID > 0x19F)
			s[0] = "<invalid or out-of-range map index>";

		t.Format("ORG $%06X : DL Old%06X-$CA0000 ; Map %03d ($%03X) : (%s)\n", pc, d[0]+0xCA0000, mapID, mapID, s[0]);
		outFile << t;

	}

	//Second is the tile triggers, they're next easiest...
	printf(_T("Enter tile trigger pointer start address (FF3us = C40000, PB = C40000): "));
	scanf("%X",&triggerStart);
	

	for(mapID = 0; mapID < 0x1A0; mapID++)
	{
		pc = triggerStart + mapID * 2;
		dwOffset = pc + nHeader - 0xC00000;
		file.Seek(dwOffset, CFile::begin);

		for(int i = 0; i < 16; i++)
		{
			b[i] = w[i] = d[i] = 0;
			s[i].Empty();
		}
		
		file.Read(w, 4);

		int numberOfTriggers = (w[1] - w[0]) / 5;
		
		if (numberOfTriggers != 0)
		{
	
			s[6] = g_strLocationNames[mapID];

			if (s[6][1] == '-')
				s[6] = "<unknown map index>";


			t.Format("; Map %03d ($%03X): (%s)\n", mapID, mapID, s[6]);
			outFile << t;

			for (int i = 0; i < numberOfTriggers; i++)
			{
				
				pc = triggerStart + w[0] + i * 5;
				dwOffset = pc + nHeader - 0xC00000;
				
				file.Seek(dwOffset, CFile::begin);

				file.Read(b, 2);
				file.Read(d, 3);
				
				//d[1] = (d[0] & 0x03FFFF) + 0xCA0000;
				d[1] = d[0] + 0xCA0000;

				t.Format("ORG $%06X : DL Old%06X-$CA0000\n", pc + 2, d[1]);
				outFile << t;
			}
		}
	}

	//Third is the long tile triggers
	printf(_T("Enter long event trigger pointer start address (FF3us = 000000, PB = C44800): "));
	scanf("%X",&triggerStart);
	

	for(mapID = 0; mapID < 0x1A0; mapID++)
	{
		pc = triggerStart + mapID * 2;
		dwOffset = pc + nHeader - 0xC00000;
		file.Seek(dwOffset, CFile::begin);

		for(int i = 0; i < 16; i++)
		{
			b[i] = w[i] = d[i] = 0;
			s[i].Empty();
		}
		
		file.Read(w, 4);

		int numberOfTriggers = (w[1] - w[0]) / 6;
		
		if (numberOfTriggers != 0)
		{
	
			s[6] = g_strLocationNames[mapID];

			if (s[6][1] == '-')
				s[6] = "<unknown map index>";


			t.Format("; Map %03d ($%03X): (%s)\n", mapID, mapID, s[6]);
			outFile << t;

			for (int i = 0; i < numberOfTriggers; i++)
			{
				
				pc = triggerStart + w[0] + i * 6;
				dwOffset = pc + nHeader - 0xC00000;
				
				file.Seek(dwOffset, CFile::begin);

				file.Read(b, 3);
				file.Read(d, 3);
				
				//d[1] = (d[0] & 0x03FFFF) + 0xCA0000;
				d[1] = d[0] + 0xCA0000;

				t.Format("ORG $%06X : DL Old%06X-$CA0000\n", pc + 3, d[1]);
				outFile << t;
			}
		}
	}

	// Last is the NPC triggers, 'cause that's the hardest
	printf(_T("Enter tile trigger pointer start address (FF3us = C41A10, PB = CE0000): "));
	scanf("%X",&npcStart);
	
	int numberOfNPCs;

	for(mapID = 0; mapID < 0x1A0; mapID++)
	{
		pc = npcStart + mapID * 2;
		dwOffset = pc + nHeader - 0xC00000;
		file.Seek(dwOffset, CFile::begin);

		for(int i = 0; i < 16; i++)
		{
			b[i] = w[i] = d[i] = 0;
			s[i].Empty();
		}
		
		file.Read(w, 4);

		numberOfNPCs = (w[1] - w[0]) / 9;
		
		if (numberOfNPCs != 0)
		{
			
			s[6] = g_strLocationNames[mapID];

			if (s[6][1] == '-')
				s[6] = "<unknown map index>";


			t.Format("; Map %03d ($%03X): (%s)\n", mapID, mapID, s[6]);
			outFile << t;

			for (int i = 0; i < numberOfNPCs; i++)
			{					
				pc = npcStart + w[0] + i * 9;
				dwOffset = pc - 0xC00000 + nHeader;
				
				file.Seek(dwOffset, CFile::begin);

				file.Read(d, 3);
				file.Read(b, 6);
				
				d[1] = (d[0] & 0x03FFFF) + 0xCA0000;

				if((b[1] & 0x80) && ((b[4] & 0xC0) == 0))
					t.Format("; Address $%06X, Event Old%06X-$CA0000|$%06X Event Not a sprite, address needs to remain unchanged: NPC %d\n", pc, d[1], (d[0]&0xFC0000), i+1);
				else		
					t.Format("ORG $%06X : DL Old%06X-$CA0000|$%06X ; NPC %d\n", pc, d[1], (d[0]&0xFC0000), i+1);
				outFile << t;
			}							
		} // end if	             
	}

	outFile.close();
	file.Close();
	
	return;
}
